Package: bridgesampling
Type: Package
Title: Bridge Sampling for Marginal Likelihoods and Bayes Factors
Version: 1.2-1
Authors@R: c(person(given="Quentin F.", family="Gronau", role=c("aut", "cre"),
             email="Quentin.F.Gronau@gmail.com",
             comment=c(ORCID="0000-0001-5510-6943")),
             person(given="Henrik", family="Singmann", role="aut",
             comment=c(ORCID="0000-0002-4842-3657")),
             person(given="Jonathan J.", family="Forster", role="ctb"),
             person(given="Eric-Jan", family="Wagenmakers", role="ths"),
             person(family="The JASP Team", role="ctb"),
             person("Jiqiang", "Guo", role = "ctb"),
             person("Jonah", "Gabry", role = "ctb"),
             person("Ben", "Goodrich", role = c("ctb")),
             person("Kees", "Mulder", role = c("ctb")),
             person("Perry", "de Valpine", role = c("ctb")),
             person(given="Aki", family="Vehtari", role = c("ctb")),
             person(given="Giorgio", family="Micaletto", role = c("ctb"))
             )
Depends: R (>= 3.0.0)
Imports: mvtnorm, Matrix, Brobdingnag, stringr, coda, parallel, scales,
        utils, methods
Suggests: testthat, Rcpp, RcppEigen, R2jags, rjags, runjags, knitr,
        rmarkdown, R.rsp, BayesFactor, rstan, rstanarm, nimble,
        MCMCpack, cmdstanr (>= 0.6.0)
Description: Provides functions for estimating marginal likelihoods, Bayes
    factors, posterior model probabilities, and normalizing constants in general,
    via different versions of bridge sampling (Meng & Wong, 1996, 
    <https://www3.stat.sinica.edu.tw/statistica/j6n4/j6n43/j6n43.htm>).
    Gronau, Singmann, & Wagenmakers (2020) <doi:10.18637/jss.v092.i10>.
Additional_repositories: https://stan-dev.r-universe.dev/
License: GPL (>= 2)
LazyData: true
RoxygenNote: 7.3.3
Encoding: UTF-8
VignetteBuilder: knitr, R.rsp
URL: https://github.com/quentingronau/bridgesampling
NeedsCompilation: no
Packaged: 2025-11-18 11:10:07 UTC; singmann
Author: Quentin F. Gronau [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-5510-6943>),
  Henrik Singmann [aut] (ORCID: <https://orcid.org/0000-0002-4842-3657>),
  Jonathan J. Forster [ctb],
  Eric-Jan Wagenmakers [ths],
  The JASP Team [ctb],
  Jiqiang Guo [ctb],
  Jonah Gabry [ctb],
  Ben Goodrich [ctb],
  Kees Mulder [ctb],
  Perry de Valpine [ctb],
  Aki Vehtari [ctb],
  Giorgio Micaletto [ctb]
Maintainer: Quentin F. Gronau <Quentin.F.Gronau@gmail.com>
Repository: CRAN
Date/Publication: 2025-11-19 06:10:42 UTC

## -----------------------------------------------------------------------------
library(bridgesampling)

### generate data ###
set.seed(12345)

mu <- 0
tau2 <- 0.5
sigma2 <- 1

n <- 20
theta <- rnorm(n, mu, sqrt(tau2))
y <- rnorm(n, theta, sqrt(sigma2))
  

## ----eval=FALSE---------------------------------------------------------------
# ### set prior parameters ###
# mu0 <- 0
# tau20 <- 1
# alpha <- 1
# beta <- 1

## ----eval=FALSE---------------------------------------------------------------
# library(rstan)
# 
# # models
# stancodeH0 <- 'data {
#   int<lower=1> n; // number of observations
#   vector[n] y; // observations
#   real<lower=0> alpha;
#   real<lower=0> beta;
#   real<lower=0> sigma2;
# }
# parameters {
#   real<lower=0> tau2; // group-level variance
#   vector[n] theta; // participant effects
# }
# model {
#   target += inv_gamma_lpdf(tau2 | alpha, beta);
#   target += normal_lpdf(theta | 0, sqrt(tau2));
#   target += normal_lpdf(y | theta, sqrt(sigma2));
# }
# '
# stancodeH1 <- 'data {
#   int<lower=1> n; // number of observations
#   vector[n] y; // observations
#   real mu0;
#   real<lower=0> tau20;
#   real<lower=0> alpha;
#   real<lower=0> beta;
#   real<lower=0> sigma2;
# }
# parameters {
#   real mu;
#   real<lower=0> tau2; // group-level variance
#   vector[n] theta; // participant effects
# }
# model {
#   target += normal_lpdf(mu | mu0, sqrt(tau20));
#   target += inv_gamma_lpdf(tau2 | alpha, beta);
#   target += normal_lpdf(theta | mu, sqrt(tau2));
#   target += normal_lpdf(y | theta, sqrt(sigma2));
# }
# '
# # compile models
# stanmodelH0 <- stan_model(model_code = stancodeH0, model_name="stanmodel")
# stanmodelH1 <- stan_model(model_code = stancodeH1, model_name="stanmodel")

## ----eval=FALSE---------------------------------------------------------------
# # fit models
# stanfitH0 <- sampling(stanmodelH0, data = list(y = y, n = n,
#                                                alpha = alpha,
#                                                beta = beta,
#                                                sigma2 = sigma2),
#                       iter = 50000, warmup = 1000, chains = 3, cores = 1)
# stanfitH1 <- sampling(stanmodelH1, data = list(y = y, n = n,
#                                                mu0 = mu0,
#                                                tau20 = tau20,
#                                                alpha = alpha,
#                                                beta = beta,
#                                                sigma2 = sigma2),
#                       iter = 50000, warmup = 1000, chains = 3, cores = 1)

## ----echo=FALSE---------------------------------------------------------------
load(system.file("extdata/", "vignette_example_stan.RData",
                     package = "bridgesampling"))

## ----eval=FALSE---------------------------------------------------------------
# # compute log marginal likelihood via bridge sampling for H0
# H0.bridge <- bridge_sampler(stanfitH0, silent = TRUE)
# 
# # compute log marginal likelihood via bridge sampling for H1
# H1.bridge <- bridge_sampler(stanfitH1, silent = TRUE)

## -----------------------------------------------------------------------------
print(H0.bridge)
print(H1.bridge)

## ----eval=FALSE---------------------------------------------------------------
# # compute percentage errors
# H0.error <- error_measures(H0.bridge)$percentage
# H1.error <- error_measures(H1.bridge)$percentage

## -----------------------------------------------------------------------------
print(H0.error)
print(H1.error)

## -----------------------------------------------------------------------------
# compute Bayes factor
BF01 <- bf(H0.bridge, H1.bridge)
print(BF01)

## -----------------------------------------------------------------------------
# compute posterior model probabilities (assuming equal prior model probabilities)
post1 <- post_prob(H0.bridge, H1.bridge)
print(post1)

## -----------------------------------------------------------------------------
# compute posterior model probabilities (using user-specified prior model probabilities)
post2 <- post_prob(H0.bridge, H1.bridge, prior_prob = c(.6, .4))
print(post2)

## -----------------------------------------------------------------------------
library(bridgesampling)

### generate data ###
set.seed(12345)

mu <- 0
tau2 <- 0.5
sigma2 <- 1

n <- 20
theta <- rnorm(n, mu, sqrt(tau2))
y <- rnorm(n, theta, sqrt(sigma2))
  

## ----eval=FALSE---------------------------------------------------------------
# ### set prior parameters ###
# mu0 <- 0
# tau20 <- 1
# alpha <- 1
# beta <- 1

## ----eval=FALSE---------------------------------------------------------------
# library("nimble")
# 
# # models
# codeH0 <- nimbleCode({
#   invTau2 ~ dgamma(1, 1)
#   tau2 <- 1/invTau2
#   for (i in 1:20) {
#     theta[i] ~ dnorm(0, sd = sqrt(tau2))
#     y[i] ~ dnorm(theta[i], sd = 1)
#   }
# })
# codeH1 <- nimbleCode({
#   mu ~ dnorm(0, sd = 1)
#   invTau2 ~ dgamma(1, 1)
#   tau2 <- 1/invTau2
#   for (i in 1:20) {
#     theta[i] ~ dnorm(mu, sd = sqrt(tau2))
#     y[i] ~ dnorm(theta[i], sd = 1)
#   }
# })
# 
# ## steps for H0:
# modelH0 <- nimbleModel(codeH0)
# modelH0$setData(y = y) # set data
# cmodelH0 <- compileNimble(modelH0) # make compiled version from generated C++
# 
# ## steps for H1:
# modelH1 <- nimbleModel(codeH1)
# modelH1$setData(y = y) # set data
# cmodelH1 <- compileNimble(modelH1) # make compiled version from generated C++
# 

## ----eval=FALSE---------------------------------------------------------------
# 
# # build MCMC functions, skipping customization of the configuration.
# mcmcH0 <- buildMCMC(modelH0,
#                     monitors = modelH0$getNodeNames(stochOnly = TRUE,
#                                                     includeData = FALSE))
# mcmcH1 <- buildMCMC(modelH1,
#                     monitors = modelH1$getNodeNames(stochOnly = TRUE,
#                                                     includeData = FALSE))
# # compile the MCMC function via generated C++
# cmcmcH0 <- compileNimble(mcmcH0, project = modelH0)
# cmcmcH1 <- compileNimble(mcmcH1, project = modelH1)
# 
# # run the MCMC.  This is a wrapper for cmcmc$run() and extraction of samples.
# # the object samplesH1 is actually not needed as the samples are also in cmcmcH1
# samplesH0 <- runMCMC(cmcmcH0, niter = 1e5, nburnin = 1000, nchains = 2,
#                      progressBar = FALSE)
# samplesH1 <- runMCMC(cmcmcH1, niter = 1e5, nburnin = 1000, nchains = 2,
#                      progressBar = FALSE)

## ----echo=FALSE---------------------------------------------------------------
load(system.file("extdata/", "vignette_example_nimble.RData",
                     package = "bridgesampling"))

## ----eval=FALSE---------------------------------------------------------------
# # compute log marginal likelihood via bridge sampling for H0
# H0.bridge <- bridge_sampler(cmcmcH0, silent = TRUE)
# 
# # compute log marginal likelihood via bridge sampling for H1
# H1.bridge <- bridge_sampler(cmcmcH1, silent = TRUE)

## -----------------------------------------------------------------------------
print(H0.bridge)
print(H1.bridge)

## ----eval=FALSE---------------------------------------------------------------
# # compute percentage errors
# H0.error <- error_measures(H0.bridge)$percentage
# H1.error <- error_measures(H1.bridge)$percentage

## -----------------------------------------------------------------------------
print(H0.error)
print(H1.error)

## -----------------------------------------------------------------------------
# compute Bayes factor
BF01 <- bf(H0.bridge, H1.bridge)
print(BF01)

## -----------------------------------------------------------------------------
# compute posterior model probabilities (assuming equal prior model probabilities)
post1 <- post_prob(H0.bridge, H1.bridge)
print(post1)

## -----------------------------------------------------------------------------
# compute posterior model probabilities (using user-specified prior model probabilities)
post2 <- post_prob(H0.bridge, H1.bridge, prior_prob = c(.6, .4))
print(post2)

#'Computes log marginal likelihood via bridge sampling.
#'@title Log Marginal Likelihood via Bridge Sampling
#'@name bridge_sampler
#'@param samples an \code{mcmc.list} object, a fitted \code{stanfit} object, a
#'  \code{stanreg} object, an \code{rjags} object, a \code{runjags} object, or a
#'  \code{matrix} with posterior samples (\code{colnames} need to correspond to
#'  parameter names in \code{lb} and \code{ub})  with posterior samples.
#'@param log_posterior function or name of function that takes a parameter
#'  vector and the \code{data} as input and returns the log of the unnormalized
#'  posterior density (i.e., a scalar value). If the function name is passed,
#'  the function should exist in the \code{.GlobalEnv}. For special behavior if
#'  \code{cores > 1} see \code{Details}.
#'@param ... additional arguments passed to \code{log_posterior}. Ignored for
#'  the \code{stanfit} and \code{stanreg} methods.
#'@param data data object which is used in \code{log_posterior}.
#'@param stanfit_model for the \code{stanfit} method, an additional object of
#'  class \code{"stanfit"} with the same model as \code{samples}, which will be
#'  used for evaluating the \code{log_posterior} (i.e., it does not need to
#'  contain any samples). The default is to use \code{samples}. In case
#'  \code{samples} was compiled in a different R session or on another computer
#'  with a different OS or setup, the \code{samples} model usually cannot be
#'  used for evaluation. In this case, one can compile the model on the current
#'  computer with \code{iter = 0} and pass it here (this usually needs to be
#'  done before \code{samples} is loaded).
#'@param lb named vector with lower bounds for parameters.
#'@param ub named vector with upper bounds for parameters.
#'@param repetitions number of repetitions.
#'@param method either \code{"normal"} or \code{"warp3"}.
#'@param cores number of cores used for evaluating \code{log_posterior}. On
#'  unix-like systems (where \code{.Platform$OS.type == "unix"} evaluates to
#'  \code{TRUE}; e.g., Linux and Mac OS) forking via \code{\link{mclapply}} is
#'  used. Hence elements needed for evaluation should be in the
#'  \code{\link{.GlobalEnv}}. For other systems (e.g., Windows)
#'  \code{\link{makeCluster}} is used and further arguments specified below will
#'  be used.
#'@param use_neff Logical. If \code{TRUE}, the effective sample size (compared
#'  to the nominal sample size) is used in the optimal bridge function and in
#'  the iterative scheme's uncertainty calculations (making MCSE computation
#'  take into account autocorrelation in MCMC samples). Default is TRUE. If
#'  FALSE, the nominal sample size  is used instead. If \code{samples} is a
#'  \code{matrix}, it is assumed that the \code{matrix} contains the samples of
#'  one chain in order. If \code{samples} come from more than one chain, we
#'  recommend to use an \code{mcmc.list} object for optimal performance.
#'@param packages character vector with names of packages needed for evaluating
#'  \code{log_posterior} in parallel (only relevant if \code{cores > 1} and
#'  \code{.Platform$OS.type != "unix"}).
#'@param varlist character vector with names of variables needed for evaluating
#'  \code{log_posterior} (only needed if \code{cores > 1}  and
#'  \code{.Platform$OS.type != "unix"} as these objects will be exported to the
#'  nodes). These objects need to exist in \code{envir}.
#'@param envir specifies the environment for \code{varlist} (only needed if
#'  \code{cores > 1}  and \code{.Platform$OS.type != "unix"} as these objects
#'  will be exported to the nodes). Default is \code{\link{.GlobalEnv}}.
#'@param rcppFile in case \code{cores > 1} and \code{log_posterior} is an
#'  \code{Rcpp} function, \code{rcppFile} specifies the path to the cpp file
#'  (will be compiled on all cores).
#'@param maxiter maximum number of iterations for the iterative updating scheme.
#'  Default is 1,000 to avoid infinite loops.
#'@param param_types character vector of length \code{ncol(samples)} with
#'  \code{"real"}, \code{"simplex"} or \code{"circular"}. For all regular
#'  bounded or unbounded continuous parameters, this should just be
#'  \code{"real"}. However, if there are parameters which lie on a simplex or on
#'  the circle, this should be noted here. Simplex parameters are parameters
#'  which are bounded below by zero and collectively sum to one, such as weights
#'  in a mixture model. For these, the stick-breaking transformation is
#'  performed as described in the Stan reference manual. The circular variables
#'  are given a numerical representation to which the normal distribution is
#'  most likely a good fit. Only possible to use with
#'  \code{bridge_sampler.matrix}.
#'@param silent Boolean which determines whether to print the number of
#'  iterations of the updating scheme to the console. Default is FALSE.
#'@param verbose Boolean. Should internal debug information be printed to
#'  console? Default is \code{FALSE}.
#'@details Bridge sampling is implemented as described in Meng and Wong (1996,
#'  see equation 4.1) using the "optimal" bridge function. When \code{method =
#'  "normal"}, the proposal distribution is a multivariate normal distribution
#'  with mean vector equal to the sample mean vector of \code{samples} and
#'  covariance matrix equal to the sample covariance matrix of \code{samples}.
#'  For a recent tutorial on bridge sampling, see Gronau et al. (in press).
#'
#'  When \code{method = "warp3"}, the proposal distribution is a standard
#'  multivariate normal distribution and the posterior distribution is "warped"
#'  (Meng & Schilling, 2002) so that it has the same mean vector, covariance
#'  matrix, and skew as the samples. \code{method = "warp3"} takes approximately
#'  twice as long as \code{method = "normal"}.
#'
#'  Note that for the \code{matrix} method, the lower and upper bound of a
#'  parameter cannot be a function of the bounds of another parameter.
#'  Furthermore, constraints that depend on multiple parameters of the model are
#'  not supported. This usually excludes, for example, parameters that
#'  constitute a covariance matrix or sets of parameters that need to sum to
#'  one.
#'
#'  However, if the retransformations are part of the model itself and the
#'  \code{log_posterior} accepts parameters on the real line and performs the
#'  appropriate Jacobian adjustments, such as done for \code{stanfit} and
#'  \code{stanreg} objects, such constraints are obviously possible (i.e., we
#'  currently do not know of any parameter supported within Stan that does not
#'  work with the current implementation through a \code{stanfit} object).
#'
#'  \subsection{Parallel Computation}{ On unix-like systems forking is used via
#'  \code{\link{mclapply}}. Hence elements needed for evaluation of
#'  \code{log_posterior} should be in the \code{\link{.GlobalEnv}}.
#'
#'  On other OSes (e.g., Windows), things can get more complicated. For normal
#'  parallel computation, the \code{log_posterior} function can be passed as
#'  both function and function name. If the latter, it needs to exist in the
#'  environment specified in the \code{envir} argument. For parallel computation
#'  when using an \code{Rcpp} function, \code{log_posterior} can only be passed
#'  as the function name (i.e., character). This function needs to result from
#'  calling \code{sourceCpp} on the file specified in \code{rcppFile}.
#'
#'  Due to the way \code{rstan} currently works, parallel computations with
#'  \code{stanfit} and \code{stanreg} objects only work with forking (i.e., NOT
#'  on Windows). }
#'@return If \code{repetitions = 1}, returns a list of class \code{"bridge"}
#'  with components:
#'  \itemize{
#'    \item \code{logml}: estimate of the log marginal likelihood.
#'    \item \code{niter}: number of iterations of the iterative
#'          updating scheme.
#'    \item \code{method}: bridge sampling method that was used
#'          to obtain the estimate.
#'    \item \code{q11}: log posterior evaluations for posterior samples.
#'    \item \code{q12}: log proposal evaluations for posterior samples.
#'    \item \code{q21}: log posterior evaluations for samples from the proposal.
#'    \item \code{q22}: log proposal evaluations for samples from the proposal.
#'    \item \code{mcse_logml}: Monte Carlo standard error of \code{logml}
#'          on the log-scale (Micaletto & Vehtari, 2025).
#'  }
#'  If \code{repetitions > 1}, returns a list of class \code{"bridge_list"}
#'  with components:
#'  \itemize{
#'    \item \code{logml}: numeric vector of log marginal likelihood estimates.
#'    \item \code{niter}: numeric vector with the number of iterations of the
#'          iterative updating scheme for each repetition.
#'    \item \code{method}: bridge sampling method that was used to obtain
#'          the estimates.
#'    \item \code{repetitions}: number of repetitions.
#'    \item \code{mcse_logml}: numeric vector of Monte Carlo standard errors
#'          on the log-scale (Micaletto & Vehtari, 2025), one per repetition.
#' }
#'@section Warning: Note that the results depend strongly on the parameter
#'  priors. Therefore, it is strongly advised to think carefully about the
#'  priors before calculating marginal likelihoods. For example, the prior
#'  choices implemented in \pkg{rstanarm} or \pkg{brms} might not be optimal
#'  from a testing point of view. We recommend to use priors that have been
#'  chosen from a testing and not a purely estimation perspective.
#'
#'  Also note that for testing, the number of posterior samples usually needs to
#'  be substantially larger than for estimation.
#'@note To be able to use a \code{stanreg} object for \code{samples}, the user
#'  crucially needs to have specified the \code{diagnostic_file} when fitting
#'  the model in \pkg{rstanarm}.
#'@author Quentin F. Gronau and Henrik Singmann. Parallel computing (i.e.,
#'  \code{cores > 1}) and the \code{stanfit} method use code from \code{rstan}
#'  by Jiaqing Guo, Jonah Gabry, and Ben Goodrich. Ben Goodrich added the
#'  \code{stanreg} method. Kees Mulder added methods for simplex and circular
#'  variables. Giorgio Micaletto and Aki Vehtari added the \code{CmdStanMCMC} method (for \code{cmdstanr}) and calculation of the Monte Carlo Standard Error (MCSE).
#'@references
#'  Gronau, Q. F., Singmann, H., & Wagenmakers, E.-J. (2020). bridgesampling: An
#'  R Package for Estimating Normalizing Constants. \emph{Journal of Statistical
#'  Software, 92}. \doi{10.18637/jss.v092.i10}
#'
#'  Gronau, Q. F., Sarafoglou, A., Matzke, D., Ly, A., Boehm, U.,
#'  Marsman, M., Leslie, D. S., Forster, J. J., Wagenmakers, E.-J., &
#'  Steingroever, H. (in press). A tutorial on bridge sampling. \emph{Journal of
#'  Mathematical Psychology}. \url{https://arxiv.org/abs/1703.05984} \cr
#'  \code{vignette("bridgesampling_tutorial")}
#'
#'  Gronau, Q. F., Wagenmakers, E.-J., Heck, D. W., & Matzke, D. (2019). A
#'  Simple Method for Comparing Complex Models: Bayesian Model Comparison for
#'  Hierarchical Multinomial Processing Tree Models Using Warp-III Bridge
#'  Sampling. \emph{Psychometrika}, 84(1), 261–284.
#'  \doi{10.1007/s11336-018-9648-3}
#'
#'  Meng, X.-L., & Wong, W. H. (1996). Simulating ratios of normalizing
#'  constants via a simple identity: A theoretical exploration. \emph{Statistica
#'  Sinica, 6}, 831-860.
#'  \url{https://www3.stat.sinica.edu.tw/statistica/j6n4/j6n43/j6n43.htm}
#'
#'  Meng, X.-L., & Schilling, S. (2002). Warp bridge sampling. \emph{Journal of
#'  Computational and Graphical Statistics, 11(3)}, 552-586.
#'  \doi{10.1198/106186002457}
#'
#'  Micaletto, G., & Vehtari, A. (2025). Monte Carlo standard errors for bridge
#'  sampling marginal likelihood estimation. \emph{arXiv preprint},
#'  arXiv:2508.14487. \url{https://arxiv.org/abs/2508.14487}
#'
#'  Overstall, A. M., & Forster, J. J. (2010). Default Bayesian model
#'  determination methods for generalised linear mixed models.
#'  \emph{Computational Statistics & Data Analysis, 54}, 3269-3288.
#'  \doi{10.1016/j.csda.2010.03.008}
#'@example examples/example.bridge_sampler.R
#'
#'@seealso \code{\link{bf}} allows the user to calculate Bayes factors and
#'  \code{\link{post_prob}} allows the user to calculate posterior model
#'  probabilities from bridge sampling estimates. \code{\link{bridge-methods}}
#'  lists some additional methods that automatically invoke the
#'  \code{\link{error_measures}} function.
#'
#'@importFrom mvtnorm rmvnorm dmvnorm
#'@importFrom Matrix nearPD
#'@import Brobdingnag
#'@importFrom stringr str_sub
#'@importFrom stats qnorm pnorm dnorm median cov var
#'@export
bridge_sampler <- function(samples, ...) {
  UseMethod("bridge_sampler", samples)
}

#' @rdname bridge_sampler
#' @export
bridge_sampler.CmdStanMCMC <- function(
  samples = NULL,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  maxiter = 1000,
  silent = FALSE,
  verbose = FALSE,
  ...
) {
  draws <- samples$unconstrain_draws(format = "matrix")
  parameters <- colnames(draws)
  lb <- rep(-Inf, length(parameters))
  ub <- rep(Inf, length(parameters))
  names(lb) <- names(ub) <- parameters
  bridge_out <- bridge_sampler.matrix(
    samples = draws,
    ...,
    maxiter = maxiter,
    silent = silent,
    lb = lb,
    ub = ub,
    repetitions = repetitions,
    method = method,
    log_posterior = .cmdstan_log_posterior,
    cores = cores,
    data = samples,
    use_neff = use_neff,
    verbose = verbose
  )

  return(bridge_out)
}

#' @rdname bridge_sampler
#' @export
bridge_sampler.stanfit <- function(
  samples = NULL,
  stanfit_model = samples,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  maxiter = 1000,
  silent = FALSE,
  verbose = FALSE,
  ...
) {
  # cores > 1 only for unix:
  if (!(.Platform$OS.type == "unix") & (cores != 1)) {
    warning(
      "cores > 1 only possible on Unix/MacOs. Uses 'core = 1' instead.",
      call. = FALSE
    )
    cores <- 1L
  }

  # convert samples into matrix
  if (!requireNamespace("rstan")) {
    stop("package rstan required")
  }
  ex <- rstan::extract(samples, permuted = FALSE)
  skeleton <- .create_skeleton(
    samples@sim$pars_oi,
    samples@par_dims[samples@sim$pars_oi]
  )
  upars <- apply(ex, 1:2, FUN = function(theta) {
    rstan::unconstrain_pars(stanfit_model, .rstan_relist(theta, skeleton))
  })

  if (length(dim(upars)) == 2) {
    # for one parameter models
    dim(upars) <- c(1, dim(upars))
  }

  nr <- dim(upars)[2]
  samples4fit_index <- seq_len(nr) %in% seq_len(round(nr / 2)) # split samples in two parts
  samples_4_fit <- apply(upars[, samples4fit_index, , drop = FALSE], 1, rbind)

  samples_4_iter_stan <- upars[, !samples4fit_index, , drop = FALSE]
  samples_4_iter_tmp <- vector("list", dim(upars)[3])
  for (i in seq_along(samples_4_iter_tmp)) {
    samples_4_iter_tmp[[i]] <- coda::as.mcmc(t(samples_4_iter_stan[,, i]))
  }
  samples_4_iter_tmp <- coda::as.mcmc.list(samples_4_iter_tmp)

  if (use_neff) {
    neff <- tryCatch(
      median(coda::effectiveSize(samples_4_iter_tmp)),
      error = function(e) {
        warning(
          "effective sample size cannot be calculated, has been replaced by number of samples.",
          call. = FALSE
        )
        return(NULL)
      }
    )
  } else {
    neff <- NULL
  }

  samples_4_iter <- apply(samples_4_iter_stan, 1, rbind)

  parameters <- paste0("x", (seq_len(dim(upars)[1])))

  transTypes <- rep("unbounded", length(parameters))
  names(transTypes) <- parameters

  # prepare lb and ub
  lb <- rep(-Inf, length(parameters))
  ub <- rep(Inf, length(parameters))
  names(lb) <- names(ub) <- parameters

  colnames(samples_4_iter) <- paste0("trans_", parameters)
  colnames(samples_4_fit) <- paste0("trans_", parameters)

  # run bridge sampling
  if (cores == 1) {
    bridge_output <- do.call(
      what = paste0(".bridge.sampler.", method),
      args = list(
        samples_4_fit = samples_4_fit,
        samples_4_iter = samples_4_iter,
        neff = neff,
        use_ess = use_neff,
        log_posterior = .stan_log_posterior,
        data = list(stanfit = stanfit_model),
        lb = lb,
        ub = ub,
        param_types = rep("real", ncol(samples_4_fit)),
        transTypes = transTypes,
        repetitions = repetitions,
        cores = cores,
        packages = "rstan",
        maxiter = maxiter,
        silent = silent,
        verbose = verbose,
        r0 = 0.5,
        tol1 = 1e-10,
        tol2 = 1e-4
      )
    )
  } else {
    bridge_output <- do.call(
      what = paste0(".bridge.sampler.", method),
      args = list(
        samples_4_fit = samples_4_fit,
        samples_4_iter = samples_4_iter,
        neff = neff,
        use_ess = use_neff,
        log_posterior = .stan_log_posterior,
        data = list(stanfit = stanfit_model),
        lb = lb,
        ub = ub,
        param_types = rep("real", ncol(samples_4_fit)),
        transTypes = transTypes,
        repetitions = repetitions,
        varlist = "stanfit",
        envir = sys.frame(sys.nframe()),
        cores = cores,
        packages = "rstan",
        maxiter = maxiter,
        silent = silent,
        verbose = verbose,
        r0 = 0.5,
        tol1 = 1e-10,
        tol2 = 1e-4
      )
    )
  }

  return(bridge_output)
}

#' @rdname bridge_sampler
#' @export
bridge_sampler.mcmc.list <- function(
  samples = NULL,
  log_posterior = NULL,
  ...,
  data = NULL,
  lb = NULL,
  ub = NULL,
  repetitions = 1,
  param_types = rep("real", ncol(samples[[1]])),
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  packages = NULL,
  varlist = NULL,
  envir = .GlobalEnv,
  rcppFile = NULL,
  maxiter = 1000,
  silent = FALSE,
  verbose = FALSE
) {
  # split samples in two parts
  nr <- nrow(samples[[1]])
  samples4fit_index <- seq_len(nr) %in% seq_len(round(nr / 2))
  samples_4_fit_tmp <- samples[samples4fit_index, , drop = FALSE]
  samples_4_fit_tmp <- do.call("rbind", samples_4_fit_tmp)

  # check lb and ub
  if (!is.numeric(lb)) {
    stop("lb needs to be numeric", call. = FALSE)
  }
  if (!is.numeric(ub)) {
    stop("ub needs to be numeric", call. = FALSE)
  }
  if (!all(colnames(samples_4_fit_tmp) %in% names(lb))) {
    stop("lb does not contain all parameters.", call. = FALSE)
  }
  if (!all(colnames(samples_4_fit_tmp) %in% names(ub))) {
    stop("ub does not contain all parameters.", call. = FALSE)
  }

  # transform parameters to real line
  tmp <- .transform2Real(samples_4_fit_tmp, lb, ub)
  samples_4_fit <- tmp$theta_t
  transTypes <- tmp$transTypes
  samples_4_iter_tmp <- lapply(
    samples[!samples4fit_index, , drop = FALSE],
    function(x) .transform2Real(x, lb = lb, ub = ub)$theta_t
  )

  # compute effective sample size
  if (use_neff) {
    samples_4_iter_tmp <- coda::mcmc.list(lapply(
      samples_4_iter_tmp,
      coda::mcmc
    ))
    neff <- tryCatch(
      median(coda::effectiveSize(samples_4_iter_tmp)),
      error = function(e) {
        warning(
          "effective sample size cannot be calculated, has been replaced by number of samples.",
          call. = FALSE
        )
        return(NULL)
      }
    )
  } else {
    neff <- NULL
  }

  # convert to matrix
  samples_4_iter <- do.call("rbind", samples_4_iter_tmp)

  # run bridge sampling
  out <- do.call(
    what = paste0(".bridge.sampler.", method),
    args = list(
      samples_4_fit = samples_4_fit,
      samples_4_iter = samples_4_iter,
      neff = neff,
      use_ess = use_neff,
      log_posterior = log_posterior,
      "..." = ...,
      data = data,
      lb = lb,
      ub = ub,
      transTypes = transTypes,
      repetitions = repetitions,
      cores = cores,
      packages = packages,
      varlist = varlist,
      envir = envir,
      param_types = param_types,
      rcppFile = rcppFile,
      maxiter = maxiter,
      silent = silent,
      verbose = verbose,
      r0 = 0.5,
      tol1 = 1e-10,
      tol2 = 1e-4
    )
  )

  return(out)
}

#' @rdname bridge_sampler
#' @export
bridge_sampler.mcmc <- function(
  samples = NULL,
  log_posterior = NULL,
  ...,
  data = NULL,
  lb = NULL,
  ub = NULL,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  packages = NULL,
  varlist = NULL,
  envir = .GlobalEnv,
  rcppFile = NULL,
  maxiter = 1000,
  param_types = rep("real", ncol(samples)),
  silent = FALSE,
  verbose = FALSE
) {
  samples <- as.matrix(samples)
  bridge_output <- bridge_sampler(
    samples = samples,
    log_posterior = log_posterior,
    ...,
    data = data,
    lb = lb,
    ub = ub,
    repetitions = repetitions,
    method = method,
    cores = cores,
    use_neff = use_neff,
    packages = packages,
    varlist = varlist,
    envir = envir,
    rcppFile = rcppFile,
    maxiter = maxiter,
    param_types = param_types,
    silent = silent,
    verbose = verbose
  )
  return(bridge_output)
}

#' @export
#' @rdname bridge_sampler
bridge_sampler.matrix <- function(
  samples = NULL,
  log_posterior = NULL,
  ...,
  data = NULL,
  lb = NULL,
  ub = NULL,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  packages = NULL,
  varlist = NULL,
  envir = .GlobalEnv,
  rcppFile = NULL,
  maxiter = 1000,
  param_types = rep("real", ncol(samples)),
  silent = FALSE,
  verbose = FALSE
) {
  # see Meng & Wong (1996), equation 4.1

  # Check simplex computation
  is_simplex_param <- param_types == "simplex"
  if (any(is_simplex_param)) {
    simplex_samples <- samples[, is_simplex_param]

    if (any(!(round(rowSums(simplex_samples), 6) == 1L))) {
      stop(paste(
        "Simplex parameters do not sum to one. This could be due to
               having multiple separate sets of simplex parameters, which are
               not supported. "
      ))
    }

    # Remove the last simplex variable because it is superfluous.
    last_sim <- which(is_simplex_param)[sum(is_simplex_param)]
    samples <- samples[, -last_sim, drop = FALSE]
    param_types <- param_types[-last_sim]
    lb <- lb[-last_sim]
    ub <- ub[-last_sim]
  }

  # transform parameters to real line
  tmp <- .transform2Real(samples, lb, ub, theta_types = param_types)
  theta_t <- tmp$theta_t
  transTypes <- tmp$transTypes

  # split samples for proposal/iterative scheme
  nr <- nrow(samples)
  samples4fit_index <- seq_len(nr) %in% seq_len(round(nr / 2)) # split samples in two parts
  samples_4_fit <- theta_t[samples4fit_index, , drop = FALSE]
  samples_4_iter <- theta_t[!samples4fit_index, , drop = FALSE]

  # compute effective sample size
  if (use_neff) {
    neff <- tryCatch(
      median(coda::effectiveSize(coda::mcmc(samples_4_iter))),
      error = function(e) {
        warning(
          "effective sample size cannot be calculated, has been replaced by number of samples.",
          call. = FALSE
        )
        return(NULL)
      }
    )
  } else {
    neff <- NULL
  }

  out <- do.call(
    what = paste0(".bridge.sampler.", method),
    args = list(
      samples_4_fit = samples_4_fit,
      samples_4_iter = samples_4_iter,
      neff = neff,
      use_ess = use_neff,
      log_posterior = log_posterior,
      "..." = ...,
      data = data,
      lb = lb,
      ub = ub,
      transTypes = transTypes,
      param_types = param_types,
      repetitions = repetitions,
      cores = cores,
      packages = packages,
      varlist = varlist,
      envir = envir,
      rcppFile = rcppFile,
      maxiter = maxiter,
      silent = silent,
      verbose = verbose,
      r0 = 0.5,
      tol1 = 1e-10,
      tol2 = 1e-4
    )
  )
  return(out)
}

#' @rdname bridge_sampler
#' @export
#' @importFrom utils read.csv
bridge_sampler.stanreg <-
  function(
    samples,
    repetitions = 1,
    method = "normal",
    cores = 1,
    use_neff = TRUE,
    maxiter = 1000,
    silent = FALSE,
    verbose = FALSE,
    ...
  ) {
    df <- eval(samples$call$diagnostic_file)
    if (is.null(df)) {
      stop(
        "the 'diagnostic_file' option must be specified in the call to ",
        samples$stan_function,
        " to use the 'bridge_sampler'"
      )
    }
    sf <- samples$stanfit
    chains <- ncol(sf)
    if (chains > 1) {
      df <- sapply(1:chains, FUN = function(j) {
        sub("\\.csv$", paste0("_", j, ".csv"), df)
      })
    }
    samples_list <- lapply(df, FUN = function(f) {
      d <- read.csv(f, comment.char = "#")
      excl <- c(
        "lp__",
        "accept_stat__",
        "stepsize__",
        "treedepth__",
        "n_leapfrog__",
        "divergent__",
        "energy__"
      )
      d <- d[, !(colnames(d) %in% excl), drop = FALSE]
      coda::as.mcmc(as.matrix(d[, 1:rstan::get_num_upars(sf), drop = FALSE]))
    })
    samples <- coda::as.mcmc.list(samples_list)
    lb <- rep(-Inf, ncol(samples[[1]]))
    ub <- rep(Inf, ncol(samples[[1]]))
    names(lb) <- names(ub) <- colnames(samples[[1]])

    # cores > 1 only for unix:
    if (!(.Platform$OS.type == "unix") & (cores != 1)) {
      warning(
        "cores > 1 only possible on Unix/MacOs. Uses 'core = 1' instead.",
        call. = FALSE
      )
      cores <- 1L
    }

    if (cores == 1) {
      bridge_output <- bridge_sampler(
        samples = samples,
        log_posterior = .stan_log_posterior,
        data = list(stanfit = sf),
        lb = lb,
        ub = ub,
        repetitions = repetitions,
        method = method,
        cores = cores,
        use_neff = use_neff,
        packages = "rstan",
        maxiter = maxiter,
        silent = silent,
        verbose = verbose
      )
    } else {
      bridge_output <- bridge_sampler(
        samples = samples,
        log_posterior = .stan_log_posterior,
        data = list(stanfit = sf),
        lb = lb,
        ub = ub,
        repetitions = repetitions,
        varlist = "stanfit",
        envir = sys.frame(sys.nframe()),
        method = method,
        cores = cores,
        use_neff = use_neff,
        packages = "rstan",
        maxiter = maxiter,
        silent = silent,
        verbose = verbose
      )
    }
    return(bridge_output)
  }

#' @rdname bridge_sampler
#' @export
bridge_sampler.rjags <- function(
  samples = NULL,
  log_posterior = NULL,
  ...,
  data = NULL,
  lb = NULL,
  ub = NULL,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  packages = NULL,
  varlist = NULL,
  envir = .GlobalEnv,
  rcppFile = NULL,
  maxiter = 1000,
  silent = FALSE,
  verbose = FALSE
) {
  # convert to mcmc.list
  samples <- coda::as.mcmc(samples)
  cn <- coda::varnames(samples)
  samples <- samples[, cn != "deviance", drop = FALSE]

  # run bridge sampling
  out <- bridge_sampler(
    samples = samples,
    log_posterior = log_posterior,
    ...,
    data = data,
    lb = lb,
    ub = ub,
    repetitions = repetitions,
    method = method,
    cores = cores,
    use_neff = use_neff,
    packages = packages,
    varlist = varlist,
    envir = envir,
    rcppFile = rcppFile,
    maxiter = maxiter,
    silent = silent,
    verbose = verbose
  )

  return(out)
}

#' @rdname bridge_sampler
#' @export
bridge_sampler.runjags <- function(
  samples = NULL,
  log_posterior = NULL,
  ...,
  data = NULL,
  lb = NULL,
  ub = NULL,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  packages = NULL,
  varlist = NULL,
  envir = .GlobalEnv,
  rcppFile = NULL,
  maxiter = 1000,
  silent = FALSE,
  verbose = FALSE
) {
  # convert to mcmc.list
  samples <- coda::as.mcmc.list(samples)

  # run bridge sampling
  out <- bridge_sampler(
    samples = samples,
    log_posterior = log_posterior,
    ...,
    data = data,
    lb = lb,
    ub = ub,
    repetitions = repetitions,
    method = method,
    cores = cores,
    use_neff = use_neff,
    packages = packages,
    varlist = varlist,
    envir = envir,
    rcppFile = rcppFile,
    maxiter = maxiter,
    silent = silent,
    verbose = verbose
  )

  return(out)
}

#' @rdname bridge_sampler
#' @export
bridge_sampler.MCMC_refClass <- function(
  samples,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  maxiter = 1000,
  silent = FALSE,
  verbose = FALSE,
  ...
) {
  if (!requireNamespace("nimble")) {
    stop("package nimble required")
  }

  ## functions for nimble support
  .log_posterior_nimble <- ".log_posterior_nimble <- nimble::nimbleFunction(

    # based on code by Perry de Valpine

    ## setup code is executed in R and specializes an instance
    ## of the nimbleFunction to a particular model or nodes
    setup = function(model, nodes) {
      calcNodes <- model$getDependencies(nodes)
    },
    ## run code is called repeatedly and can be converted into C++
    run = function(sample = double(1)) {
      values(model, nodes) <<- sample
      out <- model$calculate(calcNodes)
      return(out)
      returnType(double(0))
    }
  )"
  eval(parse(text = .log_posterior_nimble)) ## trick for avoiding R CMD check NOTEs
  .nimble_bounds <- function(samples, model, which) {
    if (!(which %in% c("lower", "upper"))) {
      stop('"which" needs to be either "lower" or "upper"\n', call. = FALSE)
    }

    cn <- colnames(samples)
    bounds <- numeric(length(cn))
    names(bounds) <- cn

    for (i in seq_along(cn)) {
      bounds[[cn[i]]] <- model$getBound(cn[i], which)
    }

    return(bounds)
  }

  # cores > 1 only for unix:
  if (!(.Platform$OS.type == "unix") & (cores != 1)) {
    warning(
      "cores > 1 only possible on Unix/MacOs. Uses 'core = 1' instead.",
      call. = FALSE
    )
    cores <- 1L
  }

  mcmc_samples <- as.matrix(samples$mvSamples)

  if (all(is.na(mcmc_samples))) {
    stop(
      "nimble object does not contain samples. Call runMCMC() first.",
      call. = FALSE
    )
  }

  # make sure that samples is a list
  if (is.matrix(mcmc_samples)) {
    # TRUE in case nchains = 1
    mcmc_samples <- list(mcmc_samples)
  }

  # convert samples to mcmc.list
  samples_mcmc <- lapply(mcmc_samples, FUN = coda::as.mcmc)
  samples_mcmc_list <- coda::as.mcmc.list(samples_mcmc)

  ## get model name from MCMC_refClass object
  mod_name <- ls(samples$nimbleProject$models)[1]
  nimble_model <- samples$nimbleProject$models[[mod_name]]

  # compile log_posterior for bridge sampling
  log_posterior_tmp <- .log_posterior_nimble(
    model = nimble_model,
    nodes = colnames(mcmc_samples[[1]])
  )
  suppressMessages(
    clog_posterior <- nimble::compileNimble(
      log_posterior_tmp,
      project = nimble_model
    )
  )

  # wrapper to match required format for log_posterior
  log_posterior <- function(x, data) {
    clog_posterior$run(x)
  }

  out <- bridge_sampler(
    samples = samples_mcmc_list,
    log_posterior = log_posterior,
    ...,
    data = NULL,
    lb = .nimble_bounds(mcmc_samples[[1]], nimble_model, "lower"),
    ub = .nimble_bounds(mcmc_samples[[1]], nimble_model, "upper"),
    repetitions = repetitions,
    method = method,
    cores = cores,
    use_neff = use_neff,
    packages = "nimble",
    maxiter = maxiter,
    silent = silent,
    verbose = verbose
  )

  return(out)
}

context('bridge_sampler.nimble works.')

test_that("nimble support works", {
  testthat::skip_on_cran()
  testthat::skip_on_ci()

  testthat::skip_if_not_installed("nimble")
  if (require(nimble)) {
    set.seed(12345)
    mu <- 0
    tau2 <- 0.5
    sigma2 <- 1
    n <- 20
    theta <- rnorm(n, mu, sqrt(tau2))
    y <- rnorm(n, theta, sqrt(sigma2))
    # create model
    codeH1 <- nimbleCode({
      mu ~ dnorm(0, sd = 1)
      invTau2 ~ dgamma(1, 1)
      tau2 <- 1/invTau2
      for (i in 1:20) {
        theta[i] ~ dnorm(mu, sd = sqrt(tau2))
        y[i] ~ dnorm(theta[i], sd = 1)
      }
    })

    capture.output(suppressMessages({

    modelH1 <- nimbleModel(codeH1)
    modelH1$setData(y = y) # set data

    # make compiled version from generated C++
    cmodelH1 <- compileNimble(modelH1)

    # build an MCMC, skipping customization of the configuration.
    mcmcH1 <- buildMCMC(modelH1,
                        monitors = modelH1$getNodeNames(stochOnly = TRUE,
                                                        includeData = FALSE))
    # compile the MCMC via generated C++
    cmcmcH1 <- compileNimble(mcmcH1, project = modelH1)

    # run the MCMC.  This is a wrapper for cmcmc$run() and extraction of samples.
    # the object samplesH1 is actually not needed as the samples are also in cmcmcH1
    samplesH1 <- runMCMC(cmcmcH1, niter = 1e5, nburnin = 1000, nchains = 2,
                         progressBar = FALSE)
    }))

    # bridge sampling
    bridge_H1 <- bridge_sampler(samples = cmcmcH1,
                                cores = 1,
                                method = "warp3",
                                repetitions = 2, silent = TRUE)

    expect_equal(bridge_H1$logml, rep(-37.7983064265064, 2), tolerance = 0.01)

  }


})

context('bridge_sampler.stanfit works.')


### H0: mu = 0
mH0 <- function(y, sigma2 = 1, alpha = 2, beta = 3, rel.tol = 10^(-10)) {
  n <- length(y)
  mH0integrand <- function(tau2, y, sigma2, alpha, beta) {
    (sigma2 + tau2)^(-n/2) * exp(-(n*mean(y)^2 + (n - 1)*sd(y)^2)/(2*(sigma2 + tau2))) *
      tau2^(-alpha - 1) * exp(-beta/tau2)
  }
  (2*pi)^(-n/2) * beta^alpha/gamma(alpha) * integrate(mH0integrand, 0, Inf, rel.tol = rel.tol,
                                                      y = y, sigma2 = sigma2, alpha = alpha,
                                                      beta = beta)$value
}


test_that("stan_bridge_sampler", {
  testthat::skip_on_os("windows")
  if (require(rstan)) {
    set.seed(12345)

    mu <- 0
    tau2 <- 0.5
    sigma2 <- 1

    n <- 20
    theta <- rnorm(n, mu, sqrt(tau2))
    y <- rnorm(n, theta, sqrt(sigma2))

    ### set prior parameters ###
    mu0 <- 0
    tau20 <- 1
    alpha <- 1
    beta <- 1

    # models
    stancodeH0 <- 'data {
    int<lower=1> n; // number of observations
    vector[n] y; // observations
    real<lower=0> alpha;
    real<lower=0> beta;
    real<lower=0> sigma2;
    }
    parameters {
    real<lower=0> tau2; // group-level variance
    vector[n] theta; // participant effects
    }
    model {
    target += inv_gamma_lpdf(tau2 | alpha, beta);
    target += normal_lpdf(theta | 0, sqrt(tau2));
    target += normal_lpdf(y | theta, sqrt(sigma2));
    }
    '

    # compile models
    stanmodelH0 <- suppressWarnings(
      stan_model(model_code = stancodeH0, model_name="stanmodel")
    )


    # fit models
    stanobjectH0 <- sampling(stanmodelH0, data = list(y = y, n = n,
                                                      alpha = alpha,
                                                      beta = beta,
                                                      sigma2 = sigma2),
                             iter = 3500, warmup = 500, chains = 4,
                             show_messages = FALSE, refresh = 0)
    expect_is(
      H0_bridge_norm <- bridge_sampler(samples = stanobjectH0,
                                       method = "normal",
                                       silent = TRUE)
      , "bridge")

    expect_is(
      H0_bridge_norm_rep <-bridge_sampler(stanobjectH0,
                                          method = "normal",
                                          repetitions = 2, silent = TRUE)
      , "bridge_list")

    expect_is(
      H0_bridge_warp3 <- bridge_sampler(stanobjectH0, method = "warp3",
                                        silent = TRUE)
      , "bridge")

    expect_is(
      H0_bridge_warp3_rep <- bridge_sampler(stanobjectH0, method = "warp3", repetitions = 2, silent = TRUE)
      , "bridge_list")

    expect_equal(
      H0_bridge_norm$logml,
      log(mH0(y = y, sigma2 = sigma2, alpha = alpha, beta = beta)),
      tolerance = 0.1)
    expect_equal(
      H0_bridge_warp3$logml,
      log(mH0(y = y, sigma2 = sigma2, alpha = alpha, beta = beta)),
      tolerance = 0.1)

    expect_equal(
      H0_bridge_norm_rep$logml,
      rep(log(mH0(y = y, sigma2 = sigma2, alpha = alpha, beta = beta)), 2),
      tolerance = 0.1)
    expect_equal(
      H0_bridge_warp3_rep$logml,
      rep(log(mH0(y = y, sigma2 = sigma2, alpha = alpha, beta = beta)), 2),
      tolerance = 0.1)

  }
})


test_that("stan_bridge_sampler in multicore", {
  testthat::skip_on_cran()
  testthat::skip_on_ci()
  testthat::skip_on_os("windows")
  if (require(rstan)) {
    set.seed(12345)

    mu <- 0
    tau2 <- 0.5
    sigma2 <- 1

    n <- 20
    theta <- rnorm(n, mu, sqrt(tau2))
    y <- rnorm(n, theta, sqrt(sigma2))

    ### set prior parameters ###
    mu0 <- 0
    tau20 <- 1
    alpha <- 1
    beta <- 1

    # models
    stancodeH0 <- 'data {
    int<lower=1> n; // number of observations
    vector[n] y; // observations
    real<lower=0> alpha;
    real<lower=0> beta;
    real<lower=0> sigma2;
    }
    parameters {
    real<lower=0> tau2; // group-level variance
    vector[n] theta; // participant effects
    }
    model {
    target += inv_gamma_lpdf(tau2 | alpha, beta);
    target += normal_lpdf(theta | 0, sqrt(tau2));
    target += normal_lpdf(y | theta, sqrt(sigma2));
    }
    '

    # compile models
    stanmodelH0 <- suppressWarnings(
      stan_model(model_code = stancodeH0, model_name="stanmodel")
    )

    # fit models
    stanobjectH0 <- sampling(stanmodelH0, data = list(y = y, n = n,
                                                      alpha = alpha,
                                                      beta = beta,
                                                      sigma2 = sigma2),
                             iter = 2500, warmup = 500, chains = 4,
                             show_messages = FALSE, refresh = 0)
    expect_is(
    H0_bridge_norm <- bridge_sampler(stanobjectH0,
                                     method = "normal",
                                     silent = TRUE, cores = 2)
    , "bridge")

    expect_is(
    H0_bridge_warp3 <- bridge_sampler(stanobjectH0, method = "warp3",
                                      silent = TRUE, cores = 2)
    , "bridge")

    expect_equal(
      H0_bridge_norm$logml,
      log(mH0(y = y, sigma2 = sigma2, alpha = alpha, beta = beta)),
      tolerance = 0.1)
    expect_equal(
      H0_bridge_warp3$logml,
      log(mH0(y = y, sigma2 = sigma2, alpha = alpha, beta = beta)),
      tolerance = 0.1)

  }
})

context('test vignette bridgesampling_example_jags.Rmd')

test_that("bridge sampler yields correct results", {

  testthat::skip_on_cran()
  testthat::skip_on_ci()

  # library(bridgesampling)
  if (require(R2jags)) {

    ### generate data ###
    set.seed(12345)

    mu <- 0
    tau2 <- 0.5
    sigma2 <- 1

    n <- 20
    theta <- rnorm(n, mu, sqrt(tau2))
    y <- rnorm(n, theta, sqrt(sigma2))

    ### set prior parameters ###
    mu0 <- 0
    tau20 <- 1
    alpha <- 1
    beta <- 1

    ### functions to get posterior samples ###

    # H0: mu = 0
    getSamplesModelH0 <- function(data,
                                  niter = 52000,
                                  nburnin = 2000,
                                  nchains = 3) {

      model <- "
      model {
      for (i in 1:n) {
      theta[i] ~ dnorm(0, invTau2)
      y[i] ~ dnorm(theta[i], 1/sigma2)
      }
      invTau2 ~ dgamma(alpha, beta)
      tau2 <- 1/invTau2
      }"

      s <- jags(data, parameters.to.save = c("theta", "invTau2"),
                model.file = textConnection(model),
                n.chains = nchains, n.iter = niter,
                n.burnin = nburnin, n.thin = 1,
                progress.bar = "none", quiet = TRUE)

      return(s)

    }

    # H1: mu != 0
    getSamplesModelH1 <- function(data,
                                  niter = 52000,
                                  nburnin = 2000,
                                  nchains = 3) {

      model <- "
      model {
      for (i in 1:n) {
      theta[i] ~ dnorm(mu, invTau2)
      y[i] ~ dnorm(theta[i], 1/sigma2)
      }
      mu ~ dnorm(mu0, 1/tau20)
      invTau2 ~ dgamma(alpha, beta)
      tau2 <- 1/invTau2
      }"

      s <- jags(data, parameters.to.save = c("theta", "mu", "invTau2"),
                model.file = textConnection(model),
                n.chains = nchains, n.iter = niter,
                n.burnin = nburnin, n.thin = 1,
                progress.bar = "none", quiet = TRUE)

      return(s)

    }

    ### get posterior samples ###

    # create data lists for JAGS
    data_H0 <- list(y = y, n = length(y), alpha = alpha,
                    beta = beta, sigma2 = sigma2)
    data_H1 <- list(y = y, n = length(y), mu0 = mu0,
                    tau20 = tau20, alpha = alpha,
                    beta = beta, sigma2 = sigma2)

    # fit models
    samples_H0 <- getSamplesModelH0(data_H0)
    samples_H1 <- getSamplesModelH1(data_H1)

    ### functions for evaluating the unnormalized posteriors on log scale ###

    log_posterior_H0 <- function(samples.row, data) {

      mu <- 0
      invTau2 <- samples.row[[ "invTau2" ]]
      theta <- samples.row[ paste0("theta[", seq_along(data$y), "]") ]

      sum(dnorm(data$y, theta, data$sigma2, log = TRUE)) +
        sum(dnorm(theta, mu, 1/sqrt(invTau2), log = TRUE)) +
        dgamma(invTau2, data$alpha, data$beta, log = TRUE)

    }

    log_posterior_H1 <- function(samples.row, data) {

      mu <- samples.row[[ "mu" ]]
      invTau2 <- samples.row[[ "invTau2" ]]
      theta <- samples.row[ paste0("theta[", seq_along(data$y), "]") ]

      sum(dnorm(data$y, theta, data$sigma2, log = TRUE)) +
        sum(dnorm(theta, mu, 1/sqrt(invTau2), log = TRUE)) +
        dnorm(mu, data$mu0, sqrt(data$tau20), log = TRUE) +
        dgamma(invTau2, data$alpha, data$beta, log = TRUE)

    }

    # specify parameter bounds H0
    cn <- colnames(samples_H0$BUGSoutput$sims.matrix)
    cn <- cn[cn != "deviance"]
    lb_H0 <- rep(-Inf, length(cn))
    ub_H0 <- rep(Inf, length(cn))
    names(lb_H0) <- names(ub_H0) <- cn
    lb_H0[[ "invTau2" ]] <- 0

    # specify parameter bounds H1
    cn <- colnames(samples_H1$BUGSoutput$sims.matrix)
    cn <- cn[cn != "deviance"]
    lb_H1 <- rep(-Inf, length(cn))
    ub_H1 <- rep(Inf, length(cn))
    names(lb_H1) <- names(ub_H1) <- cn
    lb_H1[[ "invTau2" ]] <- 0

    # compute log marginal likelihood via bridge sampling for H0
    H0.bridge <- bridge_sampler(samples = samples_H0, data = data_H0,
                                log_posterior = log_posterior_H0, lb = lb_H0,
                                ub = ub_H0, silent = TRUE)

    # compute log marginal likelihood via bridge sampling for H1
    H1.bridge <- bridge_sampler(samples = samples_H1, data = data_H1,
                                log_posterior = log_posterior_H1, lb = lb_H1,
                                ub = ub_H1, silent = TRUE)

    # compute percentage errors
    H0.error <- error_measures(H0.bridge)$percentage
    H1.error <- error_measures(H1.bridge)$percentage

    # compute Bayes factor
    BF01 <- bf(H0.bridge, H1.bridge)

    # compute posterior model probabilities (assuming equal prior model probabilities)
    post1 <- post_prob(H0.bridge, H1.bridge)

    # compute posterior model probabilities (using user-specified prior model probabilities)
    post2 <- post_prob(H0.bridge, H1.bridge, prior_prob = c(.6, .4))

    # "exact" ml H1
    mH1 <- function(data, rel.tol = 1e-10) {

      y <- data$y
      n <- data$n
      mu0 <- data$mu0
      tau20 <- data$tau20
      alpha <- data$alpha
      beta <- data$beta
      sigma2 <- data$sigma2

      mH1integrand <- function(tau2, y, sigma2, mu0, tau20, alpha, beta) {

        (sigma2 + tau2)^(-n/2) *
          exp(-1/2 * ((n*mean(y)^2 + (n - 1)*sd(y)^2)/(sigma2 + tau2) +
                        mu0^2/tau20 - ((n*mean(y))/(sigma2 + tau2) +
                                         mu0/tau20)^2 /
                        (n/(sigma2 + tau2) + 1/tau20))) *
          (n/(sigma2 + tau2) + 1/tau20)^(-1/2) * tau2^(-alpha - 1) *
          exp(-beta/tau2)

      }

      (2*pi)^(-n/2) * (tau20)^(-1/2) * beta^alpha/gamma(alpha) *
        integrate(mH1integrand, 0, Inf,
                  rel.tol = rel.tol, y = y,
                  sigma2 = sigma2, mu0 = mu0,
                  tau20 = tau20, alpha = alpha,
                  beta = beta)$value

    }

    exact_logmlH1 <- log(mH1(data_H1))

    # "exact" ml H1
    mH0 <- function(data, rel.tol = 1e-10) {

      y <- data$y
      n <- data$n
      alpha <- data$alpha
      beta <- data$beta
      sigma2 <- data$sigma2

      mH0integrand <- function(tau2, y, sigma2, alpha, beta) {

        n <- length(y)

        (sigma2 + tau2)^(-n/2) * exp(-(n*mean(y)^2 + (n - 1)*sd(y)^2)/
                                       (2*(sigma2 + tau2))) *
          tau2^(-alpha - 1) * exp(-beta/tau2)

      }

      (2*pi)^(-n/2) * beta^alpha/gamma(alpha) *
        integrate(mH0integrand, 0, Inf, rel.tol = rel.tol,
                  y = y, sigma2 = sigma2, alpha = alpha,
                  beta = beta)$value

    }

    exact_logmlH0 <- log(mH0(data_H0))

    exact_BF01 <- exp(exact_logmlH0 - exact_logmlH1)

    H0.bridge.curr <- H0.bridge
    H1.bridge.curr <- H1.bridge
    BF01.curr <- BF01
    post1.curr <- post1
    post2.curr <- post2

    load(system.file("extdata/", "vignette_example_jags.RData",
                     package = "bridgesampling"))

    expect_equal(
      H0.bridge.curr$logml,
      expected = exact_logmlH0,
      tolerance = 0.01
    )
    expect_equal(
      H1.bridge.curr$logml,
      expected = exact_logmlH1,
      tolerance = 0.01
    )
    expect_equal(
      BF01.curr$bf,
      expected = exact_BF01,
      tolerance = 0.01
    )
    expect_equal(
      H0.bridge.curr$logml,
      expected = H0.bridge$logml,
      tolerance = 0.01
    )
    expect_equal(
      H1.bridge.curr$logml,
      expected = H1.bridge$logml,
      tolerance = 0.01
    )
    expect_equal(
      BF01.curr$bf,
      expected = BF01$bf,
      tolerance = 0.01
    )
    expect_equal(
      post1.curr,
      expected = post1,
      tolerance = 0.01
    )
    expect_equal(
      post2.curr,
      expected = post2,
      tolerance = 0.01
    )

  }

})

context('basic bridge sampling behavior normal parallel')

test_that("bridge sampler matches anlytical value normal example", {

  testthat::skip_on_cran()
  testthat::skip_on_ci()

  # library(bridgesampling)
  library(mvtnorm)

  x <- rmvnorm(1e4, mean = rep(0, 2), sigma = diag(2))
  colnames(x) <- c("x1", "x2")
  log_density <- function(s, data) {
    -.5*t(s)%*%s
  }
  assign("log_density", log_density, envir = .GlobalEnv)
  lb <- rep(-Inf, 2)
  ub <- rep(Inf, 2)
  names(lb) <- names(ub) <- colnames(x)
  bridge_normal <- bridge_sampler(samples = x, log_posterior = log_density,
                                  data = NULL, lb = lb, ub = ub,
                                  method = "normal", cores = 2, silent = TRUE)
  bridge_warp3 <- bridge_sampler(samples = x, log_posterior = log_density,
                                 data = NULL, lb = lb, ub = ub,
                                 method = "warp3", cores = 2, silent = TRUE)
  bridge_normal_c <- bridge_sampler(samples = x, log_posterior = "log_density",
                                    data = NULL, lb = lb, ub = ub,
                                    method = "normal", cores = 2, silent = TRUE,
                                    envir = sys.frame(sys.nframe()))
  bridge_warp3_c <- bridge_sampler(samples = x, log_posterior = "log_density",
                                   data = NULL, lb = lb, ub = ub,
                                   method = "warp3", cores = 2, silent = TRUE,
                                   envir = sys.frame(sys.nframe()))

  expect_equal(bridge_normal$logml, expected = log(2*pi), tolerance = 0.01)
  expect_equal(bridge_warp3$logml, expected = log(2*pi), tolerance = 0.01)
  expect_equal(bridge_normal_c$logml, expected = log(2*pi), tolerance = 0.01)
  expect_equal(bridge_warp3_c$logml, expected = log(2*pi), tolerance = 0.01)

  # test dots argument
  mu <- c(1, 2)
  x <- rmvnorm(1e4, mean = mu, sigma = diag(2))
  colnames(x) <- c("x1", "x2")
  log_density <- function(s, data, ...) {
    -.5*t(s - mu) %*% (s - mu)
  }
  assign("log_density", log_density, envir = .GlobalEnv)

  lb <- rep(-Inf, 2)
  ub <- rep(Inf, 2)
  names(lb) <- names(ub) <- colnames(x)

  bridge_normal_dots <- bridge_sampler(samples = x, log_posterior = log_density,
                                       mu, data = NULL, lb = lb, ub = ub,
                                       method = "normal", cores = 2, silent = TRUE)
  bridge_warp3_dots <- bridge_sampler(samples = x, log_posterior = log_density,
                                      mu, data = NULL, lb = lb, ub = ub,
                                      method = "warp3", cores = 2, silent = TRUE)
  bridge_normal_c_dots <- bridge_sampler(samples = x, log_posterior = "log_density",
                                         mu, data = NULL, lb = lb, ub = ub,
                                         method = "normal", cores = 2, silent = TRUE,
                                         envir = sys.frame(sys.nframe()))
  # ls.str(envir = sys.frame(sys.nframe()))
  bridge_warp3_c_dots <- bridge_sampler(samples = x, log_posterior = "log_density",
                                        mu, data = NULL, lb = lb, ub = ub,
                                        method = "warp3", cores = 2, silent = TRUE,
                                        envir = sys.frame(sys.nframe()))

  expect_equal(bridge_normal_dots$logml, expected = log(2*pi), tolerance = 0.01)
  expect_equal(bridge_warp3_dots$logml, expected = log(2*pi), tolerance = 0.01)
  expect_equal(bridge_normal_c_dots$logml, expected = log(2*pi), tolerance = 0.01)
  expect_equal(bridge_warp3_c_dots$logml, expected = log(2*pi), tolerance = 0.01)

})

context('test bridge_sampler mcmc.list method')

test_that("bridge sampler matches analytical value", {

  testthat::skip_on_cran()
  testthat::skip_on_ci()

  # library(bridgesampling)
  if (require(R2jags) && require(runjags)) {

    ### generate data ###
    set.seed(12345)

    mu <- 0
    tau2 <- 0.5
    sigma2 <- 1

    n <- 20
    theta <- rnorm(n, mu, sqrt(tau2))
    y <- rnorm(n, theta, sqrt(sigma2))

    ### set prior parameters ###
    mu0 <- 0
    tau20 <- 1
    alpha <- 1
    beta <- 1

    ### function to get posterior samples ###

    # H1: mu != 0
    getSamplesModelH1 <- function(data, niter = 12000, nburnin = 2000,
                                  nchains = 3) {

    model <- "
    model {
    for (i in 1:n) {
    theta[i] ~ dnorm(mu, invTau2)
    y[i] ~ dnorm(theta[i], 1/sigma2)
    }
    mu ~ dnorm(mu0, 1/tau20)
    invTau2 ~ dgamma(alpha, beta)
    tau2 <- 1/invTau2
    }"

      s <- jags(data, parameters.to.save = c("theta", "mu", "invTau2"),
                model.file = textConnection(model),
                n.chains = nchains, n.iter = niter,
                n.burnin = nburnin, n.thin = 1, progress.bar = "none",
                quiet = TRUE)
      return(s)

    }

    getSamplesModelH1_runjags <- function(data, niter = 12000, nburnin = 2000,
                                          nchains = 3) {

      model <- "
      model {
      for (i in 1:n) {
      theta[i] ~ dnorm(mu, invTau2)
      y[i] ~ dnorm(theta[i], 1/sigma2)
      }
      mu ~ dnorm(mu0, 1/tau20)
      invTau2 ~ dgamma(alpha, beta)
      tau2 <- 1/invTau2
      }"

      capture_output(s <- suppressWarnings(runjags::run.jags(model = model, data = data,
                                     monitor = c("theta", "mu", "invTau2"),
                                     n.chains = 3, burnin = 2000,
                                     sample = 10000, silent.jags = TRUE)))
      return(s)

    }

    ### get posterior samples ###

    # create data list for Jags
    data_H1 <- list(y = y, n = length(y), mu0 = mu0, tau20 = tau20, alpha = alpha,
                    beta = beta, sigma2 = sigma2)

    # fit model
    samples_H1 <- getSamplesModelH1(data_H1)
    samples_runjags <- getSamplesModelH1_runjags(data_H1)

    ### function for evaluating the unnormalized posterior on log scale ###
    log_posterior_H1 <- function(samples.row, data) {

      mu <- samples.row[[ "mu" ]]
      invTau2 <- samples.row[[ "invTau2" ]]
      theta <- samples.row[ paste0("theta[", seq_along(data$y), "]") ]

      sum(dnorm(data$y, theta, data$sigma2, log = TRUE)) +
        sum(dnorm(theta, mu, 1/sqrt(invTau2), log = TRUE)) +
        dnorm(mu, data$mu0, sqrt(data$tau20), log = TRUE) +
        dgamma(invTau2, data$alpha, data$beta, log = TRUE)

    }

    # specify parameter bounds
    cn <- colnames(samples_H1$BUGSoutput$sims.matrix)
    lb_H1 <- rep(-Inf, length(cn) - 1)
    ub_H1 <- rep(Inf, length(cn) - 1)
    names(lb_H1) <- names(ub_H1) <- cn[cn != "deviance"]
    lb_H1[[ "invTau2" ]] <- 0
    samples1 <- coda::as.mcmc(samples_H1)
    samples1 <- samples1[,cn != "deviance"]

    # mcmc.list
    bridge_normal <- bridge_sampler(samples = samples1, log_posterior = log_posterior_H1,
                                    data = data_H1, lb = lb_H1, ub = ub_H1,
                                    method = "normal", silent = TRUE, repetitions = 2)
    bridge_warp3 <- bridge_sampler(samples = samples1, log_posterior = log_posterior_H1,
                                   data = data_H1, lb = lb_H1, ub = ub_H1,
                                   method = "warp3", silent = TRUE, repetitions = 2)
    bridge_normal_m <- bridge_sampler(samples = samples1, log_posterior = log_posterior_H1,
                                      data = data_H1, lb = lb_H1, ub = ub_H1,
                                      method = "normal", silent = TRUE, repetitions = 2,
                                      cores = 2)
    bridge_warp3_m <- bridge_sampler(samples = samples1, log_posterior = log_posterior_H1,
                                     data = data_H1, lb = lb_H1, ub = ub_H1,
                                     method = "warp3", silent = TRUE, repetitions = 2,
                                     cores = 2)

    # mcmc
    bridge_normal_s <- bridge_sampler(samples = samples1[[1]], log_posterior = log_posterior_H1,
                                      data = data_H1, lb = lb_H1, ub = ub_H1,
                                      method = "normal", silent = TRUE, repetitions = 2)
    bridge_warp3_s <- bridge_sampler(samples = samples1[[1]], log_posterior = log_posterior_H1,
                                   data = data_H1, lb = lb_H1, ub = ub_H1,
                                   method = "warp3", silent = TRUE, repetitions = 2)
    bridge_normal_m_s <- bridge_sampler(samples = samples1[[1]], log_posterior = log_posterior_H1,
                                      data = data_H1, lb = lb_H1, ub = ub_H1,
                                      method = "normal", silent = TRUE, repetitions = 2,
                                      cores = 2)
    bridge_warp3_m_s <- bridge_sampler(samples = samples1[[1]], log_posterior = log_posterior_H1,
                                     data = data_H1, lb = lb_H1, ub = ub_H1,
                                     method = "warp3", silent = TRUE, repetitions = 2,
                                     cores = 2)

    # rjags
    bridge_normal_j <- bridge_sampler(samples = samples_H1, log_posterior = log_posterior_H1,
                                    data = data_H1, lb = lb_H1, ub = ub_H1,
                                    method = "normal", silent = TRUE, repetitions = 2)
    bridge_warp3_j <- bridge_sampler(samples = samples_H1, log_posterior = log_posterior_H1,
                                   data = data_H1, lb = lb_H1, ub = ub_H1,
                                   method = "warp3", silent = TRUE, repetitions = 2)
    bridge_normal_jm <- bridge_sampler(samples = samples_H1, log_posterior = log_posterior_H1,
                                      data = data_H1, lb = lb_H1, ub = ub_H1,
                                      method = "normal", silent = TRUE, repetitions = 2,
                                      cores = 2)
    bridge_warp3_jm <- bridge_sampler(samples = samples_H1, log_posterior = log_posterior_H1,
                                     data = data_H1, lb = lb_H1, ub = ub_H1,
                                     method = "warp3", silent = TRUE, repetitions = 2,
                                     cores = 2)

    # runjags
    bridge_normal_r <- bridge_sampler(samples = samples_runjags, log_posterior = log_posterior_H1,
                                      data = data_H1, lb = lb_H1, ub = ub_H1,
                                      method = "normal", silent = TRUE, repetitions = 2)
    bridge_warp3_r <- bridge_sampler(samples = samples_runjags, log_posterior = log_posterior_H1,
                                     data = data_H1, lb = lb_H1, ub = ub_H1,
                                     method = "warp3", silent = TRUE, repetitions = 2)
    bridge_normal_rm <- bridge_sampler(samples = samples_runjags, log_posterior = log_posterior_H1,
                                       data = data_H1, lb = lb_H1, ub = ub_H1,
                                       method = "normal", silent = TRUE, repetitions = 2,
                                       cores = 2)
    bridge_warp3_rm <- bridge_sampler(samples = samples_runjags, log_posterior = log_posterior_H1,
                                      data = data_H1, lb = lb_H1, ub = ub_H1,
                                      method = "warp3", silent = TRUE, repetitions = 2,
                                      cores = 2)

    # "exact" ml
    mH1 <- function(data, rel.tol = 1e-10) {

      y <- data$y
      n <- data$n
      mu0 <- data$mu0
      tau20 <- data$tau20
      alpha <- data$alpha
      beta <- data$beta
      sigma2 <- data$sigma2

      mH1integrand <- function(tau2, y, sigma2, mu0, tau20, alpha, beta) {

        (sigma2 + tau2)^(-n/2) *
          exp(-1/2 * ((n*mean(y)^2 + (n - 1)*sd(y)^2)/(sigma2 + tau2) +
                        mu0^2/tau20 - ((n*mean(y))/(sigma2 + tau2) +
                                         mu0/tau20)^2 /
                        (n/(sigma2 + tau2) + 1/tau20))) *
          (n/(sigma2 + tau2) + 1/tau20)^(-1/2) * tau2^(-alpha - 1) *
          exp(-beta/tau2)

      }

      (2*pi)^(-n/2) * (tau20)^(-1/2) * beta^alpha/gamma(alpha) *
        integrate(mH1integrand, 0, Inf,
                  rel.tol = rel.tol, y = y,
                  sigma2 = sigma2, mu0 = mu0,
                  tau20 = tau20, alpha = alpha,
                  beta = beta)$value

    }

    exact_logml <- log(mH1(data_H1))

    expect_equal(class(samples1), expected = "mcmc.list")
    expect_equal(
      bridge_normal$logml,
      expected = rep(exact_logml, length(bridge_normal$logml)),
      tolerance = 0.01
    )
    expect_equal(
      bridge_warp3$logml,
      expected = rep(exact_logml, length(bridge_warp3$logml)),
      tolerance = 0.01
    )
    expect_equal(
      bridge_normal_m$logml,
      expected = rep(exact_logml, length(bridge_normal_m$logml)),
      tolerance = 0.01
    )
    expect_equal(
      bridge_warp3_m$logml,
      expected = rep(exact_logml, length(bridge_warp3_m$logml)),
      tolerance = 0.01
    )

    expect_equal(class(samples1[[1]]), expected = "mcmc")
    expect_equal(
      bridge_normal_s$logml,
      expected = rep(exact_logml, length(bridge_normal_s$logml)),
      tolerance = 0.01
    )
    expect_equal(
      bridge_warp3_s$logml,
      expected = rep(exact_logml, length(bridge_warp3_s$logml)),
      tolerance = 0.01
    )
    expect_equal(
      bridge_normal_m_s$logml,
      expected = rep(exact_logml, length(bridge_normal_m_s$logml)),
      tolerance = 0.01
    )
    expect_equal(
      bridge_warp3_m_s$logml,
      expected = rep(exact_logml, length(bridge_warp3_m_s$logml)),
      tolerance = 0.01
    )

    expect_equal(class(samples_H1), expected = "rjags")
    expect_equal(
      bridge_normal_j$logml,
      expected = rep(exact_logml, length(bridge_normal_j$logml)),
      tolerance = 0.01
    )
    expect_equal(
      bridge_warp3_j$logml,
      expected = rep(exact_logml, length(bridge_warp3_j$logml)),
      tolerance = 0.01
    )
    expect_equal(
      bridge_normal_jm$logml,
      expected = rep(exact_logml, length(bridge_normal_jm$logml)),
      tolerance = 0.01
    )
    expect_equal(
      bridge_warp3_jm$logml,
      expected = rep(exact_logml, length(bridge_warp3_jm$logml)),
      tolerance = 0.01
    )

    expect_equal(class(samples_runjags), expected = "runjags")
    expect_equal(
      bridge_normal_r$logml,
      expected = rep(exact_logml, length(bridge_normal_r$logml)),
      tolerance = 0.01
    )
    expect_equal(
      bridge_warp3_r$logml,
      expected = rep(exact_logml, length(bridge_warp3_r$logml)),
      tolerance = 0.01
    )
    expect_equal(
      bridge_normal_rm$logml,
      expected = rep(exact_logml, length(bridge_normal_rm$logml)),
      tolerance = 0.01
    )
    expect_equal(
      bridge_warp3_rm$logml,
      expected = rep(exact_logml, length(bridge_warp3_rm$logml)),
      tolerance = 0.01
    )

    ### check that wrong lb and ub produce errors:
    ub_H0 <- ub_H1[-2]
    lb_H0 <- lb_H1[-1]
    expect_error(
      bridge_sampler(
        samples = samples_runjags,
        log_posterior = log_posterior_H1,
        data = data_H1,
        lb = lb_H1,
        ub = ub_H0
      ),
      "ub does not contain all parameters"
    )
    expect_error(
      bridge_sampler(
        samples = samples_runjags,
        log_posterior = log_posterior_H1,
        data = data_H1,
        lb = lb_H0,
        ub = ub_H1
      ),
      "lb does not contain all parameters"
    )
    expect_error(
      bridge_sampler(
        samples = samples1,
        log_posterior = log_posterior_H1,
        data = data_H1,
        lb = lb_H1,
        ub = ub_H0
      ),
      "ub does not contain all parameters"
    )
    expect_error(
      bridge_sampler(
        samples = samples1,
        log_posterior = log_posterior_H1,
        data = data_H1,
        lb = lb_H0,
        ub = ub_H1
      ),
      "lb does not contain all parameters"
    )
    expect_error(
      bridge_sampler(
        samples = samples_H1,
        log_posterior = log_posterior_H1,
        data = data_H1,
        lb = lb_H0,
        ub = ub_H1
      ),
      "lb does not contain all parameters"
    )
    expect_error(
      bridge_sampler(
        samples = samples_H1,
        log_posterior = log_posterior_H1,
        data = data_H1,
        lb = lb_H1,
        ub = ub_H0
      ),
      "ub does not contain all parameters"
    )

  }

})

context('basic bridge sampling behavior normal Rcpp')

test_that("bridge sampler matches anlytical value normal example", {

  testthat::skip_on_cran()
  testthat::skip_on_travis()

  # library(bridgesampling)
  library(mvtnorm)
  if(require(RcppEigen)) {

    x <- rmvnorm(1e4, mean = rep(0, 2), sigma = diag(2))
    colnames(x) <- c("x1", "x2")

    lb <- rep(-Inf, 2)
    ub <- rep(Inf, 2)
    names(lb) <- names(ub) <- colnames(x)

    Rcpp::sourceCpp("unnormalized_normal_density.cpp")

    bridge_normal <- bridge_sampler(samples = x, log_posterior = log_densityRcpp,
                                    data = NULL, lb = lb, ub = ub,
                                    method = "normal",
                                    silent = TRUE)
    bridge_warp3 <- bridge_sampler(samples = x, log_posterior = log_densityRcpp,
                                   data = NULL, lb = lb, ub = ub,
                                   method = "warp3",
                                   silent = TRUE)

    expect_equal(bridge_normal$logml, expected = log(2*pi), tolerance = 0.01)
    expect_equal(bridge_warp3$logml, expected = log(2*pi), tolerance = 0.01)

    # test dots argument
    mu <- c(1, 2)
    x <- rmvnorm(1e4, mean = mu, sigma = diag(2))
    colnames(x) <- c("x1", "x2")

    lb <- rep(-Inf, 2)
    ub <- rep(Inf, 2)
    names(lb) <- names(ub) <- colnames(x)

    Rcpp::sourceCpp("unnormalized_normal_density_mu.cpp")

    bridge_normal_dots <- bridge_sampler(samples = x, log_posterior = log_densityRcpp_mu,
                                         mu, data = NULL, lb = lb, ub = ub,
                                         method = "normal",
                                         silent = TRUE)
    bridge_warp3_dots <- bridge_sampler(samples = x, log_posterior = log_densityRcpp_mu,
                                        mu, data = NULL, lb = lb, ub = ub,
                                        method = "warp3",
                                        silent = TRUE)

    expect_equal(bridge_normal_dots$logml, expected = log(2*pi), tolerance = 0.01)
    expect_equal(bridge_warp3_dots$logml, expected = log(2*pi), tolerance = 0.01)

  }

})

context('bridge_sampler.stanreg works.')

test_that("stan_bridge_sampler", {

  testthat::skip_on_cran()
  testthat::skip_on_ci()

  if (require(rstanarm)) {

    fit_1 <- stan_glm(mpg ~ wt + qsec + am, data = mtcars,
                     chains = 2, cores = 2, iter = 5000,
                     diagnostic_file = file.path(tempdir(), "df.csv"),
                     refresh = 0)
    bridge_norm <- bridge_sampler(fit_1, silent = TRUE)

    fit_2 <- update(fit_1, formula = . ~ . + cyl, refresh = 0)
    bridge_warp <- bridge_sampler(fit_2, method = "warp3", silent = TRUE)

    expect_true(bridge_norm$logml > bridge_warp$logml)
  }
})


test_that("stan_bridge_sampler in multicore", {
  testthat::skip_on_cran()
  testthat::skip_on_ci()
  #testthat::skip_on_os("windows")
  if (require(rstanarm)) {
    fit_1 <- stan_glm(mpg ~ wt + qsec + am, data = mtcars,
                     chains = 2, cores = 2, iter = 5000,
                     diagnostic_file = file.path(tempdir(), "df.csv"),
                     refresh = 0)
    bridge_norm <- bridge_sampler(fit_1, cores = 2, silent = TRUE)

    fit_2 <- update(fit_1, formula = . ~ . + cyl, refresh = 0)
    bridge_warp <- bridge_sampler(fit_2, method = "warp3", cores = 2, silent = TRUE)

    expect_true(bridge_norm$logml > bridge_warp$logml)
  }
})

context("test bridge_sampler cmdstanmcmc method")

testthat::test_that("bridge_sampler() works for CmdStanMCMC and basic sanity checks", {
  testthat::skip_on_cran()
  testthat::skip_if_not_installed("cmdstanr")
  testthat::skip_if_not_installed("bridgesampling")
  testthat::skip_if_not_installed("posterior")

  # Require a working CmdStan toolchain
  if (!file.exists(cmdstanr::cmdstan_path())) {
    testthat::skip("CmdStan is not installed in the expected path for cmdstanr.")
  }

  set.seed(123)

  N     <- 60L
  sigma <- 1
  y     <- rnorm(N, mean = 0.5, sd = sigma)

  data_list <- list(N = N, y = y, sigma = sigma)

  stan_code <- "
  data {
    int<lower=1> N;
    vector[N] y;
    real<lower=0> sigma;
  }
  parameters {
    real mu;
  }
  model {
    mu ~ normal(0, 1);
    y ~ normal(mu, sigma);
  }"

  tf <- tempfile(fileext = ".stan")
  on.exit(unlink(tf), add = TRUE)
  writeLines(stan_code, tf)
  mod <- cmdstanr::cmdstan_model(tf, quiet = TRUE, force_recompile = TRUE)

  fit <- mod$sample(
    data = data_list,
    seed = 202,
    chains = 2,
    parallel_chains = 2,
    iter_warmup = 2000,
    iter_sampling = 4000,
    refresh = 0,
    show_messages = FALSE,
    show_exceptions = FALSE
  )

  bs <- bridgesampling::bridge_sampler(fit, silent = TRUE, use_neff = FALSE)

  testthat::expect_s3_class(fit, "CmdStanMCMC")
  testthat::expect_true(is.list(bs))
  testthat::expect_true(is.finite(bs$logml))

  fit2 <- mod$sample(
    data = data_list,
    seed = 203,
    chains = 4,
    parallel_chains = 2,
    iter_warmup = 750,
    iter_sampling = 2000,
    refresh = 0,
    show_messages = FALSE,
    show_exceptions = FALSE
  )
  bs2 <- bridgesampling::bridge_sampler(fit2, silent = TRUE, use_neff = FALSE)
  testthat::expect_true(is.finite(bs2$logml))
})

testthat::test_that("CmdStanMCMC bridge estimate roughly agrees with rstan", {
  testthat::skip_on_cran()
  testthat::skip_on_ci()
  testthat::skip_if_not_installed("cmdstanr")
  testthat::skip_if_not_installed("bridgesampling")
  if (!requireNamespace("rstan", quietly = TRUE)) testthat::skip("rstan not installed")

  if (!file.exists(cmdstanr::cmdstan_path())) {
    testthat::skip("CmdStan is not installed in the expected path for cmdstanr.")
  }

  set.seed(456)

  # Same model/data as above
  N     <- 60L
  sigma <- 1
  y     <- rnorm(N, mean = 0.25, sd = sigma)
  data_list <- list(N = N, y = y, sigma = sigma)

  stan_code <- "
  data {
    int<lower=1> N;
    vector[N] y;
    real<lower=0> sigma;
  }
  parameters {
    real mu;
  }
  model {
    mu ~ normal(0, 1);
    y ~ normal(mu, sigma);
  }"

  # --- CmdStanR/RStan fit ---
  tf <- tempfile(fileext = ".stan")
  on.exit(unlink(tf), add = TRUE)
  writeLines(stan_code, tf)
  mod_cs <- cmdstanr::cmdstan_model(tf, quiet = TRUE)
  fit_cs <- mod_cs$sample(
    data = data_list,
    seed = 777,
    chains = 4,
    parallel_chains = 2,
    iter_warmup = 10000,
    iter_sampling = 3000,
    refresh = 0,
    show_messages = FALSE,
    show_exceptions = FALSE
  )
  bs_cmd <- bridgesampling::bridge_sampler(fit_cs, silent = TRUE, use_neff = FALSE)
  testthat::expect_true(is.finite(bs_cmd$logml))

  Sys.sleep(2.5)

  sm <- rstan::stan_model(model_code = stan_code)
  fit_rs <- rstan::sampling(
    sm, data = data_list, seed = 777,
    chains = 4, iter = 10000, warmup = 3000, refresh = 0, cores = 2
  )
  bs_rstan <- bridgesampling::bridge_sampler(fit_rs, silent = TRUE, use_neff = FALSE)
  testthat::expect_true(is.finite(bs_rstan$logml))

  # Compare the two bridge estimates. Tolerance accounts for MC/bridge variance.
  testthat::expect_lt(abs(bs_cmd$logml - bs_rstan$logml), 0.5)
})

context('bridge sampling print method')

test_that("bridge sampler print method correctly displayed", {

  # library(bridgesampling)
  library(mvtnorm)

  x <- rmvnorm(1e4, mean = rep(0, 2), sigma = diag(2))
  colnames(x) <- c("x1", "x2")
  log_density <- function(s, data) {
    -.5*t(s)%*%s
  }

  lb <- rep(-Inf, 2)
  ub <- rep(Inf, 2)
  names(lb) <- names(ub) <- colnames(x)

  # repetitions = 1
  bridge_normal <- bridge_sampler(samples = x, log_posterior = log_density,
                                  data = NULL, lb = lb, ub = ub,
                                  method = "normal", silent = TRUE)
  bridge_warp3 <- bridge_sampler(samples = x, log_posterior = log_density,
                                  data = NULL, lb = lb, ub = ub,
                                 method = "warp3", silent = TRUE)

  expect_output(print(bridge_normal), "Bridge sampling estimate of the log marginal likelihood")
  expect_output(print(bridge_warp3), "Bridge sampling estimate of the log marginal likelihood")

  # repetitions > 1
  bridge_normal <- bridge_sampler(samples = x, log_posterior = log_density,
                                  data = NULL, lb = lb, ub = ub,
                                  method = "normal", silent = TRUE, repetitions = 2)
  bridge_warp3 <- bridge_sampler(samples = x, log_posterior = log_density,
                                 data = NULL, lb = lb, ub = ub,
                                 method = "warp3", silent = TRUE, repetitions = 2)

  expect_output(print(bridge_normal), "Median of")
  expect_output(print(bridge_warp3), "Median of")

})

test_that("prints with NAs with warning.", {
  bridge_o <- structure(list(logml = c(4291.14352476047, 4293.29076119542,
4291.96372581169, 4293.02187182362, NA, NA, 4290.9761730488,
4293.32075269401, 4293.5762219227, 4294.02761288449), niter = c(104,
16, 52, 8, 1000, 1000, 167, 16, 21, 44), method = "normal", repetitions = 10), .Names = c("logml",
"niter", "method", "repetitions"), class = "bridge_list")

  expect_output(expect_warning(print(bridge_o), "NA"))
})

context(".cmdstan_log_posterior helper function for CmdStanMCMC")

test_that(".cmdstan_log_posterior and bridge_sampler agree with analytical results on an unconstrained model", {
  skip_on_cran()
  skip_if_not_installed("cmdstanr")
  skip_if_not_installed("posterior")
  skip_if_not_installed("bridgesampling")

  if (!file.exists(cmdstanr::cmdstan_path())) {
    skip("CmdStan is not installed in the expected path for cmdstanr.")
  }

  # Access the internal helper from bridgesampling
  pkg <- "bridgesampling"
  expect_true(
    exists(".cmdstan_log_posterior", envir = asNamespace(pkg), inherits = FALSE),
    info = "Internal function .cmdstan_log_posterior not found in 'bridgesampling'."
  )
  .cmdstan_log_posterior <- get(".cmdstan_log_posterior", envir = asNamespace(pkg))


  # Normal - Normal Data Model
  set.seed(321)
  N     <- 40L
  sigma <- 1
  y     <- rnorm(N, 0.25, sigma)
  data_list <- list(N = N, y = y, sigma = sigma)

  stan_code <- "
  data { int<lower=1> N; vector[N] y; real<lower=0> sigma; }
  parameters { real mu; }
  model {
    mu ~ normal(0, 1);
    y ~ normal(mu, sigma);
  }"

  tf <- tempfile(fileext = ".stan")
  on.exit(unlink(tf), add = TRUE)
  writeLines(stan_code, tf)

  mod <- cmdstanr::cmdstan_model(tf, quiet = TRUE, force_recompile = TRUE)

  fit <- mod$sample(
    data = data_list,
    seed = 404,
    chains = 20,
    parallel_chains = 4,
    iter_warmup = 1000,
    iter_sampling = 10000,
    refresh = 0,
    show_messages = FALSE,
    show_exceptions = FALSE
  )

  # 1) lp__ vs analytical log posterior (up to a constant)
  # Prior: mu ~ N(0,1); likelihood: y_i | mu ~ N(mu, sigma^2)
  logpost_mu <- function(mu, y, sigma) {
    -0.5 * mu^2 - sum((y - mu)^2) / (2 * sigma^2)
  }

  # Extract draws
  lp_df <- fit$draws(variables = "lp__", format = "df")
  expect_true(nrow(lp_df) > 10)
  lp_vec_all <- lp_df$lp__

  mu_df <- fit$draws(variables = "mu", format = "df")
  expect_equal(nrow(mu_df), length(lp_vec_all))
  mu_vec_all <- mu_df$mu

  lp_anal_all <- vapply(mu_vec_all, logpost_mu, numeric(1), y = y, sigma = sigma)

  # Compare up to additive constant: center both and compare
  lp_cent <- lp_vec_all - mean(lp_vec_all)
  anal_cent <- lp_anal_all - mean(lp_anal_all)

  expect_equal(lp_cent, anal_cent, tolerance = 1e-4)
  expect_gt(stats::cor(lp_vec_all, lp_anal_all), 0.99) # sanity check on correlation

  # 2) bridgesampling's internal q11 agrees with analytical log posterior
  bs_out <- bridgesampling::bridge_sampler(
    samples     = fit,
    repetitions = 1,
    method      = "normal",
    cores       = 1L,
    use_neff    = FALSE,
    silent      = TRUE,
    verbose     = FALSE
  )

  n_all   <- length(lp_vec_all)
  n_fit   <- round(n_all / 2)
  idx_iter <- seq.int(n_fit + 1L, n_all)

  expect_equal(length(bs_out$q11), length(idx_iter))

  # Compute analytical log posterior for the same subset of draws
  mu_iter       <- mu_vec_all[idx_iter]
  lp_anal_iter  <- vapply(mu_iter, logpost_mu, numeric(1), y = y, sigma = sigma)

  # Compare up to an additive constant by centering both
  q11_cent        <- bs_out$q11 - mean(bs_out$q11)
  anal_iter_cent  <- lp_anal_iter - mean(lp_anal_iter)

  expect_equal(unname(q11_cent), unname(anal_iter_cent), tolerance = 1e-4)
  expect_gt(stats::cor(bs_out$q11, lp_anal_iter), 0.99) # additional sanity check


  # 3) Spot-check the internal helper against lp__ directly
  upars <- fit$unconstrain_draws(format = "matrix")
  expect_equal(nrow(upars), length(lp_vec_all))

  take <- seq_len(min(100L, nrow(upars)))
  direct_vals <- apply(upars[take, , drop = FALSE], 1, .cmdstan_log_posterior, data = fit)

  expect_type(direct_vals, "double")
  expect_length(direct_vals, length(take))
  expect_equal(unname(direct_vals), unname(lp_vec_all[take]), tolerance = 1e-4)

  # 4) Basic input validation on the helper
  expect_error(
    .cmdstan_log_posterior(fit = "not-a-fit", data = list()),
    info = "Helper should reject invalid input when mis-called with named args."
  )

  expect_error(
    .cmdstan_log_posterior(x = numeric(), data = fit),
    info = "Proper signature should reject badly shaped x."
  )
})


test_that("bridgesampling and .cmdstan_log_posterior handle constrained parameter correctly", {
  skip_on_cran()
  skip_if_not_installed("cmdstanr")
  skip_if_not_installed("posterior")
  skip_if_not_installed("bridgesampling")

  if (!file.exists(cmdstanr::cmdstan_path())) {
    skip("CmdStan is not installed in the expected path for cmdstanr.")
  }

  # Access bridgesampling's internal helper
  pkg <- "bridgesampling"
  expect_true(
    exists(".cmdstan_log_posterior", envir = asNamespace(pkg), inherits = FALSE),
    info = "Internal function .cmdstan_log_posterior not found in 'bridgesampling'."
  )
  .cmdstan_log_posterior <- get(".cmdstan_log_posterior", envir = asNamespace(pkg))

  # Stan model with constrained theta and simple Bernoulli likelihood
  bern_code <- "
  data {
    int<lower=0> N;
    array[N] int<lower=0, upper=1> y;
  }
  parameters {
    real<lower=0, upper=1> theta;
  }
  model {
    target += beta_lpdf(theta | 1, 1);            // uniform prior on (0,1)
    target += bernoulli_lpmf(y | theta);          // likelihood
  }"

  tf <- tempfile(fileext = ".stan")
  on.exit(unlink(tf), add = TRUE)
  writeLines(bern_code, tf)
  mod <- cmdstanr::cmdstan_model(tf, quiet = TRUE, force_recompile = TRUE)

  # Data
  data_bern <- list(N = 10L, y = c(1, 1, 1, 0, 1, 1, 1, 0, 1, 0))
  fit <- mod$sample(
    data = data_bern,
    seed = 777,
    chains = 8,
    parallel_chains = 4,
    iter_warmup = 1000,
    iter_sampling = 8000,
    refresh = 0,
    show_messages = FALSE,
    show_exceptions = FALSE
  )

  # Analytical log-posterior on the UNCONSTRAINED space
  y_ <- data_bern$y
  N_ <- data_bern$N
  s_ <- sum(y_)

  logpost_unconstrained <- function(theta, s, N) {
    # Prior Beta(1,1) contributes only a constant
    # Likelihood + Jacobian
    s * log(theta) + (N - s) * log1p(-theta) + log(theta * (1 - theta))
  }

  lp_df <- fit$draws(variables = "lp__", format = "df")
  expect_true(nrow(lp_df) > 10)
  lp_vec_all <- lp_df$lp__

  th_df <- fit$draws(variables = "theta", format = "df")
  expect_equal(nrow(th_df), length(lp_vec_all))
  theta_all <- th_df$theta

  lp_anal_all <- vapply(theta_all, logpost_unconstrained, numeric(1), s = s_, N = N_)
  lp_cent   <- lp_vec_all - mean(lp_vec_all)
  anal_cent <- lp_anal_all - mean(lp_anal_all)

  expect_equal(lp_cent, anal_cent, tolerance = 1e-4)
  expect_gt(stats::cor(lp_vec_all, lp_anal_all), 0.99)

  bs_out <- bridgesampling::bridge_sampler(
    samples     = fit,
    repetitions = 1,
    method      = "normal",
    cores       = 1L,
    use_neff    = FALSE,
    silent      = TRUE,
    verbose     = FALSE
  )

  n_all    <- length(lp_vec_all)
  n_fit    <- round(n_all / 2)
  idx_iter <- seq.int(n_fit + 1L, n_all)

  expect_equal(length(bs_out$q11), length(idx_iter))

  theta_iter      <- theta_all[idx_iter]
  lp_anal_iter    <- vapply(theta_iter, logpost_unconstrained, numeric(1), s = s_, N = N_)
  q11_cent        <- bs_out$q11 - mean(bs_out$q11)
  anal_iter_cent  <- lp_anal_iter - mean(lp_anal_iter)

  expect_equal(unname(q11_cent), unname(anal_iter_cent), tolerance = 1e-4)
  expect_gt(stats::cor(bs_out$q11, lp_anal_iter), 0.99)

  upars <- fit$unconstrain_draws(format = "matrix")
  expect_equal(nrow(upars), length(lp_vec_all))

  take <- seq_len(min(100L, nrow(upars)))
  direct_vals <- apply(upars[take, , drop = FALSE], 1, .cmdstan_log_posterior, data = fit)

  expect_type(direct_vals, "double")
  expect_length(direct_vals, length(take))
  expect_equal(unname(direct_vals), unname(lp_vec_all[take]), tolerance = 1e-4)
})

context('test vignette bridgesampling_stan_ttest.Rmd')

test_that("bridge sampler yields correct results", {

  testthat::skip_on_cran()
  testthat::skip_on_ci()

  # library(bridgesampling)
  if (require(rstan) && require(BayesFactor)) {

    set.seed(12345)

    # Sleep data from t.test example
    data(sleep)

    # compute difference scores
    y <- sleep$extra[sleep$group == 2] - sleep$extra[sleep$group == 1]
    n <- length(y)

    # models
    stancodeH0 <- '
    data {
    int<lower=1> n; // number of observations
    vector[n] y; // observations
    }
    parameters {
    real<lower=0> sigma2; // variance parameter
    }
    model {
    target += log(1/sigma2); // Jeffreys prior on sigma2
    target += normal_lpdf(y | 0, sqrt(sigma2)); // likelihood
    }
    '
    stancodeH1 <- '
    data {
    int<lower=1> n; // number of observations
    vector[n] y; // observations
    real<lower=0> r; // Cauchy prior scale
    }
    parameters {
    real delta;
    real<lower=0> sigma2;// variance parameter
    }
    model {
    target += cauchy_lpdf(delta | 0, r); // Cauchy prior on delta
    target += log(1/sigma2); // Jeffreys prior on sigma2
    target += normal_lpdf(y | delta*sqrt(sigma2), sqrt(sigma2));  // likelihood
    }
    '
    # compile models
    stanmodelH0 <- stan_model(model_code = stancodeH0, model_name="stanmodel")
    stanmodelH1 <- stan_model(model_code = stancodeH1, model_name="stanmodel")

    # fit models
    stanfitH0 <- sampling(stanmodelH0, data = list(y = y, n = n),
                          iter = 20000, warmup = 1000, chains = 4, cores = 1,
                          control = list(adapt_delta = .99), refresh = 0)
    stanfitH1 <- sampling(stanmodelH1, data = list(y = y, n = n, r = 1/sqrt(2)),
                          iter = 20000, warmup = 1000, chains = 4, cores = 1,
                          control = list(adapt_delta = .99), refresh = 0)

    set.seed(12345)
    suppressWarnings(H0 <- bridge_sampler(stanfitH0, silent = TRUE))
    H1 <- bridge_sampler(stanfitH1, silent = TRUE)

    # compute percentage errors
    H0.error <- error_measures(H0)$percentage
    H1.error <- error_measures(H1)$percentage

    # compute Bayes factor
    BF10 <- bf(H1, H0)

    # BayesFactor result
    BF10.BayesFactor <- extractBF(ttestBF(y), onlybf = TRUE, logbf = FALSE)

    # one-sided test
    stancodeHplus <- '
    data {
    int<lower=1> n; // number of observations
    vector[n] y; // observations
    real<lower=0> r; // Cauchy prior scale
    }
    parameters {
    real<lower=0> delta; // constrained to be positive
    real<lower=0> sigma2;// variance parameter
    }
    model {
    target += cauchy_lpdf(delta | 0, r) - cauchy_lccdf(0 | 0, r); // Cauchy prior on delta
    target += log(1/sigma2); // Jeffreys prior on sigma2
    target += normal_lpdf(y | delta*sqrt(sigma2), sqrt(sigma2));  // likelihood
    }
    '
    # compile and fit model
    stanmodelHplus <- stan_model(model_code = stancodeHplus, model_name="stanmodel")
    stanfitHplus <- sampling(stanmodelHplus, data = list(y = y, n = n, r = 1/sqrt(2)),
                             iter = 30000, warmup = 1000, chains = 4,
                             control = list(adapt_delta = .99), refresh = 0)

    Hplus <- bridge_sampler(stanfitHplus, silent = TRUE)
    Hplus.error <- error_measures(Hplus)$percentage

    # compute Bayes factor
    BFplus0 <- bf(Hplus, H0)

    BFplus0.BayesFactor <- extractBF(ttestBF(y, nullInterval = c(0, Inf)),
                                     onlybf = TRUE, logbf = FALSE)[1]

    H0.curr <- H0
    H1.curr <- H1
    Hplus.curr <- Hplus
    BF10.curr <- BF10
    BFplus0.curr <- BFplus0

    load(system.file("extdata/", "vignette_stan_ttest.RData",
                     package = "bridgesampling"))

    expect_equal(
      H0.curr$logml,
      expected = H0$logml,
      tolerance = 0.01
    )
    expect_equal(
      H1.curr$logml,
      expected = H1$logml,
      tolerance = 0.01
    )
    expect_equal(
      BF10.curr$bf,
      expected = BF10$bf,
      tolerance = 0.01
    )
    expect_equal(
      BF10.curr$bf,
      expected = BF10.BayesFactor,
      tolerance = 0.03
    )
    expect_equal(
      BFplus0.curr$bf,
      expected = BFplus0$bf,
      tolerance = 0.01
    )
    expect_equal(
      BFplus0.curr$bf,
      expected = BFplus0.BayesFactor,
      tolerance = 0.03
    )
  }

})

context('basic bridge sampling behavior normal Rcpp parallel')

test_that("bridge sampler matches anlytical value normal example", {

  testthat::skip_on_cran()
  testthat::skip_on_ci()

  # library(bridgesampling)
  library(mvtnorm)
  if(require(RcppEigen)) {

    x <- rmvnorm(1e4, mean = rep(0, 2), sigma = diag(2))
    colnames(x) <- c("x1", "x2")

    lb <- rep(-Inf, 2)
    ub <- rep(Inf, 2)
    names(lb) <- names(ub) <- colnames(x)
    Rcpp::sourceCpp(file = "unnormalized_normal_density.cpp")
    Rcpp::sourceCpp(file = "unnormalized_normal_density.cpp", env = .GlobalEnv)
    bridge_normal <- bridge_sampler(samples = x, log_posterior = "log_densityRcpp",
                                    data = NULL, lb = lb, ub = ub,
                                    method = "normal", packages = "RcppEigen",
                                    rcppFile = "unnormalized_normal_density.cpp",
                                    cores = 2, silent = TRUE)
    bridge_warp3 <- bridge_sampler(samples = x, log_posterior = "log_densityRcpp",
                                   data = NULL, lb = lb, ub = ub,
                                   method = "warp3", packages = "RcppEigen",
                                   rcppFile = "unnormalized_normal_density.cpp",
                                   cores = 2, silent = TRUE)

    expect_equal(bridge_normal$logml, expected = log(2*pi), tolerance = 0.01)
    expect_equal(bridge_warp3$logml, expected = log(2*pi), tolerance = 0.01)

    # test dots argument
    mu <- c(1, 2)
    x <- rmvnorm(1e4, mean = mu, sigma = diag(2))
    colnames(x) <- c("x1", "x2")

    lb <- rep(-Inf, 2)
    ub <- rep(Inf, 2)
    names(lb) <- names(ub) <- colnames(x)
    Rcpp::sourceCpp(file = "unnormalized_normal_density_mu.cpp")
    Rcpp::sourceCpp(file = "unnormalized_normal_density_mu.cpp", env = .GlobalEnv)

    bridge_normal_dots <- bridge_sampler(samples = x, log_posterior = "log_densityRcpp_mu",
                                         mu, data = NULL, lb = lb, ub = ub,
                                         method = "normal", packages = "RcppEigen",
                                         rcppFile = "unnormalized_normal_density_mu.cpp",
                                         cores = 2, silent = TRUE)
    bridge_warp3_dots <- bridge_sampler(samples = x, log_posterior = "log_densityRcpp_mu",
                                        mu, data = NULL, lb = lb, ub = ub,
                                        method = "warp3", packages = "RcppEigen",
                                        rcppFile = "unnormalized_normal_density_mu.cpp",
                                        cores = 2, silent = TRUE)

    expect_equal(bridge_normal_dots$logml, expected = log(2*pi), tolerance = 0.01)
    expect_equal(bridge_warp3_dots$logml, expected = log(2*pi), tolerance = 0.01)

  }

})

context('Stan Bridge Sampler Bugs')

test_that("subscript out of bounds error", {
  ## https://github.com/quentingronau/bridgesampling/issues/26
  stan_mod = "
  data{
    int M;
    int J;
    int T;
    int E;
    int G;
    int N[G];
    int ii[M];
    int jj[M];
    int gg[M];
    int g_all[sum(N)];
    int y[M];
    matrix[J,J] obs_corr[G];
  }

  transformed data{
    int N_all = sum(N);
  }

  parameters{
    ordered[T] thresholds_raw[G,J];
    matrix<multiplier=5>[E,J] lam[G];
    matrix[N_all,E] eta;
    matrix[N_all,J] ystar_raw;
  }

  transformed parameters {
    ordered[T] thresholds[G,J];

    for(g in 1:G)
      for(j in 1:J)
        thresholds[g,j] = thresholds_raw[g,j] * 5;
  }


  model{
    matrix[N_all,J] ystar;
    int pos = 1;

    target += std_normal_lpdf(to_vector(ystar_raw));
    target += std_normal_lpdf(to_vector(eta));

    for(g in 1:G){
      int g_ids[N[g]] = segment(g_all,pos,N[g]);
      target += normal_lpdf(to_vector(eta)| 0,5);

      for(j in 1:J)
        target += std_normal_lpdf(thresholds_raw[g,j]);

      ystar[g_ids,] = eta[g_ids,] * lam[g] + ystar_raw[g_ids,];
      pos += N[g];
    }

    for(m in 1:M)
      target += ordered_logistic_lpmf(y[m] | ystar[ii[m],jj[m]],
                                             thresholds[gg[m],jj[m]]);
  }
  "
  testthat::skip_on_cran()
  testthat::skip_on_ci()
  testthat::skip_if_not_installed("rstan")
  library("rstan")
  # source("tests/testthat/test_dat.txt")
  source("test_dat.txt")

  suppressWarnings(
    mod <- stan(model_code=stan_mod,data=test_dat, chains = 2, refresh = 0)
  )

  expect_warning(object = bridge_sampler(mod, silent=TRUE),
                 regexp = "Infinite value in iterative scheme, returning NA.")
})

test_that("bridge_sampler.stanfit multicore works for one-parameter model.", {

  skip_on_cran()
  skip_on_ci()
  skip_on_os("windows")

  if (require(rstan)) {
    set.seed(12345)

    # compute difference scores
    n <- 10
    y <- rnorm(n)

    # models
    stancodeH0 <- '
    data {
    int<lower=1> n; // number of observations
    vector[n] y; // observations
    }
    parameters {
    real<lower=0> sigma2; // variance parameter
    }
    model {
    target += log(1/sigma2); // Jeffreys prior on sigma2
    target += normal_lpdf(y | 0, sqrt(sigma2)); // likelihood
    }
    '
    # compile models
    suppressWarnings(
      stanmodelH0 <- stan_model(model_code = stancodeH0, model_name="stanmodel")
    )
    # fit models
    stanfitH0 <- sampling(stanmodelH0, data = list(y = y, n = n),
                          iter = 10000, warmup = 1000, chains = 4,
                          control = list(adapt_delta = 0.95),
                          refresh = 0)

    ######### bridge sampling ###########
    suppressWarnings(H0 <- bridge_sampler(stanfitH0, cores = 2, silent = TRUE))

    expect_s3_class(H0, "bridge")

  }
})

test_that("turtle example",{
  skip_on_cran()
  skip_on_ci()


  if (require(rstan)) {

    data("turtles")

    ### m1 (model with random intercepts) ###
    m1_code_nc <-
      "data {
        int<lower = 1> nobs;
        int<lower = 0, upper = 1> y[nobs];
        real<lower = 0> x[nobs];
        int<lower = 1> m;
        int<lower = 1> clutch[nobs];
      }
      parameters {
        real alpha0_raw;
        real alpha1_raw;
        vector[m] b_raw;
        real<lower = 0> sigma2;
      }
      transformed parameters {
        vector[m] b;
        real<lower = 0> sigma = sqrt(sigma2);
        real alpha0 = sqrt(10.0)*alpha0_raw;
        real alpha1 = sqrt(10.0)*alpha1_raw;
        b = b_raw*sigma;
      }
      model {
        // priors
        target += -2*log(1 + sigma2); // p(sigma2) = 1/(1 + sigma2)^2
        target += normal_lpdf(alpha0_raw | 0, 1);
        target += normal_lpdf(alpha1_raw | 0, 1);

        // random effects
        target += normal_lpdf(b_raw | 0, 1);

        // likelihood
        for (i in 1:nobs)
        target += bernoulli_lpmf(y[i] | Phi(alpha0 + alpha1*x[i] + b[clutch[i]]));
  }"

    suppressWarnings(
      stanobject_m1_nc <- stan(model_code = m1_code_nc,
                               data = list(y = turtles$y, x = turtles$x,
                                           nobs = nrow(turtles),
                                           m = max(turtles$clutch),
                                           clutch = turtles$clutch),
                               iter = 10500, warmup = 500, chains = 4,
                               refresh = 0)
    )
    bs_m1_nc <- bridge_sampler(stanobject_m1_nc, method = "warp3",
                               repetitions = 25, silent=TRUE)

  m0_code_nc <-
    "data {
      int<lower = 1> nobs;
      int<lower = 0, upper = 1> y[nobs];
      real<lower = 0> x[nobs];
    }
    parameters {
      real alpha0_raw;
      real alpha1_raw;
    }
    transformed parameters {
      real alpha0 = sqrt(10.0)*alpha0_raw;
      real alpha1 = sqrt(10.0)*alpha1_raw;
    }
    model {
      // priors
      target += normal_lpdf(alpha0_raw | 0, 1);
      target += normal_lpdf(alpha1_raw | 0, 1);

      // likelihood
      for (i in 1:nobs)
        target += bernoulli_lpmf(y[i] | Phi(alpha0 + alpha1*x[i]));
    }"

  suppressWarnings(
    stanobject_m0_nc <- stan(model_code = m0_code_nc,
                             data = list(y = turtles$y, x = turtles$x,
                                         nobs = nrow(turtles),
                                         m = max(turtles$clutch),
                                         clutch = turtles$clucth),
                             iter = 10500, warmup = 500, chains = 4,
                             refresh = 0)
  )

  bs_m0_nc <- bridge_sampler(stanobject_m0_nc, method = "warp3",
                             repetitions = 25, silent=TRUE)
  expect_equal(bf(bs_m0_nc, bs_m1_nc)$bf, rep(1.27, 25), tolerance = 0.02)
  }
})

context('test vignette bridgesampling_example_nimble.Rmd')

test_that("bridge sampler yields correct results", {

  testthat::skip_on_cran()
  testthat::skip_on_ci()

  # library(bridgesampling)
  if (require(nimble)) {

    ### generate data ###
    set.seed(12345)

    mu <- 0
    tau2 <- 0.5
    sigma2 <- 1

    n <- 20
    theta <- rnorm(n, mu, sqrt(tau2))
    y <- rnorm(n, theta, sqrt(sigma2))

    ### set prior parameters ###
    mu0 <- 0
    tau20 <- 1
    alpha <- 1
    beta <- 1

    # models
    codeH0 <- nimbleCode({
      invTau2 ~ dgamma(1, 1)
      tau2 <- 1/invTau2
      for (i in 1:20) {
        theta[i] ~ dnorm(0, sd = sqrt(tau2))
        y[i] ~ dnorm(theta[i], sd = 1)
      }
    })
    codeH1 <- nimbleCode({
      mu ~ dnorm(0, sd = 1)
      invTau2 ~ dgamma(1, 1)
      tau2 <- 1/invTau2
      for (i in 1:20) {
        theta[i] ~ dnorm(mu, sd = sqrt(tau2))
        y[i] ~ dnorm(theta[i], sd = 1)
      }
    })

    ## steps for H0:
    capture.output(suppressMessages(modelH0 <- nimbleModel(codeH0)))
    modelH0$setData(y = y) # set data
    cmodelH0 <- compileNimble(modelH0) # make compiled version from generated C++

    ## steps for H1:
    capture.output(suppressMessages(modelH1 <- nimbleModel(codeH1)))
    modelH1$setData(y = y) # set data
    cmodelH1 <- compileNimble(modelH1) # make compiled version from generated C++

    # build MCMC functions, skipping customization of the configuration.
    capture.output(suppressMessages({
      mcmcH0 <- buildMCMC(modelH0,
                          monitors = modelH0$getNodeNames(stochOnly = TRUE,
                                                          includeData = FALSE))
      mcmcH1 <- buildMCMC(modelH1,
                          monitors = modelH1$getNodeNames(stochOnly = TRUE,
                                                          includeData = FALSE))
    }))
    # compile the MCMC function via generated C++
    cmcmcH0 <- compileNimble(mcmcH0, project = modelH0)
    cmcmcH1 <- compileNimble(mcmcH1, project = modelH1)

    # run the MCMC.  This is a wrapper for cmcmc$run() and extraction of samples.
    # the object samplesH1 is actually not needed as the samples are also in cmcmcH1
    samplesH0 <- runMCMC(cmcmcH0, niter = 1e5, nburnin = 1000, nchains = 2,
                         progressBar = FALSE)
    samplesH1 <- runMCMC(cmcmcH1, niter = 1e5, nburnin = 1000, nchains = 2,
                         progressBar = FALSE)

    # compute log marginal likelihood via bridge sampling for H0
    H0.bridge <- bridge_sampler(cmcmcH0, silent = TRUE)

    # compute log marginal likelihood via bridge sampling for H1
    H1.bridge <- bridge_sampler(cmcmcH1, silent = TRUE)

    # compute percentage errors
    H0.error <- error_measures(H0.bridge)$percentage
    H1.error <- error_measures(H1.bridge)$percentage

    # compute Bayes factor
    BF01 <- bf(H0.bridge, H1.bridge)

    # compute posterior model probabilities (assuming equal prior model probabilities)
    post1 <- post_prob(H0.bridge, H1.bridge)

    # compute posterior model probabilities (using user-specified prior model probabilities)
    post2 <- post_prob(H0.bridge, H1.bridge, prior_prob = c(.6, .4))

    # "exact" ml H1
    mH1 <- function(data, rel.tol = 1e-10) {

      y <- data$y
      n <- data$n
      mu0 <- data$mu0
      tau20 <- data$tau20
      alpha <- data$alpha
      beta <- data$beta
      sigma2 <- data$sigma2

      mH1integrand <- function(tau2, y, sigma2, mu0, tau20, alpha, beta) {

        (sigma2 + tau2)^(-n/2) *
          exp(-1/2 * ((n*mean(y)^2 + (n - 1)*sd(y)^2)/(sigma2 + tau2) +
                        mu0^2/tau20 - ((n*mean(y))/(sigma2 + tau2) +
                                         mu0/tau20)^2 /
                        (n/(sigma2 + tau2) + 1/tau20))) *
          (n/(sigma2 + tau2) + 1/tau20)^(-1/2) * tau2^(-alpha - 1) *
          exp(-beta/tau2)

      }

      (2*pi)^(-n/2) * (tau20)^(-1/2) * beta^alpha/gamma(alpha) *
        integrate(mH1integrand, 0, Inf,
                  rel.tol = rel.tol, y = y,
                  sigma2 = sigma2, mu0 = mu0,
                  tau20 = tau20, alpha = alpha,
                  beta = beta)$value

    }

    exact_logmlH1 <- log(mH1(list(y = y, n = n,
                                  mu0 = mu0,
                                  tau20 = tau20,
                                  alpha = alpha,
                                  beta = beta,
                                  sigma2 = sigma2)))

    # "exact" ml H1
    mH0 <- function(data, rel.tol = 1e-10) {

      y <- data$y
      n <- data$n
      alpha <- data$alpha
      beta <- data$beta
      sigma2 <- data$sigma2

      mH0integrand <- function(tau2, y, sigma2, alpha, beta) {

        n <- length(y)

        (sigma2 + tau2)^(-n/2) * exp(-(n*mean(y)^2 + (n - 1)*sd(y)^2)/
                                       (2*(sigma2 + tau2))) *
          tau2^(-alpha - 1) * exp(-beta/tau2)

      }

      (2*pi)^(-n/2) * beta^alpha/gamma(alpha) *
        integrate(mH0integrand, 0, Inf, rel.tol = rel.tol,
                  y = y, sigma2 = sigma2, alpha = alpha,
                  beta = beta)$value

    }

    exact_logmlH0 <- log(mH0(list(y = y, n = n,
                                  alpha = alpha,
                                  beta = beta,
                                  sigma2 = sigma2)))

    exact_BF01 <- exp(exact_logmlH0 - exact_logmlH1)

    H0.bridge.curr <- H0.bridge
    H1.bridge.curr <- H1.bridge
    BF01.curr <- BF01
    post1.curr <- post1
    post2.curr <- post2

    # load(system.file("extdata/", "vignette_example_nimble.RData",
    #                  package = "bridgesampling"))

    expect_equal(
      H0.bridge.curr$logml,
      expected = exact_logmlH0,
      tolerance = 0.01
    )
    expect_equal(
      H1.bridge.curr$logml,
      expected = exact_logmlH1,
      tolerance = 0.01
    )
    expect_equal(
      BF01.curr$bf,
      expected = exact_BF01,
      tolerance = 0.01
    )
    expect_equal(
      H0.bridge.curr$logml,
      expected = H0.bridge$logml,
      tolerance = 0.01
    )
    expect_equal(
      H1.bridge.curr$logml,
      expected = H1.bridge$logml,
      tolerance = 0.01
    )
    expect_equal(
      BF01.curr$bf,
      expected = BF01$bf,
      tolerance = 0.01
    )
    expect_equal(
      post1.curr,
      expected = post1,
      tolerance = 0.01
    )
    expect_equal(
      post2.curr,
      expected = post2,
      tolerance = 0.01
    )

  }

})

.bridge.sampler.warp3 <- function(
  samples_4_fit, # matrix with already transformed samples for fitting the
  # proposal (rows are samples), colnames are "trans_x" where
  # x is the parameter name
  samples_4_iter, # matrix with already transformed samples for the
  # iterative scheme (rows are samples), colnames are "trans_x"
  # where x is the parameter name
  neff, # effective sample size of samples_4_iter (i.e., already transformed samples), scalar
  log_posterior,
  ...,
  data,
  lb,
  ub,
  transTypes, # types of transformations (unbounded/lower/upperbounded) for the different parameters (named character vector)
  param_types, # Sample space for transformations (real, circular, simplex)
  cores,
  repetitions,
  packages,
  varlist,
  envir,
  rcppFile,
  maxiter,
  silent,
  verbose,
  use_ess,
  r0,
  tol1,
  tol2
) {
  if (is.null(neff)) {
    neff <- nrow(samples_4_iter)
  }

  n_post <- nrow(samples_4_iter)

  # get mean & covariance matrix and generate samples from proposal
  m <- apply(samples_4_fit, 2, mean)
  V_tmp <- cov(samples_4_fit)
  V <- as.matrix(nearPD(V_tmp)$mat) # make sure that V is positive-definite
  L <- t(chol(V))

  # sample from multivariate normal distribution and evaluate for posterior samples and generated samples
  q12 <- dmvnorm(
    (samples_4_iter -
      matrix(m, nrow = n_post, ncol = length(m), byrow = TRUE)) %*%
      t(solve(L)),
    sigma = diag(ncol(samples_4_fit)),
    log = TRUE
  )
  q22 <- vector(mode = "list", length = repetitions)
  gen_samples <- vector(mode = "list", length = repetitions)
  for (i in seq_len(repetitions)) {
    gen_samples[[i]] <- rmvnorm(n_post, sigma = diag(ncol(samples_4_fit)))
    colnames(gen_samples[[i]]) <- colnames(samples_4_iter)
    q22[[i]] <- dmvnorm(
      gen_samples[[i]],
      sigma = diag(ncol(samples_4_fit)),
      log = TRUE
    )
  }

  e <- as.brob(exp(1))

  # evaluate log of likelihood times prior for posterior samples and generated samples
  q21 <- vector(mode = "list", length = repetitions)
  if (cores == 1) {
    q11 <- log(
      e^(apply(
        .invTransform2Real(samples_4_iter, lb, ub, param_types),
        1,
        log_posterior,
        data = data,
        ...
      ) +
        .logJacobian(samples_4_iter, transTypes, lb, ub)) +
        e^(apply(
          .invTransform2Real(
            matrix(2 * m, nrow = n_post, ncol = length(m), byrow = TRUE) -
              samples_4_iter,
            lb,
            ub,
            param_types
          ),
          1,
          log_posterior,
          data = data,
          ...
        ) +
          .logJacobian(
            matrix(2 * m, nrow = n_post, ncol = length(m), byrow = TRUE) -
              samples_4_iter,
            transTypes,
            lb,
            ub
          ))
    )
    for (i in seq_len(repetitions)) {
      q21[[i]] <- log(
        e^(apply(
          .invTransform2Real(
            matrix(m, nrow = n_post, ncol = length(m), byrow = TRUE) -
              gen_samples[[i]] %*% t(L),
            lb,
            ub,
            param_types
          ),
          1,
          log_posterior,
          data = data,
          ...
        ) +
          .logJacobian(
            matrix(m, nrow = n_post, ncol = length(m), byrow = TRUE) -
              gen_samples[[i]] %*% t(L),
            transTypes,
            lb,
            ub
          )) +
          e^(apply(
            .invTransform2Real(
              matrix(m, nrow = n_post, ncol = length(m), byrow = TRUE) +
                gen_samples[[i]] %*% t(L),
              lb,
              ub,
              param_types
            ),
            1,
            log_posterior,
            data = data,
            ...
          ) +
            .logJacobian(
              matrix(m, nrow = n_post, ncol = length(m), byrow = TRUE) +
                gen_samples[[i]] %*% t(L),
              transTypes,
              lb,
              ub
            ))
      )
    }
  } else if (cores > 1) {
    if (.Platform$OS.type == "unix") {
      split1a <- .split_matrix(
        matrix = .invTransform2Real(samples_4_iter, lb, ub, param_types),
        cores = cores
      )
      split1b <- .split_matrix(
        matrix = .invTransform2Real(
          matrix(2 * m, nrow = n_post, ncol = length(m), byrow = TRUE) -
            samples_4_iter,
          lb,
          ub,
          param_types
        ),
        cores = cores
      )
      q11a <- parallel::mclapply(
        split1a,
        FUN = function(x) apply(x, 1, log_posterior, data = data, ...),
        mc.preschedule = FALSE,
        mc.cores = cores
      )
      q11b <- parallel::mclapply(
        split1b,
        FUN = function(x) apply(x, 1, log_posterior, data = data, ...),
        mc.preschedule = FALSE,
        mc.cores = cores
      )
      q11 <- log(
        e^(unlist(q11a) + .logJacobian(samples_4_iter, transTypes, lb, ub)) +
          e^(unlist(q11b) +
            .logJacobian(
              matrix(2 * m, nrow = n_post, ncol = length(m), byrow = TRUE) -
                samples_4_iter,
              transTypes,
              lb,
              ub
            ))
      )

      for (i in seq_len(repetitions)) {
        tmp_mat2 <- gen_samples[[i]] %*% t(L)
        split2a <- .split_matrix(
          matrix = .invTransform2Real(
            matrix(m, nrow = n_post, ncol = length(m), byrow = TRUE) - tmp_mat2,
            lb,
            ub,
            param_types
          ),
          cores = cores
        )
        split2b <- .split_matrix(
          matrix = .invTransform2Real(
            matrix(m, nrow = n_post, ncol = length(m), byrow = TRUE) + tmp_mat2,
            lb,
            ub,
            param_types
          ),
          cores = cores
        )
        q21a <- parallel::mclapply(
          split2a,
          FUN = function(x) apply(x, 1, log_posterior, data = data, ...),
          mc.preschedule = FALSE,
          mc.cores = cores
        )
        q21b <- parallel::mclapply(
          split2b,
          FUN = function(x) apply(x, 1, log_posterior, data = data, ...),
          mc.preschedule = FALSE,
          mc.cores = cores
        )
        q21[[i]] <- log(
          e^(unlist(q21a) +
            .logJacobian(
              matrix(m, nrow = n_post, ncol = length(m), byrow = TRUE) -
                tmp_mat2,
              transTypes,
              lb,
              ub
            )) +
            e^(unlist(q21b) +
              .logJacobian(
                matrix(m, nrow = n_post, ncol = length(m), byrow = TRUE) +
                  tmp_mat2,
                transTypes,
                lb,
                ub
              ))
        )
      }
    } else {
      cl <- parallel::makeCluster(cores, useXDR = FALSE)
      sapply(packages, function(x) {
        parallel::clusterCall(
          cl = cl,
          "require",
          package = x,
          character.only = TRUE
        )
      })

      parallel::clusterExport(cl = cl, varlist = varlist, envir = envir)

      if (!is.null(rcppFile)) {
        parallel::clusterExport(
          cl = cl,
          varlist = "rcppFile",
          envir = parent.frame()
        )
        parallel::clusterCall(
          cl = cl,
          "require",
          package = "Rcpp",
          character.only = TRUE
        )
        parallel::clusterEvalQ(cl = cl, Rcpp::sourceCpp(file = rcppFile))
      } else if (is.character(log_posterior)) {
        parallel::clusterExport(cl = cl, varlist = log_posterior, envir = envir)
      }

      q11 <- log(
        e^(parallel::parRapply(
          cl = cl,
          x = .invTransform2Real(samples_4_iter, lb, ub, param_types),
          log_posterior,
          data = data,
          ...
        ) +
          .logJacobian(samples_4_iter, transTypes, lb, ub)) +
          e^(parallel::parRapply(
            cl = cl,
            x = .invTransform2Real(
              matrix(2 * m, nrow = n_post, ncol = length(m), byrow = TRUE) -
                samples_4_iter,
              lb,
              ub,
              param_types
            ),
            log_posterior,
            data = data,
            ...
          ) +
            .logJacobian(
              matrix(2 * m, nrow = n_post, ncol = length(m), byrow = TRUE) -
                samples_4_iter,
              transTypes,
              lb,
              ub
            ))
      )
      for (i in seq_len(repetitions)) {
        q21[[i]] <- log(
          e^(parallel::parRapply(
            cl = cl,
            x = .invTransform2Real(
              matrix(m, nrow = n_post, ncol = length(m), byrow = TRUE) -
                gen_samples[[i]] %*% t(L),
              lb,
              ub,
              param_types
            ),
            log_posterior,
            data = data,
            ...
          ) +
            .logJacobian(
              matrix(m, nrow = n_post, ncol = length(m), byrow = TRUE) -
                gen_samples[[i]] %*% t(L),
              transTypes,
              lb,
              ub
            )) +
            e^(parallel::parRapply(
              cl = cl,
              x = .invTransform2Real(
                matrix(m, nrow = n_post, ncol = length(m), byrow = TRUE) +
                  gen_samples[[i]] %*% t(L),
                lb,
                ub,
                param_types
              ),
              log_posterior,
              data = data,
              ...
            ) +
              .logJacobian(
                matrix(m, nrow = n_post, ncol = length(m), byrow = TRUE) +
                  gen_samples[[i]] %*% t(L),
                transTypes,
                lb,
                ub
              ))
        )
      }
      parallel::stopCluster(cl)
    }
  }
  if (any(is.infinite(q11))) {
    warning(
      sum(is.infinite(q11)),
      " of the ",
      length(q11),
      " log_prob() evaluations on the warp-transformed posterior draws produced -Inf/Inf.",
      call. = FALSE
    )
  }
  for (i in seq_len(repetitions)) {
    if (any(is.infinite(q21[[i]]))) {
      warning(
        sum(is.infinite(q21[[i]])),
        " of the ",
        length(q21[[i]]),
        " log_prob() evaluations on the warp-transformed proposal draws produced -Inf/Inf.",
        call. = FALSE
      )
    }
  }
  if (any(is.na(q11))) {
    warning(
      sum(is.na(q11)),
      " evaluation(s) of log_prob() on the warp-transformed posterior draws produced NA and have been replaced by -Inf.",
      call. = FALSE
    )
    q11[is.na(q11)] <- -Inf
  }
  for (i in seq_len(repetitions)) {
    if (any(is.na(q21[[i]]))) {
      warning(
        sum(is.na(q21[[i]])),
        " evaluation(s) of log_prob() on the warp-transformed proposal draws produced NA nd have been replaced by -Inf.",
        call. = FALSE
      )
      q21[[i]][is.na(q21[[i]])] <- -Inf
    }
  }
  if (verbose) {
    print("summary(q12): (log_dens of proposal for posterior samples)")
    print(summary(q12))
    print("summary(q22): (log_dens of proposal for generated samples)")
    print(lapply(q22, summary))
    print("summary(q11): (log_dens of posterior for posterior samples)")
    print(summary(q11))
    print("summary(q21): (log_dens of posterior for generated samples)")
    print(lapply(q21, summary))
  }

  logml <- numeric(repetitions)
  niter <- numeric(repetitions)
  mcse_logmls <- numeric(repetitions)
  # run iterative updating scheme to compute log of marginal likelihood
  for (i in seq_len(repetitions)) {
    tmp <- .run.iterative.scheme(
      q11 = q11,
      q12 = q12,
      q21 = q21[[i]],
      q22 = q22[[i]],
      r0 = r0,
      tol = tol1,
      L = L,
      method = "warp3",
      maxiter = maxiter,
      silent = silent,
      criterion = "r",
      neff = neff,
      use_ess = use_ess
    )
    if (is.na(tmp$logml) & !is.null(tmp$r_vals)) {
      warning(
        "logml could not be estimated within maxiter, rerunning with adjusted starting value. \nEstimate might be more variable than usual.",
        call. = FALSE
      )
      lr <- length(tmp$r_vals)
      # use geometric mean as starting value
      r0_2 <- sqrt(tmp$r_vals[[lr - 1]] * tmp$r_vals[[lr]])
      tmp <- .run.iterative.scheme(
        q11 = q11,
        q12 = q12,
        q21 = q21[[i]],
        q22 = q22[[i]],
        r0 = r0_2,
        tol = tol2,
        L = L,
        method = "warp3",
        maxiter = maxiter,
        silent = silent,
        criterion = "logml",
        neff = neff,
        use_ess = use_ess
      )
      tmp$niter <- maxiter + tmp$niter
    }

    logml[i] <- tmp$logml
    niter[i] <- tmp$niter
    mcse_logmls[i] <- tmp$mcse_logml
    if (niter[i] == maxiter) {
      warning(
        "logml could not be estimated within maxiter, returning NA.",
        call. = FALSE
      )
    }
  }

  if (repetitions == 1) {
    out <- list(
      logml = logml,
      niter = niter,
      method = "warp3",
      q11 = q11,
      q12 = q12,
      q21 = q21[[1]],
      q22 = q22[[1]],
      mcse_logml = mcse_logmls
    )
    class(out) <- "bridge"
  } else if (repetitions > 1) {
    out <- list(
      logml = logml,
      niter = niter,
      method = "warp3",
      repetitions = repetitions,
      mcse_logml = mcse_logmls
    )
    class(out) <- "bridge_list"
  }

  return(out)
}

.bridge.sampler.normal <- function(
  samples_4_fit, # matrix with already transformed samples for fitting the
                 # proposal (rows are samples), colnames are "trans_x" where
                 # x is the parameter name
  samples_4_iter, # matrix with already transformed samples for the
                  # iterative scheme (rows are samples), colnames are "trans_x"
                  # where x is the parameter name
  neff, # effective sample size of samples_4_iter (i.e., already transformed samples), scalar
  log_posterior,
  ...,
  data,
  lb, ub,
  transTypes, # types of transformations (unbounded/lower/upperbounded) for the different parameters (named character vector)
  param_types, # Sample space for transformations (real, circular, simplex)
  cores,
  repetitions,
  packages,
  varlist,
  envir,
  rcppFile,
  maxiter,
  silent,
  verbose,
  r0,
  tol1,
  tol2) {

  if (is.null(neff))
    neff <- nrow(samples_4_iter)

  n_post <- nrow(samples_4_iter)

  # get mean & covariance matrix and generate samples from proposal
  m <- apply(samples_4_fit, 2, mean)
  V_tmp <- cov(samples_4_fit)
  V <- as.matrix(nearPD(V_tmp)$mat) # make sure that V is positive-definite

  # sample from multivariate normal distribution and evaluate for posterior samples and generated samples
  q12 <- dmvnorm(samples_4_iter, mean = m, sigma = V, log = TRUE)
  gen_samples <- vector(mode = "list", length = repetitions)
  q22 <- vector(mode = "list", length = repetitions)
  for (i in seq_len(repetitions)) {
    gen_samples[[i]] <- rmvnorm(n_post, mean = m, sigma = V)
    colnames(gen_samples[[i]]) <- colnames(samples_4_iter)
    q22[[i]] <- dmvnorm(gen_samples[[i]], mean = m, sigma = V, log = TRUE)
  }

  # evaluate log of likelihood times prior for posterior samples and generated samples
  q21 <- vector(mode = "list", length = repetitions)
  if (cores == 1) {
    q11 <- apply(.invTransform2Real(samples_4_iter, lb, ub, param_types), 1, log_posterior,
                 data = data, ...) + .logJacobian(samples_4_iter, transTypes, lb, ub)
    for (i in seq_len(repetitions)) {
      q21[[i]] <- apply(.invTransform2Real(gen_samples[[i]], lb, ub, param_types), 1, log_posterior,
                        data = data, ...) + .logJacobian(gen_samples[[i]], transTypes, lb, ub)
    }
  } else if (cores > 1) {
    if ( .Platform$OS.type == "unix") {
      split1 <- .split_matrix(matrix=.invTransform2Real(samples_4_iter, lb, ub, param_types), cores=cores)
      q11 <- parallel::mclapply(split1, FUN =
                                  function(x) apply(x, 1, log_posterior, data = data, ...),
                                  mc.preschedule = FALSE,
                                  mc.cores = cores)
      q11 <- unlist(q11) + .logJacobian(samples_4_iter, transTypes, lb, ub)
      for (i in seq_len(repetitions)) {
        split2 <- .split_matrix(matrix=.invTransform2Real(gen_samples[[i]], lb, ub, param_types), cores = cores)
        q21[[i]] <- parallel::mclapply(split2, FUN =
                                  function(x) apply(x, 1, log_posterior, data = data, ...),
                                  mc.preschedule = FALSE,
                                  mc.cores = cores)
        q21[[i]] <- unlist(q21[[i]]) + .logJacobian(gen_samples[[i]], transTypes, lb, ub)
      }
    } else {
    cl <- parallel::makeCluster(cores, useXDR = FALSE)
    sapply(packages, function(x) parallel::clusterCall(cl = cl, "require", package = x,
                                                       character.only = TRUE))
    parallel::clusterExport(cl = cl, varlist = varlist, envir = envir)

    if ( ! is.null(rcppFile)) {
      parallel::clusterExport(cl = cl, varlist = "rcppFile", envir = parent.frame())
      parallel::clusterCall(cl = cl, "require", package = "Rcpp", character.only = TRUE)
      parallel::clusterEvalQ(cl = cl, Rcpp::sourceCpp(file = rcppFile))
    } else if (is.character(log_posterior)) {
      parallel::clusterExport(cl = cl, varlist = log_posterior, envir = envir)
    }

    q11 <- parallel::parRapply(cl = cl, x = .invTransform2Real(samples_4_iter, lb, ub, param_types), log_posterior,
                               data = data, ...) + .logJacobian(samples_4_iter, transTypes, lb, ub)
    for (i in seq_len(repetitions)) {
      q21[[i]] <- parallel::parRapply(cl = cl, x = .invTransform2Real(gen_samples[[i]], lb, ub, param_types), log_posterior,
                                      data = data, ...) + .logJacobian(gen_samples[[i]], transTypes, lb, ub)
    }
    parallel::stopCluster(cl)
    }
  }
  if(verbose) {
    print("summary(q12): (log_dens of proposal (i.e., with dmvnorm) for posterior samples)")
    print(summary(q12))
    print("summary(q22): (log_dens of proposal (i.e., with dmvnorm) for generated samples)")
    print(lapply(q22, summary))
    print("summary(q11): (log_dens of posterior (i.e., with log_posterior) for posterior samples)")
    print(summary(q11))
    print("summary(q21): (log_dens of posterior (i.e., with log_posterior) for generated samples)")
    print(lapply(q21, summary))
    .PROPOSALS <- vector("list", repetitions)
    # for (i in seq_len(repetitions)) {
    #   .PROPOSALS[[i]] <- .invTransform2Real(gen_samples[[i]], lb, ub, param_types)
    # }
    # assign(".PROPOSALS", .PROPOSALS, pos = .GlobalEnv)
    # message("All proposal samples written to .GlobalEnv as .PROPOSALS")
  }
  if (any(is.infinite(q11))) {
    warning(sum(is.infinite(q11)), " of the ", length(q11)," log_prob() evaluations on the posterior draws produced -Inf/Inf.", call. = FALSE)
  }
  for (i in seq_len(repetitions)) {
    if (any(is.infinite(q21[[i]]))) {
      warning(sum(is.infinite(q21[[i]])), " of the ", length(q21[[i]])," log_prob() evaluations on the proposal draws produced -Inf/Inf.", call. = FALSE)
    }
  }
  if (any(is.na(q11))) {
    warning(sum(is.na(q11)), " evaluation(s) of log_prob() on the posterior draws produced NA and have been replaced by -Inf.", call. = FALSE)
    q11[is.na(q11)] <- -Inf
  }
  for (i in seq_len(repetitions)) {
    if (all(is.na(q21[[i]]))) {
      stop("Evaluations of log_prob() on all proposal draws produced NA.\n",
           "E.g., rounded to 3 digits (use verbose = TRUE for all proposal samples):\n",
           deparse(round(
             .invTransform2Real(gen_samples[[i]], lb, ub, param_types)[1,],
             3), width.cutoff = 500L),
           call. = FALSE)
    }
    if (any(is.na(q21[[i]]))) {
      warning(sum(is.na(q21[[i]])), " evaluation(s) of log_prob() on the proposal draws produced NA and have been replaced by -Inf.", call. = FALSE)
      q21[[i]][is.na(q21[[i]])] <- -Inf
    }
  }
  logml <- numeric(repetitions)
  niter <- numeric(repetitions)
  # run iterative updating scheme to compute log of marginal likelihood
  for (i in seq_len(repetitions)) {
    tmp <- .run.iterative.scheme(q11 = q11, q12 = q12, q21 = q21[[i]], q22 = q22[[i]],
                                 r0 = r0, tol = tol1, L = NULL, method = "normal",
                                 maxiter = maxiter, silent = silent,
                                 criterion = "r", neff = neff)
    if (is.na(tmp$logml) & !is.null(tmp$r_vals)) {
      warning("logml could not be estimated within maxiter, rerunning with adjusted starting value. \nEstimate might be more variable than usual.", call. = FALSE)
      lr <- length(tmp$r_vals)
      # use geometric mean as starting value
      r0_2 <- sqrt(tmp$r_vals[[lr - 1]] * tmp$r_vals[[lr]])
      tmp <- .run.iterative.scheme(q11 = q11, q12 = q12, q21 = q21[[i]], q22 = q22[[i]],
                                   r0 = r0_2, tol = tol2, L = NULL, method = "normal",
                                   maxiter = maxiter, silent = silent,
                                   criterion = "logml", neff = neff)
      tmp$niter <- maxiter + tmp$niter
    }

    logml[i] <- tmp$logml
    niter[i] <- tmp$niter
    if (niter[i] == maxiter)
      warning("logml could not be estimated within maxiter, returning NA.", call. = FALSE)
  }

  if (repetitions == 1) {
    out <- list(logml = logml, niter = niter, method = "normal", q11 = q11,
                q12 = q12, q21 = q21[[1]], q22 = q22[[1]])
    class(out) <- "bridge"
  } else if (repetitions > 1) {
    out <- list(logml = logml, niter = niter, method = "normal", repetitions = repetitions)
    class(out) <- "bridge_list"
  }

  return(out)

}

#--------------------------------------------------------------------------
# functions for Stan support via rstan
#--------------------------------------------------------------------------

# taken from rstan:
.rstan_relist <- function(x, skeleton) {
  lst <- utils::relist(x, skeleton)
  for (i in seq_along(skeleton)) {
    dim(lst[[i]]) <- dim(skeleton[[i]])
  }
  lst
}

# taken from rstan:
.create_skeleton <- function(pars, dims) {
  lst <- lapply(seq_along(pars), function(i) {
    len_dims <- length(dims[[i]])
    if (len_dims < 1) {
      return(0)
    }
    return(array(0, dim = dims[[i]]))
  })
  names(lst) <- pars
  lst
}

.stan_log_posterior <- function(s.row, data) {
  out <- tryCatch(
    rstan::log_prob(object = data$stanfit, upars = s.row),
    error = function(e) -Inf
  )
  if (is.na(out)) {
    out <- -Inf
  }
  return(out)
}

.cmdstan_log_posterior <- function(s.row, data) {
  if ("lp__" %in% names(s.row)) {
    s.row <- s.row[!names(s.row) %in% "lp__"]
  }

  if (!is.numeric(s.row)) {
    s.row <- as.numeric(s.row)
  }
  out <- tryCatch(
    {
      log_prob <- data$log_prob(s.row, jacobian = TRUE)
      log_prob
    },
    error = function(e) {
      print(e)
      -Inf
    }
  )

  if (is.na(out)) {
    out <- -Inf
  }
  result <- data.frame(matrix(s.row, nrow = 1))
  result$log_posterior <- out

  return(out)
}

#' Generic function that computes posterior model probabilities from marginal
#' likelihoods.
#' @export
#' @title Posterior Model Probabilities from Marginal Likelihoods
#' @param x Object of class \code{"bridge"} or \code{"bridge_list"} as returned
#'   from \code{\link{bridge_sampler}}. Additionally, the default method assumes
#'   that all passed objects are numeric log marginal likelihoods (e.g., from
#'   \code{\link{logml}}) and will throw an error otherwise.
#' @param ... further objects of class \code{"bridge"} or \code{"bridge_list"}
#'   as returned from \code{\link{bridge_sampler}}. Or numeric values for the
#'   default method.
#' @param prior_prob numeric vector with prior model probabilities. If omitted,
#'   a uniform prior is used (i.e., all models are equally likely a priori). The
#'   default \code{NULL} corresponds to equal prior model weights.
#' @param model_names If \code{NULL} (the default) will use model names derived
#'   from deparsing the call. Otherwise will use the passed values as model
#'   names.
#'
#' @return For the default method and the method for \code{"bridge"} objects, a
#'   named numeric vector with posterior model probabilities (i.e., which sum to
#'   one).
#'
#'   For the method for \code{"bridge_list"} objects, a matrix consisting of
#'   posterior model probabilities where each row sums to one and gives the
#'   model probabilities for one set of logmls. The (named) columns correspond
#'   to the models and the number of rows is given by the \code{"bridge_list"}
#'   element with the most \code{repetitions}. Elements with fewer repetitions
#'   will be recycled (with warning).
#' @author Quentin F. Gronau and Henrik Singmann
#' @note For realistic examples, see \code{\link{bridge_sampler}} and the
#'   accompanying vignettes: \cr \code{vignette("bridgesampling_example_jags")}
#'   \cr \code{vignette("bridgesampling_example_stan")}
#' @example examples/example.post_prob.R
#' @importFrom methods is
post_prob <- function(x, ..., prior_prob = NULL, model_names = NULL) {
  UseMethod("post_prob", x)
}

#' @rdname post_prob
#' @export
post_prob.bridge <- function(x, ..., prior_prob = NULL, model_names = NULL) {
  dots <- list(...)
  mc <- match.call()
  modb <- vapply(dots, inherits, NA, what = c("bridge", "bridge_list"))
  if (is.null(model_names)) {
    model_names <- c(
      deparse(mc[["x"]]),
      vapply(which(modb), function(x) deparse(mc[[x + 2]]), "")
    )
  }
  if (sum(modb) == 0) {
    stop(
      "Only one object of class 'bridge' or 'bridge_list' passed.",
      call. = FALSE
    )
  }
  if (sum(modb) != length(dots)) {
    warning(
      "Objects not of class 'bridge' or 'bridge_list' are ignored.",
      call. = FALSE
    )
  }

  logml <- vapply(c(list(x), dots[modb]), logml, FUN.VALUE = 0)

  .post_prob_calc(
    logml = logml,
    model_names = model_names,
    prior_prob = prior_prob
  )
}


#' @rdname post_prob
#' @export
post_prob.bridge_list <- function(
  x,
  ...,
  prior_prob = NULL,
  model_names = NULL
) {
  dots <- list(...)
  mc <- match.call()
  modb <- vapply(dots, inherits, NA, what = c("bridge", "bridge_list"))
  if (is.null(model_names)) {
    model_names <- c(
      deparse(mc[["x"]]),
      vapply(which(modb), function(x) deparse(mc[[x + 2]]), "")
    )
  }
  if (sum(modb) == 0) {
    stop(
      "Only one object of class 'bridge' or 'bridge_list' passed.",
      call. = FALSE
    )
  }
  if (sum(modb) != length(dots)) {
    warning(
      "Objects not of class 'bridge' or 'bridge_list' are ignored.",
      call. = FALSE
    )
  }

  logml <- lapply(c(list(x), dots[modb]), "[[", i = "logml")
  len <- vapply(logml, length, FUN.VALUE = 0)
  if (!all(len == max(len))) {
    warning(
      "Not all objects provide ",
      max(len),
      " logmls. Some values are recycled.",
      call. = FALSE
    )
    logml <- lapply(logml, function(x) rep(x, length.out = max(len)))
  }
  t(apply(
    as.data.frame(logml),
    1,
    .post_prob_calc,
    model_names = model_names,
    prior_prob = prior_prob
  ))
}

#' @rdname post_prob
#' @export
post_prob.default <- function(x, ..., prior_prob = NULL, model_names = NULL) {
  dots <- list(...)
  mc <- match.call()
  if (is.null(model_names)) {
    model_names <- c(
      rep(deparse(mc[["x"]]), length(x)),
      rep(
        vapply(seq_along(dots), function(x) deparse(mc[[x + 2]]), ""),
        times = vapply(dots, length, 0)
      )
    )
  }
  logml <- c(x, unlist(dots))
  if (!is.numeric(logml)) {
    stop("logml values need to be numeric", call. = FALSE)
  }
  .post_prob_calc(
    logml = logml,
    model_names = model_names,
    prior_prob = prior_prob
  )
}

.post_prob_calc <- function(logml, model_names, prior_prob) {
  e <- as.brob(exp(1))

  if (is.null(prior_prob)) {
    prior_prob <- rep(1 / length(logml), length(logml))
  }

  if (!isTRUE(all.equal(sum(prior_prob), 1))) {
    stop("Prior model probabilities do not sum to one.", call. = FALSE)
  }

  if (length(logml) != length(prior_prob)) {
    stop(
      "Number of objects/logml-values needs to match number of elements in prior_prob.",
      call. = FALSE
    )
  }

  if (any(is.na(logml))) {
    post_prob <- rep(NA_real_, length(logml))
    warning(
      "NAs in logml values. No posterior probabilities calculated.",
      call. = FALSE
    )
  } else {
    post_prob <- as.numeric(e^logml * prior_prob / sum(e^logml * prior_prob))
    if (!isTRUE(all.equal(sum(post_prob), 1))) {
      warning("Posterior model probabilities do not sum to one.", call. = FALSE)
    }
  }
  names(post_prob) <- make.unique(as.character(model_names))

  return(post_prob)
}

#' Standardized International Exchange Rate Changes from 1975 to 1986
#'
#' This data set contains the changes in monthly international exchange rates for pounds sterling from January 1975 to December 1986 obtained from West and Harrison (1997, pp. 612-615). Currencies tracked are US Dollar (column \code{us_dollar}), Canadian Dollar (column \code{canadian_dollar}), Japanese Yen (column \code{yen}), French Franc (column \code{franc}), Italian Lira (column \code{lira}), and the (West) German Mark (column \code{mark}). Each series has been standardized with respect to its sample mean and standard deviation.
#'
#' @docType data
#' @keywords dataset
#' @name ier
#' @usage ier
#' @format A matrix with 143 rows and 6 columns.
#' @source West, M., Harrison, J. (1997). \emph{Bayesian forecasting and dynamic models} (2nd ed.). Springer-Verlag, New York.
#'
#' Lopes, H. F., West, M. (2004). Bayesian model assessment in factor analysis. \emph{Statistica Sinica, 14}, 41-67.
#' @encoding UTF-8
#'
#' @example examples/example.ier.R
NULL

#' Methods for bridge and bridge_list objects
#'
#' Methods defined for objects returned from the generic \code{\link{bridge_sampler}} function.
#'
#' @param object,x object of class \code{bridge} or \code{bridge_list} as returned from \code{\link{bridge_sampler}}.
#' @param na.rm logical. Should NA estimates in \code{bridge_list} objects be removed? Passed to \code{\link{error_measures}}.
#' @param ... further arguments, currently ignored.
#'
#' @return
#' The \code{summary} methods return a \code{data.frame} which contains the log marginal likelihood plus the result returned from invoking \code{\link{error_measures}}.
#'
#' The \code{print} methods simply print and return nothing.
#'
#'
#' @name bridge-methods
NULL


# summary methods

#' @rdname bridge-methods
#' @method summary bridge
#' @export
summary.bridge <- function(object, na.rm = TRUE, ...) {
  if (!(object$method %in% c("normal", "warp3"))) {
    stop('object$method needs to be either "normal" or "warp3".', call. = FALSE)
  }

  if (object$method == "normal") {
    em <- error_measures(object)
    out <- data.frame(
      "Logml_Estimate" = object$logml,
      "Relative_Mean_Squared_Error" = em$re2,
      "Coefficient_of_Variation" = em$cv,
      "Percentage_Error" = em$percentage,
      "Method" = object$method,
      "Repetitions" = 1,
      stringsAsFactors = FALSE
    )
  } else if (object$method == "warp3") {
    out <- data.frame(
      "Logml_Estimate" = object$logml,
      "Method" = object$method,
      "Repetitions" = 1
    )
  }

  class(out) <- c("summary.bridge", "data.frame")
  return(out)
}

#' @rdname bridge-methods
#' @method summary bridge_list
#' @export
summary.bridge_list <- function(object, na.rm = TRUE, ...) {
  if (!(object$method %in% c("normal", "warp3"))) {
    stop('object$method needs to be either "normal" or "warp3".', call. = FALSE)
  }

  em <- error_measures(object, na.rm = na.rm)
  out <- data.frame(
    "Logml_Estimate" = median(object$logml, na.rm = na.rm),
    "Min" = em$min,
    "Max" = em$max,
    "Interquartile_Range" = em$IQR,
    "Method" = object$method,
    "Repetitions" = object$repetitions
  )

  class(out) <- c("summary.bridge_list", "data.frame")
  return(out)
}

# print summary methods

#' @rdname bridge-methods
#' @method print summary.bridge
#' @export
print.summary.bridge <- function(x, ...) {
  if (x[["Method"]] == "normal") {
    cat(
      '\nBridge sampling log marginal likelihood estimate \n(method = "',
      as.character(x[["Method"]]),
      '", repetitions = ',
      x[["Repetitions"]],
      '):\n\n ',
      x[["Logml_Estimate"]],
      '\n\nError Measures:\n\n Relative Mean-Squared Error: ',
      x[["Relative_Mean_Squared_Error"]],
      '\n Coefficient of Variation: ',
      x[["Coefficient_of_Variation"]],
      '\n Percentage Error: ',
      x[["Percentage_Error"]],
      '\n\nNote:\nAll error measures are approximate.\n\n',
      sep = ""
    )
  } else if (x[["Method"]] == "warp3") {
    cat(
      '\nBridge sampling log marginal likelihood estimate \n(method = "',
      as.character(x[["Method"]]),
      '", repetitions = ',
      x[["Repetitions"]],
      '):\n\n ',
      x[["Logml_Estimate"]],
      '\n\nNote:\nNo error measures are available for method = "warp3"',
      '\nwith repetitions = 1.',
      '\nWe recommend to run the warp3 procedure multiple times to',
      '\nassess the uncertainty of the estimate.\n\n',
      sep = ""
    )
  }
}

#' @rdname bridge-methods
#' @method print summary.bridge_list
#' @export
print.summary.bridge_list <- function(x, ...) {
  cat(
    '\nBridge sampling log marginal likelihood estimate \n(method = "',
    as.character(x[["Method"]]),
    '", repetitions = ',
    x[["Repetitions"]],
    '):\n\n ',
    x[["Logml_Estimate"]],
    '\n\nError Measures:\n\n Min: ',
    x[["Min"]],
    '\n Max: ',
    x[["Max"]],
    '\n Interquartile Range: ',
    x[["Interquartile_Range"]],
    '\n\nNote:\nAll error measures are based on ',
    x[["Repetitions"]],
    ' estimates.\n\n',
    sep = ""
  )
}

# print methods

#' @rdname bridge-methods
#' @method print bridge
#' @export
print.bridge <- function(x, ...) {
  cat(
    "Bridge sampling estimate of the log marginal likelihood: ",
    round(x$logml, 5),
    "\nEstimate obtained in ",
    x$niter,
    " iteration(s) via method \"",
    x$method,
    "\".\n",
    sep = ""
  )
}

#' @rdname bridge-methods
#' @method print bridge_list
#' @export
print.bridge_list <- function(x, na.rm = TRUE, ...) {
  cat(
    "Median of ",
    x$repetitions,
    " bridge sampling estimates\nof the log marginal likelihood: ",
    round(median(x$logml, na.rm = na.rm), 5),
    "\nRange of estimates: ",
    round(range(x$logml, na.rm = na.rm)[1], 5),
    " to ",
    round(range(x$logml, na.rm = na.rm)[2], 5),
    "\nInterquartile range: ",
    round(stats::IQR(x$logml, na.rm = na.rm), 5),
    "\nMethod: ",
    x$method,
    "\n",
    sep = ""
  )
  if (any(is.na(x$logml))) {
    warning(
      sum(is.na(x$logml)),
      " bridge sampling estimate(s) are NAs.",
      call. = FALSE
    )
  }
}

#' Generic function that computes Bayes factor(s) from marginal likelihoods. \code{bayes_factor()} is simply an (S3 generic) alias for \code{bf()}.
#' @export
#' @title Bayes Factor(s) from Marginal Likelihoods
#' @param x1 Object of class \code{"bridge"} or \code{"bridge_list"} as returned from \code{\link{bridge_sampler}}. Additionally, the default method assumes that \code{x1} is a single numeric log marginal likelihood (e.g., from \code{\link{logml}}) and will throw an error otherwise.
#' @param x2 Object of class \code{"bridge"} or \code{"bridge_list"} as returned from \code{\link{bridge_sampler}}. Additionally, the default method assumes that \code{x2} is a single numeric log marginal likelihood (e.g., from \code{\link{logml}}) and will throw an error otherwise.
#' @param log Boolean. If \code{TRUE}, the function returns the log of the Bayes factor. Default is \code{FALSE}.
#' @param ... currently not used here, but can be used by other methods.
#' @details Computes the Bayes factor (Kass & Raftery, 1995) in favor of the model associated with \code{x1} over the model associated with \code{x2}.
#' @return For the default method returns a list of class \code{"bf_default"} with components:
#' \itemize{
#'  \item \code{bf}: (scalar) value of the Bayes factor in favor of the model associated with \code{x1} over the model associated with \code{x2}.
#'  \item \code{log}: Boolean which indicates whether \code{bf} corresponds to the log Bayes factor.
#' }
#'
#'
#' For the method for \code{"bridge"} objects returns a list of class \code{"bf_bridge"} with components:
#' \itemize{
#'  \item \code{bf}:  (scalar) value of the Bayes factor in favor of the model associated with \code{x1} over the model associated with \code{x2}.
#'  \item \code{log}: Boolean which indicates whether \code{bf} corresponds to the log Bayes factor.
#' }
#'
#'
#' For the method for \code{"bridge_list"} objects returns a list of class \code{"bf_bridge_list"} with components:
#' \itemize{
#'  \item \code{bf}:  a numeric vector consisting of Bayes factors where each element gives the Bayes factor for one set of logmls in favor of the model associated with \code{x1} over the model associated with \code{x2}. The length of this vector is given by the \code{"bridge_list"} element with the most \code{repetitions}. Elements with fewer repetitions will be recycled (with warning).
#'  \item \code{bf_median_based}: (scalar) value of the Bayes factor in favor of the model associated with \code{x1} over the model associated with \code{x2} that is based on the median values of the logml estimates.
#'  \item \code{log}: Boolean which indicates whether \code{bf} corresponds to the log Bayes factor.
#' }
#' @author Quentin F. Gronau
#' @note For examples, see \code{\link{bridge_sampler}} and the accompanying vignettes: \cr \code{vignette("bridgesampling_example_jags")} \cr \code{vignette("bridgesampling_example_stan")}
#' @references
#' Kass, R. E., & Raftery, A. E. (1995). Bayes factors. \emph{Journal of the American Statistical Association, 90(430)}, 773-795. \doi{10.1080/01621459.1995.10476572}
#' @importFrom methods is
bf <- function(x1, x2, log = FALSE, ...) {
  UseMethod("bf", x1)
}

#' @rdname bf
#' @export
bayes_factor <- function(x1, x2, log = FALSE, ...) {
  UseMethod("bayes_factor", x1)
}


#' @rdname bf
#' @export
bayes_factor.default <- function(x1, x2, log = FALSE, ...) {
  bf(x1, x2, log = log, ...)
}


.bf_calc <- function(logml1, logml2, log) {
  bf <- logml1 - logml2
  if (!log) {
    bf <- exp(bf)
  }
  return(bf)
}

#' @rdname bf
#' @export
bf.bridge <- function(x1, x2, log = FALSE, ...) {
  if (!inherits(x2, c("bridge", "bridge_list"))) {
    stop("x2 needs to be of class 'bridge' or 'bridge_list'.", call. = FALSE)
  }
  bf <- .bf_calc(logml(x1), logml(x2), log = log)
  out <- list(bf = bf, log = log)
  class(out) <- "bf_bridge"
  try(
    {
      mc <- match.call()
      name1 <- deparse(mc[["x1"]])
      name2 <- deparse(mc[["x2"]])
      attr(out, "model_names") <- c(name1, name2)
    },
    silent = TRUE
  )
  return(out)
}


#' @rdname bf
#' @export
bf.bridge_list <- function(x1, x2, log = FALSE, ...) {
  if (!inherits(x2, c("bridge", "bridge_list"))) {
    stop("x2 needs to be of class 'bridge' or 'bridge_list'.", call. = FALSE)
  }
  logml1 <- x1$logml
  logml2 <- x2$logml
  median1 <- median(logml1, na.rm = TRUE)
  median2 <- median(logml2, na.rm = TRUE)
  len1 <- length(logml1)
  len2 <- length(logml2)
  max_len <- max(c(len1, len2))
  if (!all(c(len1, len2) == max_len)) {
    warning(
      "Not all objects provide ",
      max_len,
      " logmls. Some values are recycled.",
      call. = FALSE
    )
    logml1 <- rep(logml1, length.out = max_len)
    logml2 <- rep(logml2, length.out = max_len)
  }
  bf <- .bf_calc(logml1, logml2, log = log)
  bf_median_based <- .bf_calc(median1, median2, log = log)
  out <- list(bf = bf, bf_median_based = bf_median_based, log = log)
  class(out) <- "bf_bridge_list"
  try(
    {
      mc <- match.call()
      name1 <- deparse(mc[["x1"]])
      name2 <- deparse(mc[["x2"]])
      attr(out, "model_names") <- c(name1, name2)
    },
    silent = TRUE
  )
  return(out)
}

#' @rdname bf
#' @export
bf.default <- function(x1, x2, log = FALSE, ...) {
  if (!is.numeric(c(x1, x2))) {
    stop("logml values need to be numeric", call. = FALSE)
  }
  if (length(x1) > 1 || length(x2) > 1) {
    stop("Both logmls need to be scalar values.", call. = FALSE)
  }
  bf <- .bf_calc(x1, x2, log = log)
  out <- list(bf = bf, log = log)
  class(out) <- "bf_default"
  try(
    {
      mc <- match.call()
      name1 <- deparse(mc[["x1"]])
      name2 <- deparse(mc[["x2"]])
      attr(out, "model_names") <- c(name1, name2)
    },
    silent = TRUE
  )
  return(out)
}

######## Methods for bf objects:

#' @method print bf_bridge
#' @export
print.bf_bridge <- function(x, ...) {
  if (!is.null(attr(x, "model_names"))) {
    model_names <- attr(x, "model_names")
  } else {
    model_names <- c("x1", "x2")
  }
  cat(
    "Estimated ",
    if (x$log) "log " else NULL,
    "Bayes factor in favor of ",
    model_names[1],
    " over ",
    model_names[2],
    ": ",
    formatC(x$bf, digits = 5, format = "f"),
    "\n",
    sep = ""
  )
}

#' @method print bf_bridge_list
#' @export
print.bf_bridge_list <- function(x, na.rm = TRUE, ...) {
  if (!is.null(attr(x, "model_names"))) {
    model_names <- attr(x, "model_names")
  } else {
    model_names <- c("x1", "x2")
  }
  cat(
    "Estimated ",
    if (x$log) "log " else NULL,
    "Bayes factor (based on medians of log marginal likelihood estimates)\n",
    " in favor of ",
    model_names[1],
    " over ",
    model_names[2],
    ": ",
    formatC(x$bf_median_based, digits = 5, format = "f"),
    "\nRange of estimates: ",
    formatC(range(x$bf, na.rm = na.rm)[1], digits = 5, format = "f"),
    " to ",
    formatC(range(x$bf, na.rm = na.rm)[2], digits = 5, format = "f"),
    "\nInterquartile range: ",
    formatC(stats::IQR(x$bf, na.rm = na.rm), digits = 5, format = "f"),
    "\n",
    sep = ""
  )
  if (any(is.na(x$bf))) {
    warning(
      sum(is.na(x$bf)),
      " log Bayes factor estimate(s) are NAs.",
      call. = FALSE
    )
  }
}

#' @method print bf_default
#' @export
print.bf_default <- function(x, ...) {
  if (!is.null(attr(x, "model_names"))) {
    model_names <- attr(x, "model_names")
  } else {
    model_names <- c("Model 1", "Model 2")
  }
  cat(
    if (x$log) "Log " else NULL,
    "Bayes factor in favor of ",
    model_names[1],
    " over ",
    model_names[2],
    ": ",
    formatC(x$bf, digits = 5, format = "f"),
    "\n",
    sep = ""
  )
}

#' Generic function that returns log marginal likelihood from bridge objects. For objects of class \code{"bridge_list"}, which contains multiple log marginal likelihoods, \code{fun} is performed on the vector and its result returned.
#' @title Log Marginal Likelihoods from Bridge Objects
#' @param x Object of class \code{"bridge"} or \code{"bridge_list"} as returned from \code{\link{bridge_sampler}}.
#' @param fun Function which returns a scalar value and is applied to the \code{logml} vector of \code{"bridge_list"} objects. Default is \code{\link{median}}.
#' @param ... Further arguments passed to \code{fun}.
#' @return scalar numeric
#' @export
logml <- function(x, ...) {
  UseMethod("logml", x)
}


#' @rdname logml
#' @export
logml.bridge <- function(x, ...) {
  x$logml
}

#' @rdname logml
#' @export
logml.bridge_list <- function(x, fun = median, ...) {
  out <- fun(x$logml, ...)
  if (length(out) != 1) {
    warning("fun returns results of length != 1, only first used.")
    out <- out[1]
  }
  out
}

# Helper function to represent circular variables (such as mean directions) as
# "gapless" numerical representations.
.gaplessCircular <- function(th) {
  # Mean direction
  md <- atan2(sum(sin(th)), sum(cos(th)))

  # Shift th so that it is unlikely to have a gap.
  ((th - md + pi) %% (2 * pi)) - pi + md
}


#### for matrix method ######

.transform2Real <- function(
  theta,
  lb,
  ub,
  theta_types = rep("real", ncol(theta))
) {
  ### transform samples to real line

  theta_t <- theta
  transTypes <- character(ncol(theta))
  cn <- colnames(theta)
  names(theta_types) <- names(transTypes) <- cn

  # Because the simplex transform must be done on all simplex parameters at
  # once, do it before the loop. This transformation follows the Stan reference
  # manual. For simplex variables, we expect one parameter less than the number
  # of weights due to the contstraint sum(simplex_theta) == 1.
  is_simplex_theta <- theta_types == "simplex"
  if (any(is_simplex_theta)) {
    # Select the simplex variables
    simplex_theta <- theta[, is_simplex_theta, drop = FALSE]

    # Simplex dimensionality
    simdim <- ncol(simplex_theta)
    cs <- cbind(
      0L,
      matrix(t(apply(simplex_theta, 1L, cumsum)), ncol = simdim)[,
        -simdim,
        drop = FALSE
      ]
    )

    # Get the break proportions.
    z_k <- (simplex_theta / (1L - cs))
    y_k <- log(z_k) -
      log(1L - z_k) +
      matrix(log(simdim:1L), nrow(theta), simdim, byrow = TRUE)

    theta_t[, is_simplex_theta] <- y_k
    transTypes[is_simplex_theta] <- "simplex"
  }

  for (i in seq_len(ncol(theta))) {
    p <- cn[i]

    if (theta_types[[p]] == "circular") {
      transTypes[[p]] <- "circular"
      theta_t[, i] <- .gaplessCircular(theta[, i])
    } else if (theta_types[[p]] == "real") {
      if (any(theta[, i] < lb[[p]])) {
        stop(
          "Parameter values (samples) cannot be smaller than lb: ",
          p,
          call. = FALSE
        )
      }
      if (any(theta[, i] > ub[[p]])) {
        stop(
          "Parameter values (samples) cannot be larger than ub: ",
          p,
          call. = FALSE
        )
      }
      if (lb[[p]] < ub[[p]] && is.infinite(lb[[p]]) && is.infinite(ub[[p]])) {
        transTypes[[p]] <- "unbounded"
        theta_t[, i] <- theta[, i]
      } else if (
        lb[[p]] < ub[[p]] && is.finite(lb[[p]]) && is.infinite(ub[[p]])
      ) {
        transTypes[[p]] <- "lower-bounded"
        theta_t[, i] <- log(theta[, i] - lb[[p]])
      } else if (
        lb[[p]] < ub[[p]] && is.infinite(lb[[p]]) && is.finite(ub[[p]])
      ) {
        transTypes[[p]] <- "upper-bounded"
        theta_t[, i] <- log(ub[[p]] - theta[, i])
      } else if (
        lb[[p]] < ub[[p]] && is.finite(lb[[p]]) && is.finite(ub[[p]])
      ) {
        transTypes[[p]] <- "double-bounded"
        theta_t[, i] <- qnorm((theta[, i] - lb[[p]]) / (ub[[p]] - lb[[p]]))

        # Finally, give an error except for simplex variables, which are already
        # transformed.
      } else if (theta_types[p] != "simplex") {
        stop(paste(
          "Could not transform parameters, possibly due to invalid",
          "lower and/or upper prior bounds."
        ))
      }
    }
  }

  colnames(theta_t) <- paste0("trans_", colnames(theta))

  return(list(theta_t = theta_t, transTypes = transTypes))
}

.invTransform2Real <- function(
  theta_t,
  lb,
  ub,
  theta_types = rep("real", ncol(theta))
) {
  ### transform transformed samples back to original scales

  theta <- theta_t
  colnames(theta) <- stringr::str_sub(colnames(theta), 7)
  cn <- colnames(theta)
  names(theta_types) <- cn

  # Because the simplex transform must be done on all simplex parameters at
  # once, do it before the loop. This transformation follows the Stan reference
  # manual. For simplex variables, we expect one parameter less than the number
  # of weights due to the contstraint sum(simplex_theta) == 1.
  is_simplex_theta <- theta_types == "simplex"
  if (any(is_simplex_theta)) {
    # Select the simplex variables
    simplex_theta <- theta_t[, is_simplex_theta, drop = FALSE]

    # Simplex dimensionality
    simdim <- ncol(simplex_theta)

    logitz <- simplex_theta -
      matrix(log(simdim:1L), nrow(theta), simdim, byrow = TRUE)
    z_k <- exp(logitz) / (1 + exp(logitz))
    x_k <- z_k

    if (simdim > 1) {
      for (k in 2:simdim) {
        x_k[, k] <- (1 - rowSums(x_k[, 1:(k - 1), drop = FALSE])) * z_k[, k]
      }
    }

    theta[, is_simplex_theta] <- x_k
  }

  # Note that the circular variables are not transformed back, because they are
  # simply a different numerical representation.
  for (i in seq_len(ncol(theta_t))) {
    p <- cn[i]

    if (theta_types[[p]] == "real") {
      if (lb[[p]] < ub[[p]] && is.infinite(lb[[p]]) && is.infinite(ub[[p]])) {
        theta[, i] <- theta_t[, i]
      } else if (
        lb[[p]] < ub[[p]] && is.finite(lb[[p]]) && is.infinite(ub[[p]])
      ) {
        theta[, i] <- exp(theta_t[, i]) + lb[[p]]
      } else if (
        lb[[p]] < ub[[p]] && is.infinite(lb[[p]]) && is.finite(ub[[p]])
      ) {
        theta[, i] <- ub[[p]] - exp(theta_t[, i])
      } else if (
        lb[[p]] < ub[[p]] && is.finite(lb[[p]]) && is.finite(ub[[p]])
      ) {
        theta[, i] <- pnorm(theta_t[, i]) * (ub[[p]] - lb[[p]]) + lb[[p]]
      } else {
        stop(
          "Could not transform parameters, possibly due to invalid lower and/or upper
             prior bounds."
        )
      }
    }
  }

  return(theta)
}

.logJacobian <- function(theta_t, transTypes, lb, ub) {
  ### compute log of Jacobian

  logJ <- matrix(nrow = nrow(theta_t), ncol = ncol(theta_t))
  cn <- stringr::str_sub(colnames(theta_t), 7)

  # Separate the computations for the simplex
  is_simplex_theta <- transTypes == "simplex"
  if (any(is_simplex_theta)) {
    # Select the simplex variables
    simplex_theta <- theta_t[, is_simplex_theta, drop = FALSE]

    # Simplex dimensionality, this is K - 1
    simdim <- ncol(simplex_theta)

    logitz <- simplex_theta -
      matrix(log(simdim:1L), nrow(theta_t), simdim, byrow = TRUE)
    z_k <- exp(logitz) / (1 + exp(logitz))
    x_k <- z_k

    # Sum_x_k is the length of the remaining stick at step k. At the start, the
    # whole stick is still left
    sum_x_k <- matrix(nrow = nrow(theta_t), ncol = simdim)
    sum_x_k[, 1] <- 1

    if (simdim > 1) {
      for (k in 2:simdim) {
        rsx <- rowSums(x_k[, 1:(k - 1), drop = FALSE])
        x_k[, k] <- (1 - rsx) * z_k[, k]
        sum_x_k[, k] <- (1 - rsx)
      }
    }
    logJ[, is_simplex_theta] <- log(z_k) + log(1 - z_k) + log(sum_x_k)
  }

  for (i in seq_len(ncol(theta_t))) {
    p <- cn[i]

    if (transTypes[[p]] == "unbounded") {
      logJ[, i] <- 0
    } else if (transTypes[[p]] == "lower-bounded") {
      logJ[, i] <- theta_t[, i]
    } else if (transTypes[[p]] == "upper-bounded") {
      logJ[, i] <- theta_t[, i]
    } else if (transTypes[[p]] == "double-bounded") {
      logJ[, i] <- log(ub[[p]] - lb[[p]]) + dnorm(theta_t[, i], log = TRUE)
    } else if (transTypes[[p]] == "circular") {
      logJ[, i] <- 0
    }
  }

  return(.rowSums(logJ, m = nrow(logJ), n = ncol(logJ)))
}

.split_matrix <- function(matrix, cores) {
  out <- vector("list", cores)
  borders <- ceiling(seq(from = 0, to = nrow(matrix), length.out = cores + 1))
  for (i in seq_len(cores)) {
    out[[i]] <- matrix[(borders[i] + 1):borders[i + 1], , drop = FALSE]
  }
  out
}

.run.iterative.scheme <- function(
  q11,
  q12,
  q21,
  q22,
  r0,
  tol,
  L,
  method,
  maxiter,
  silent,
  criterion,
  neff,
  use_ess
) {
  ### run iterative updating scheme (using "optimal" bridge function,
  ### see Meng & Wong, 1996)

  if (method == "normal") {
    l1 <- q11 - q12 # log(l)
    l2 <- q21 - q22 # log(ltilde)
  } else if (method == "warp3") {
    l1 <- -log(2) + determinant(L)$modulus + (q11 - q12) # log(l)
    l2 <- -log(2) + determinant(L)$modulus + (q21 - q22) # log(ltilde)
  }
  ## for dbugging:
  # save(
  #   l1, l2,
  #   r0, tol, L,
  #   method, maxiter, silent,
  #   criterion, neff,
  #   file = "iterative_scheme.rda"
  # )

  lstar <- median(l1)
  n.1 <- length(l1)
  n.2 <- length(l2)
  s1 <- neff / (neff + n.2)
  s2 <- n.2 / (neff + n.2)
  r <- r0
  r_vals <- r
  logml <- log(r) + lstar
  logml_vals <- logml
  criterion_val <- 1 + tol

  e <- as.brob(exp(1))
  i <- 1

  while (i <= maxiter && criterion_val > tol) {
    if (!silent) {
      cat(paste0("Iteration: ", i, "\n"))
    }

    rold <- r
    logmlold <- logml
    numi <- e^(l2 - lstar) / (s1 * e^(l2 - lstar) + s2 * r)
    deni <- 1 / (s1 * e^(l1 - lstar) + s2 * r)

    if (
      any(is.infinite(as.numeric(numi))) ||
        any(is.infinite(as.numeric((deni))))
    ) {
      warning(
        "Infinite value in iterative scheme, returning NA.\n Try rerunning with more samples.",
        call. = FALSE
      )
      return(list(logml = NA, niter = i, mcse_logml = NA_real_))
    }
    mean_numi <- mean(as.numeric(numi))
    mean_deni <- mean(as.numeric(deni))
    var_numi <- var(as.numeric(numi))
    if (use_ess) {
      var_deni <- tryCatch(
        var(as.numeric(deni)) *
          length(deni) /
          mean(coda::effectiveSize(as.numeric(deni))),
        error = function(e) {
          warning(
            "effective sample size calculation failed in iterative's scheme uncertainty calculation",
            call. = FALSE
          )
          return(var(as.numeric(deni)))
        }
      )
    } else {
      var_deni <- var(as.numeric(deni))
    }
    r <- mean_numi / mean_deni
    r_vals <- c(r_vals, r)
    logml <- log(r) + lstar
    logml_vals <- c(logml_vals, logml)
    criterion_val <- switch(
      criterion,
      "r" = abs((r - rold) / r),
      "logml" = abs((logml - logmlold) / logml)
    )
    i <- i + 1
    var_r <- (mean_numi^2) /
      (mean_deni^2) *
      (var_numi / (mean_numi)^2 + var_deni / mean_deni^2)
    var_r <- var_r / length(numi)

    ## Compute variance in log scale by match the variance of a
    ## log-normal approximation
    ## https://en.wikipedia.org/wiki/Log-normal_distribution#Arithmetic_moments
    var_logml <- log(1 + var_r / r^2)
    mcse_logml <- sqrt(var_logml)
  }

  if (i >= maxiter) {
    return(list(
      logml = NA,
      niter = i - 1,
      r_vals = r_vals,
      mcse_logml = mcse_logml
    ))
  }

  return(list(logml = logml, niter = i - 1, mcse_logml = mcse_logml))
}

context("Iterative scheme MCSE calculations")

test_that("MCSE is finite, positive, and returned for normal method", {
  skip_if_not_installed("Brobdingnag")

  # Minimal deterministic inputs
  q11 <- c(0.10, 0.20, 0.30, 0.40)
  q12 <- c(0.02, 0.09, 0.10, 0.15)
  q21 <- c(0.05, 0.18, 0.22, 0.28)
  q22 <- c(0.01, 0.07, 0.11, 0.12)

  L <- diag(2)
  out <- .run.iterative.scheme(
    q11 = q11,
    q12 = q12,
    q21 = q21,
    q22 = q22,
    r0 = 1,
    tol = 1e-10,
    L = L,
    method = "normal",
    maxiter = 1000,
    silent = TRUE,
    criterion = "r",
    neff = length(q11),
    use_ess = FALSE
  )

  expect_type(out, "list")
  expect_true(is.finite(out$mcse_logml))
  expect_gt(out$mcse_logml, 0)
  # Deterministic value checks for the toy example
  expect_equal(out$logml, 0.13248979618200290, tolerance = 1e-12)
  expect_equal(out$mcse_logml, 0.02353233284705807, tolerance = 1e-12)
})

test_that("MCSE is invariant to constant shifts (warp3 vs normal)", {
  skip_if_not_installed("Brobdingnag")

  # Same base inputs as above
  q11 <- c(0.10, 0.20, 0.30, 0.40)
  q12 <- c(0.02, 0.09, 0.10, 0.15)
  q21 <- c(0.05, 0.18, 0.22, 0.28)
  q22 <- c(0.01, 0.07, 0.11, 0.12)

  L <- diag(2)

  out_normal <- .run.iterative.scheme(
    q11 = q11,
    q12 = q12,
    q21 = q21,
    q22 = q22,
    r0 = 1,
    tol = 1e-10,
    L = L,
    method = "normal",
    maxiter = 1000,
    silent = TRUE,
    criterion = "r",
    neff = length(q11),
    use_ess = FALSE
  )

  out_warp3 <- .run.iterative.scheme(
    q11 = q11,
    q12 = q12,
    q21 = q21,
    q22 = q22,
    r0 = 1,
    tol = 1e-10,
    L = L,
    method = "warp3",
    maxiter = 1000,
    silent = TRUE,
    criterion = "r",
    neff = length(q11),
    use_ess = FALSE
  )

  # warp3 adds a constant to both l1 and l2 and shifts l*, the e^(l - l*) terms are invariant
  expect_equal(out_warp3$mcse_logml, out_normal$mcse_logml, tolerance = 1e-10)
})

test_that("MCSE roughly scales like 1/sqrt(n)", {
  skip_if_not_installed("Brobdingnag")

  base_q11 <- c(0.10, 0.20, 0.30, 0.40)
  base_q12 <- c(0.02, 0.09, 0.10, 0.15)
  base_q21 <- c(0.05, 0.18, 0.22, 0.28)
  base_q22 <- c(0.01, 0.07, 0.11, 0.12)
  L <- diag(2)

  # n
  out_n <- .run.iterative.scheme(
    q11 = base_q11,
    q12 = base_q12,
    q21 = base_q21,
    q22 = base_q22,
    r0 = 1,
    tol = 1e-10,
    L = L,
    method = "normal",
    maxiter = 1000,
    silent = TRUE,
    criterion = "r",
    neff = length(base_q11),
    use_ess = FALSE
  )

  # 4n (replicate samples 4x)
  k <- 4
  out_4n <- .run.iterative.scheme(
    q11 = rep(base_q11, k),
    q12 = rep(base_q12, k),
    q21 = rep(base_q21, k),
    q22 = rep(base_q22, k),
    r0 = 1,
    tol = 1e-10,
    L = L,
    method = "normal",
    maxiter = 1000,
    silent = TRUE,
    criterion = "r",
    neff = length(base_q11) * k,
    use_ess = FALSE
  )

  # Expect MCSE to drop by ~ 1/sqrt(k)
  expect_lt(out_4n$mcse_logml, out_n$mcse_logml)
  expect_equal(out_4n$mcse_logml, out_n$mcse_logml / sqrt(k), tolerance = 0.05)

  # Deterministic value for the 4x replicated case
  expect_equal(out_4n$mcse_logml, 0.01052514482181162, tolerance = 1e-12)
})

test_that("Function runs with use_ess = TRUE (if posterior installed)", {
  skip_if_not_installed("Brobdingnag")
  # if (!requireNamespace("posterior", quietly = TRUE)) {
  #   skip("posterior not installed")
  # } ## uses coda currently

  q11 <- c(0.10, 0.20, 0.30, 0.40, 0.45, 0.5)
  q12 <- c(0.02, 0.09, 0.10, 0.15, 0.18, 0.2)
  q21 <- c(0.05, 0.18, 0.22, 0.28, 0.30, 0.35)
  q22 <- c(0.01, 0.07, 0.11, 0.12, 0.14, 0.15)
  L <- diag(2)

  out <- .run.iterative.scheme(
    q11 = q11,
    q12 = q12,
    q21 = q21,
    q22 = q22,
    r0 = 1,
    tol = 1e-10,
    L = L,
    method = "normal",
    maxiter = 1000,
    silent = TRUE,
    criterion = "r",
    neff = length(q11),
    use_ess = TRUE
  )

  expect_true(is.finite(out$mcse_logml))
  expect_gt(out$mcse_logml, 0)
})

#' Turtles Data from Janzen, Tucker, and Paukstis (2000)
#'
#' This data set contains information about 244 newborn turtles from 31
#' different clutches. For each turtle, the data set includes information about
#' survival status (column \code{y}; 0 = died, 1 = survived), birth weight in
#' grams (column \code{x}), and clutch (family) membership (column
#' \code{clutch}; an integer between one and 31). The clutches have been ordered
#' according to mean birth weight.
#'
#' @docType data
#' @keywords dataset
#' @name turtles
#' @usage turtles
#' @format A data.frame with 244 rows and 3 variables.
#' @source Janzen, F. J., Tucker,  J. K., & Paukstis, G. L. (2000). Experimental
#'   analysis of an early life-history stage: Selection on size of hatchling
#'   turtles. \emph{Ecology, 81(8)}, 2290-2304.
#'   \doi{10.2307/177115}
#'
#'   Overstall, A. M., & Forster, J. J. (2010). Default Bayesian model
#'   determination methods for generalised linear mixed models.
#'   \emph{Computational Statistics & Data Analysis, 54}, 3269-3288.
#'   \doi{10.1016/j.csda.2010.03.008}
#'
#'   Sinharay, S., & Stern, H. S. (2005). An empirical comparison of methods for
#'   computing Bayes factors in generalized linear mixed models. \emph{Journal
#'   of Computational and Graphical Statistics, 14(2)}, 415-435.
#'   \doi{10.1198/106186005X47471}
#' @encoding UTF-8
#'
#' @example examples/example.turtles.R
NULL

#' Computes error measures for estimated marginal likelihood.
#' @export
#' @title Error Measures for Estimated Marginal Likelihood
#' @param bridge_object an object of class \code{"bridge"} or \code{"bridge_list"} as returned from \code{\link{bridge_sampler}}.
#' @param na.rm a logical indicating whether missing values in logml estimates should be removed.  Ignored for the \code{bridge} method.
#' @param ... additional arguments (currently ignored).
#' @details Computes error measures for marginal likelihood bridge sampling estimates. The approximate errors for a \code{bridge_object} of class \code{"bridge"} that has been obtained with \code{method = "normal"} and \code{repetitions = 1} are based on Fruehwirth-Schnatter (2004).
#' Not applicable in case the object of class \code{"bridge"} has been obtained with \code{method = "warp3"} and \code{repetitions = 1}.
#' To assess the uncertainty of the estimate in this case, it is recommended to run the \code{"warp3"} procedure multiple times.
#' @return If \code{bridge_object} is of class \code{"bridge"} and has been obtained with \code{method = "normal"} and \code{repetitions = 1}, returns a list with components:
#' \itemize{
#'  \item \code{re2}: approximate relative mean-squared error for marginal likelihood estimate.
#'  \item \code{cv}: approximate coefficient of variation for marginal likelihood estimate (assumes that bridge estimate is unbiased).
#'  \item \code{percentage}: approximate percentage error of marginal likelihood estimate.
#' }
#' If \code{bridge_object} is of class \code{"bridge_list"}, returns a list with components:
#' \itemize{
#'  \item \code{min}: minimum of the log marginal likelihood estimates.
#'  \item \code{max}: maximum of the log marginal likelihood estimates.
#'  \item \code{IQR}: interquartile range of the log marginal likelihood estimates.
#' }
#' @author Quentin F. Gronau
#' @note For examples, see \code{\link{bridge_sampler}} and the accompanying vignettes: \cr \code{vignette("bridgesampling_example_jags")} \cr \code{vignette("bridgesampling_example_stan")}
#'
#' @seealso The \code{summary} methods for \code{bridge} and \code{bridge_list} objects automatically invoke this function, see \code{\link{bridge-methods}}.
#'
#' @references
#' Fruehwirth-Schnatter, S. (2004). Estimating marginal likelihoods for mixture and Markov switching models using bridge sampling techniques. \emph{The Econometrics Journal, 7}, 143-167. \doi{10.1111/j.1368-423X.2004.00125.x}
#' @import Brobdingnag
#' @importFrom coda spectrum0.ar
#' @export
error_measures <- function(bridge_object, ...) {
  UseMethod("error_measures", bridge_object)
}

#' @rdname error_measures
#' @export
error_measures.bridge <- function(bridge_object, ...) {
  if (bridge_object$method == "warp3") {
    stop(paste0(
      "error_measures not implemented for warp3 method with",
      "\n  repetitions = 1.",
      "\n  We recommend to run the warp3 procedure multiple times",
      "\n  to assess the uncertainty of the estimate."
    ))
  }

  e <- as.brob(exp(1))

  ml <- e^(bridge_object$logml)
  g_p <- e^(bridge_object$q12)
  g_g <- e^(bridge_object$q22)
  priorTimesLik_p <- e^(bridge_object$q11)
  priorTimesLik_g <- e^(bridge_object$q21)
  p_p <- priorTimesLik_p / ml
  p_g <- priorTimesLik_g / ml

  N1 <- length(p_p)
  N2 <- length(g_g)
  s1 <- N1 / (N1 + N2)
  s2 <- N2 / (N1 + N2)

  f1 <- as.numeric(p_g / (s1 * p_g + s2 * g_g))
  f2 <- as.numeric(g_p / (s1 * p_p + s2 * g_p))
  rho_f2 <- spectrum0.ar(f2)$spec

  term1 <- 1 / N2 * var(f1) / mean(f1)^2
  term2 <- rho_f2 / N1 * var(f2) / mean(f2)^2

  re2 <- term1 + term2

  # convert to coefficient of variation (assumes that bridge estimate is unbiased)
  cv <- sqrt(re2)

  # convert to percentage error
  percentage <- scales::percent(cv)
  return(list(re2 = re2, cv = cv, percentage = percentage))
}

#' @rdname error_measures
#' @export
error_measures.bridge_list <- function(bridge_object, na.rm = TRUE, ...) {
  return(list(
    min = min(bridge_object$logml, na.rm = na.rm),
    max = max(bridge_object$logml, na.rm = na.rm),
    IQR = stats::IQR(bridge_object$logml, na.rm = na.rm)
  ))
}

---
title: "Hierarchical Normal Example (JAGS)"
author: "Quentin F. Gronau"
date: "`r Sys.Date()`"
show_toc: true
output:
  knitr:::html_vignette:
    toc: yes
vignette: >
  %\VignetteIndexEntry{Hierarchical Normal Example JAGS}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

In this vignette, we explain how one can compute marginal likelihoods, Bayes factors, and posterior model probabilities using a simple hierarchical normal model implemented in `JAGS`. This vignette uses the same models and data as the [`Stan` vignette](bridgesampling_example_stan.html).

## Model and Data
The model that we will use assumes that each of the $n$ observations $y_i$ (where $i$ indexes the observation, $i = 1,2,...,n$) is normally distributed with corresponding mean $\theta_i$ and a common known variance $\sigma^2$: $y_i \sim \mathcal{N}(\theta_i, \sigma^2)$. Each $\theta_i$ is drawn from a normal group-level distribution with mean $\mu$ and variance $\tau^2$: $\theta_i \sim \mathcal{N}(\mu, \tau^2)$. For the group-level mean $\mu$, we use a normal prior distribution of the form $\mathcal{N}(\mu_0, \tau^2_0)$. For the group-level variance $\tau^2$, we use an inverse-gamma prior of the form $\text{Inv-Gamma}(\alpha, \beta)$. We will use `JAGS` to fit the model which parametrizes the normal distribution in terms of the precision (i.e., one over the variance). Consequently, we implement this inverse-gamma prior on $\tau^2$ by placing a gamma prior of the form $\text{Gamma}(\alpha, \beta)$ on the precision; we call this precision parameter `invTau2` in the code.

In this example, we are interested in comparing the null model $\mathcal{H}_0$, which posits that the group-level mean $\mu = 0$, to the alternative model $\mathcal{H}_1$, which allows $\mu$ to be different from zero. First, we generate some data from the null model:

```{r}
library(bridgesampling)

### generate data ###
set.seed(12345)

mu <- 0
tau2 <- 0.5
sigma2 <- 1

n <- 20
theta <- rnorm(n, mu, sqrt(tau2))
y <- rnorm(n, theta, sqrt(sigma2))
  
```

Next, we specify the prior parameters $\mu_0$, $\tau^2_0$, $\alpha$, and $\beta$:

```{r,eval=FALSE}
### set prior parameters ###
mu0 <- 0
tau20 <- 1
alpha <- 1
beta <- 1
```

## Fitting the Models
Now we can fit the null and the alternative model in `JAGS` (note that it is necessary to install `JAGS` for this). One usually requires a larger number of posterior sample for estimating the marginal likelihood than for simply estimating the model parameters. This is the reason for using a comparatively large number of samples (i.e., 50,000 post burn-in samples per chain) for this comparatively simple model.
```{r, eval=FALSE}
library(R2jags)

### functions to get posterior samples ###

# H0: mu = 0
getSamplesModelH0 <- function(data, niter = 52000, nburnin = 2000, nchains = 3) {
  
  model <- "
    model {
      for (i in 1:n) {
        theta[i] ~ dnorm(0, invTau2)
          y[i] ~ dnorm(theta[i], 1/sigma2)
      }
      invTau2 ~ dgamma(alpha, beta)
      tau2 <- 1/invTau2
    }"
  
  s <- jags(data, parameters.to.save = c("theta", "invTau2"),
            model.file = textConnection(model),
            n.chains = nchains, n.iter = niter,
            n.burnin = nburnin, n.thin = 1)
  
  return(s)
  
}

# H1: mu != 0
getSamplesModelH1 <- function(data, niter = 52000, nburnin = 2000,
                              nchains = 3) {
  
  model <- "
    model {
      for (i in 1:n) {
        theta[i] ~ dnorm(mu, invTau2)
        y[i] ~ dnorm(theta[i], 1/sigma2)
      }
      mu ~ dnorm(mu0, 1/tau20)
      invTau2 ~ dgamma(alpha, beta)
      tau2 <- 1/invTau2
    }"
  
  s <- jags(data, parameters.to.save = c("theta", "mu", "invTau2"),
            model.file = textConnection(model),
            n.chains = nchains, n.iter = niter,
            n.burnin = nburnin, n.thin = 1)
  
  return(s)
  
}

### get posterior samples ###

# create data lists for JAGS
data_H0 <- list(y = y, n = length(y), alpha = alpha, beta = beta, sigma2 = sigma2)
data_H1 <- list(y = y, n = length(y), mu0 = mu0, tau20 = tau20, alpha = alpha,
                beta = beta, sigma2 = sigma2)

# fit models
samples_H0 <- getSamplesModelH0(data_H0)
samples_H1 <- getSamplesModelH1(data_H1)

```

## Specifying the Unnormalized Log Posterior Function
The next step is to write the corresponding `log_posterior` (i.e., unnormalized posterior) function for both models.
This function takes one draw from the joint posterior and the data object as input and returns the log of the unnormalized joint posterior density.
When using MCMC software such as `JAGS` or `Stan`, specifying this function is relatively simple. As a rule of thumb, one only needs to look for all places where a "`~`" sign appears in the model code.
The log of the densities on the right-hand side of these "`~`" symbols needs to be evaluated for the relevant quantities and then these log densities values are summed.

For example, in the null model, there are three "`~`" signs. Starting at the data-level, we need to evaluate the log of the normal density with mean $\theta_i$ and variance $\sigma^2$ for all $y_i$ and then sum the resulting log density values. Next, we move one step up in the model and evaluate the log of the group-level density for all $\theta_i$. Hence, we evaluate the log of the normal density for $\theta_i$ with mean $\mu = 0$ and variance $\tau^2$ (remember that `JAGS` parametrizes the normal distribution in terms of the precision `invTau2` = $1/\tau^2$; in contrast, `R` parametrizes it in terms of the standard deviation) and sum the resulting log density values. The result of this summation is added to the result of the previous summation for the data-level normal distribution. Finally, we need to evaluate the log of the prior density for `invTau2`. This means that we compute the log density of the gamma distribution with parameters $\alpha$ and $\beta$ for the sampled `invTau2` value and add the resulting log density value to the result of summing the data-level and group-level log densities. The unnormalized log posterior for the alternative model can be obtained in a similar fashion. The resulting functions look as follows:
```{r,eval=FALSE}
### functions for evaluating the unnormalized posteriors on log scale ###

log_posterior_H0 <- function(samples.row, data) {
  
  mu <- 0
  invTau2 <- samples.row[[ "invTau2" ]]
  theta <- samples.row[ paste0("theta[", seq_along(data$y), "]") ]
  
  sum(dnorm(data$y, theta, data$sigma2, log = TRUE)) +
    sum(dnorm(theta, mu, 1/sqrt(invTau2), log = TRUE)) +
    dgamma(invTau2, data$alpha, data$beta, log = TRUE)
  
}

log_posterior_H1 <- function(samples.row, data) {
  
  mu <- samples.row[[ "mu" ]]
  invTau2 <- samples.row[[ "invTau2" ]]
  theta <- samples.row[ paste0("theta[", seq_along(data$y), "]") ]
  
  sum(dnorm(data$y, theta, data$sigma2, log = TRUE)) +
    sum(dnorm(theta, mu, 1/sqrt(invTau2), log = TRUE)) +
    dnorm(mu, data$mu0, sqrt(data$tau20), log = TRUE) +
    dgamma(invTau2, data$alpha, data$beta, log = TRUE)
  
}
  
```

## Specifying the Parameter Bounds
The final step before computing the log marginal likelihoods is to specify the parameter bounds. In this example, for both models, all parameters can range from $-\infty$ to $\infty$ except the precision `invTau2` which has a lower bound of zero. These boundary vectors need to be named and the names need to match the order of the parameters. 
```{r,eval=FALSE}
# specify parameter bounds H0
cn <- colnames(samples_H0$BUGSoutput$sims.matrix)
cn <- cn[cn != "deviance"]
lb_H0 <- rep(-Inf, length(cn))
ub_H0 <- rep(Inf, length(cn))
names(lb_H0) <- names(ub_H0) <- cn
lb_H0[[ "invTau2" ]] <- 0

# specify parameter bounds H1
cn <- colnames(samples_H1$BUGSoutput$sims.matrix)
cn <- cn[cn != "deviance"]
lb_H1 <- rep(-Inf, length(cn))
ub_H1 <- rep(Inf, length(cn))
names(lb_H1) <- names(ub_H1) <- cn
lb_H1[[ "invTau2" ]] <- 0
```
Note that currently, the lower and upper bound of a parameter cannot be a function of the bounds of another parameter. Furthermore, constraints that depend on multiple parameters of the model are not supported. This excludes, for example, parameters that constitute a covariance matrix or sets of parameters that need to sum to one.

## Computing the (Log) Marginal Likelihoods
Now we are ready to compute the log marginal likelihoods using the `bridge_sampler` function. We use `silent = TRUE` to suppress printing the number of iterations to the console:
```{r, echo=FALSE}
load(system.file("extdata/", "vignette_example_jags.RData",
                     package = "bridgesampling"))
```

```{r,eval=FALSE}
# compute log marginal likelihood via bridge sampling for H0
H0.bridge <- bridge_sampler(samples = samples_H0, data = data_H0,
                            log_posterior = log_posterior_H0, lb = lb_H0,
                            ub = ub_H0, silent = TRUE)

# compute log marginal likelihood via bridge sampling for H1
H1.bridge <- bridge_sampler(samples = samples_H1, data = data_H1,
                            log_posterior = log_posterior_H1, lb = lb_H1,
                            ub = ub_H1, silent = TRUE)
```
We obtain:
```{r}
print(H0.bridge)
print(H1.bridge)
```
We can use the `error_measures` function to compute an approximate percentage error of the estimates:
```{r,eval=FALSE}
# compute percentage errors
H0.error <- error_measures(H0.bridge)$percentage
H1.error <- error_measures(H1.bridge)$percentage
```
We obtain:
```{r}
print(H0.error)
print(H1.error)
```
## Bayesian Model Comparison
To compare the null model and the alternative model, we can compute the Bayes factor by using the `bf` function.
In our case, we compute $\text{BF}_{01}$, that is, the Bayes factor which quantifies how much more likely the data are under the null versus the alternative model:
```{r}
# compute Bayes factor
BF01 <- bf(H0.bridge, H1.bridge)
print(BF01)
```
In this case, the Bayes factor is close to one, indicating that there is not much evidence for either model. We can also compute posterior model probabilities by using the `post_prob` function:
```{r}
# compute posterior model probabilities (assuming equal prior model probabilities)
post1 <- post_prob(H0.bridge, H1.bridge)
print(post1)
```
When the argument `prior_prob` is not specified, as is the case here, the prior model probabilities of all models under consideration are set equal (i.e., in this case with two models to 0.5). However, if we had prior knowledge about how likely both models are, we could use the `prior_prob` argument to specify different prior model probabilities:
```{r}
# compute posterior model probabilities (using user-specified prior model probabilities)
post2 <- post_prob(H0.bridge, H1.bridge, prior_prob = c(.6, .4))
print(post2)
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bridge_methods.R
\name{bridge-methods}
\alias{bridge-methods}
\alias{summary.bridge}
\alias{summary.bridge_list}
\alias{print.summary.bridge}
\alias{print.summary.bridge_list}
\alias{print.bridge}
\alias{print.bridge_list}
\title{Methods for bridge and bridge_list objects}
\usage{
\method{summary}{bridge}(object, na.rm = TRUE, ...)

\method{summary}{bridge_list}(object, na.rm = TRUE, ...)

\method{print}{summary.bridge}(x, ...)

\method{print}{summary.bridge_list}(x, ...)

\method{print}{bridge}(x, ...)

\method{print}{bridge_list}(x, na.rm = TRUE, ...)
}
\arguments{
\item{object, x}{object of class \code{bridge} or \code{bridge_list} as returned from \code{\link{bridge_sampler}}.}

\item{na.rm}{logical. Should NA estimates in \code{bridge_list} objects be removed? Passed to \code{\link{error_measures}}.}

\item{...}{further arguments, currently ignored.}
}
\value{
The \code{summary} methods return a \code{data.frame} which contains the log marginal likelihood plus the result returned from invoking \code{\link{error_measures}}.

The \code{print} methods simply print and return nothing.
}
\description{
Methods defined for objects returned from the generic \code{\link{bridge_sampler}} function.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/logml.R
\name{logml}
\alias{logml}
\alias{logml.bridge}
\alias{logml.bridge_list}
\title{Log Marginal Likelihoods from Bridge Objects}
\usage{
logml(x, ...)

\method{logml}{bridge}(x, ...)

\method{logml}{bridge_list}(x, fun = median, ...)
}
\arguments{
\item{x}{Object of class \code{"bridge"} or \code{"bridge_list"} as returned from \code{\link{bridge_sampler}}.}

\item{...}{Further arguments passed to \code{fun}.}

\item{fun}{Function which returns a scalar value and is applied to the \code{logml} vector of \code{"bridge_list"} objects. Default is \code{\link{median}}.}
}
\value{
scalar numeric
}
\description{
Generic function that returns log marginal likelihood from bridge objects. For objects of class \code{"bridge_list"}, which contains multiple log marginal likelihoods, \code{fun} is performed on the vector and its result returned.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/post_prob.R
\name{post_prob}
\alias{post_prob}
\alias{post_prob.bridge}
\alias{post_prob.bridge_list}
\alias{post_prob.default}
\title{Posterior Model Probabilities from Marginal Likelihoods}
\usage{
post_prob(x, ..., prior_prob = NULL, model_names = NULL)

\method{post_prob}{bridge}(x, ..., prior_prob = NULL, model_names = NULL)

\method{post_prob}{bridge_list}(x, ..., prior_prob = NULL, model_names = NULL)

\method{post_prob}{default}(x, ..., prior_prob = NULL, model_names = NULL)
}
\arguments{
\item{x}{Object of class \code{"bridge"} or \code{"bridge_list"} as returned
from \code{\link{bridge_sampler}}. Additionally, the default method assumes
that all passed objects are numeric log marginal likelihoods (e.g., from
\code{\link{logml}}) and will throw an error otherwise.}

\item{...}{further objects of class \code{"bridge"} or \code{"bridge_list"}
as returned from \code{\link{bridge_sampler}}. Or numeric values for the
default method.}

\item{prior_prob}{numeric vector with prior model probabilities. If omitted,
a uniform prior is used (i.e., all models are equally likely a priori). The
default \code{NULL} corresponds to equal prior model weights.}

\item{model_names}{If \code{NULL} (the default) will use model names derived
from deparsing the call. Otherwise will use the passed values as model
names.}
}
\value{
For the default method and the method for \code{"bridge"} objects, a
  named numeric vector with posterior model probabilities (i.e., which sum to
  one).

  For the method for \code{"bridge_list"} objects, a matrix consisting of
  posterior model probabilities where each row sums to one and gives the
  model probabilities for one set of logmls. The (named) columns correspond
  to the models and the number of rows is given by the \code{"bridge_list"}
  element with the most \code{repetitions}. Elements with fewer repetitions
  will be recycled (with warning).
}
\description{
Generic function that computes posterior model probabilities from marginal
likelihoods.
}
\note{
For realistic examples, see \code{\link{bridge_sampler}} and the
  accompanying vignettes: \cr \code{vignette("bridgesampling_example_jags")}
  \cr \code{vignette("bridgesampling_example_stan")}
}
\examples{

H0 <- structure(list(logml = -20.8084543022433, niter = 4, method = "normal"),
                .Names = c("logml", "niter", "method"), class = "bridge")
H1 <- structure(list(logml = -17.9623077558729, niter = 4, method = "normal"),
                .Names = c("logml", "niter", "method"), class = "bridge")
H2 <- structure(list(logml = -19, niter = 4, method = "normal"),
                .Names = c("logml", "niter", "method"), class = "bridge")


post_prob(H0, H1, H2)
post_prob(H1, H0)

## all produce the same (only names differ):
post_prob(H0, H1, H2)
post_prob(H0$logml, H1$logml, H2$logml)
post_prob(c(H0$logml, H1$logml, H2$logml))
post_prob(H0$logml, c(H1$logml, H2$logml))
post_prob(H0$logml, c(H1$logml, H2$logml), model_names = c("H0", "H1", "H2"))


### with bridge list elements:
H0L <- structure(list(logml = c(-20.8088381186739, -20.8072772698116,
-20.808454454621, -20.8083419072281, -20.8087870541247, -20.8084887398113,
-20.8086023582344, -20.8079083169745, -20.8083048489095, -20.8090050811436
), niter = c(4, 4, 4, 4, 4, 4, 4, 4, 4, 4), method = "normal",
    repetitions = 10), .Names = c("logml", "niter", "method",
"repetitions"), class = "bridge_list")

H1L <- structure(list(logml = c(-17.961665507006, -17.9611290723151,
-17.9607509604499, -17.9608629535992, -17.9602093576442, -17.9600223300432,
-17.9610157118017, -17.9615557696561, -17.9608437034849, -17.9606743200309
), niter = c(4, 4, 4, 4, 4, 4, 4, 4, 3, 4), method = "normal",
    repetitions = 10), .Names = c("logml", "niter", "method",
"repetitions"), class = "bridge_list")

post_prob(H1L, H0L)
post_prob(H1L, H0L, H0) # last element recycled with warning.

}
\author{
Quentin F. Gronau and Henrik Singmann
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/turtles-data.R
\docType{data}
\encoding{UTF-8}
\name{turtles}
\alias{turtles}
\title{Turtles Data from Janzen, Tucker, and Paukstis (2000)}
\format{
A data.frame with 244 rows and 3 variables.
}
\source{
Janzen, F. J., Tucker,  J. K., & Paukstis, G. L. (2000). Experimental
  analysis of an early life-history stage: Selection on size of hatchling
  turtles. \emph{Ecology, 81(8)}, 2290-2304.
  \doi{10.2307/177115}

  Overstall, A. M., & Forster, J. J. (2010). Default Bayesian model
  determination methods for generalised linear mixed models.
  \emph{Computational Statistics & Data Analysis, 54}, 3269-3288.
  \doi{10.1016/j.csda.2010.03.008}

  Sinharay, S., & Stern, H. S. (2005). An empirical comparison of methods for
  computing Bayes factors in generalized linear mixed models. \emph{Journal
  of Computational and Graphical Statistics, 14(2)}, 415-435.
  \doi{10.1198/106186005X47471}
}
\usage{
turtles
}
\description{
This data set contains information about 244 newborn turtles from 31
different clutches. For each turtle, the data set includes information about
survival status (column \code{y}; 0 = died, 1 = survived), birth weight in
grams (column \code{x}), and clutch (family) membership (column
\code{clutch}; an integer between one and 31). The clutches have been ordered
according to mean birth weight.
}
\examples{

\dontrun{

################################################################################
# BAYESIAN GENERALIZED LINEAR MIXED MODEL (PROBIT REGRESSION)
################################################################################

library(bridgesampling)
library(rstan)

data("turtles")

#-------------------------------------------------------------------------------
# plot data
#-------------------------------------------------------------------------------

# reproduce Figure 1 from Sinharay & Stern (2005)
xticks <- pretty(turtles$clutch)
yticks <- pretty(turtles$x)

plot(1, type = "n", axes = FALSE, ylab = "", xlab = "", xlim = range(xticks),
     ylim =  range(yticks))
points(turtles$clutch, turtles$x, pch = ifelse(turtles$y, 21, 4), cex = 1.3,
       col = ifelse(turtles$y, "black", "darkred"), bg = "grey", lwd = 1.3)
axis(1, cex.axis = 1.4)
mtext("Clutch Identifier", side = 1, line = 2.9, cex = 1.8)
axis(2, las = 1, cex.axis = 1.4)
mtext("Birth Weight (Grams)", side = 2, line = 2.6, cex = 1.8)

#-------------------------------------------------------------------------------
# Analysis: Natural Selection Study (compute same BF as Sinharay & Stern, 2005)
#-------------------------------------------------------------------------------

### H0 (model without random intercepts) ###
H0_code <-
"data {
  int<lower = 1> N;
  int<lower = 0, upper = 1> y[N];
  real<lower = 0> x[N];
}
parameters {
  real alpha0_raw;
  real alpha1_raw;
}
transformed parameters {
  real alpha0 = sqrt(10.0) * alpha0_raw;
  real alpha1 = sqrt(10.0) * alpha1_raw;
}
model {
  // priors
  target += normal_lpdf(alpha0_raw | 0, 1);
  target += normal_lpdf(alpha1_raw | 0, 1);

  // likelihood
  for (i in 1:N) {
    target += bernoulli_lpmf(y[i] | Phi(alpha0 + alpha1 * x[i]));
  }
}"

### H1 (model with random intercepts) ###
H1_code <-
"data {
  int<lower = 1> N;
  int<lower = 0, upper = 1> y[N];
  real<lower = 0> x[N];
  int<lower = 1> C;
  int<lower = 1, upper = C> clutch[N];
}
parameters {
  real alpha0_raw;
  real alpha1_raw;
  vector[C] b_raw;
  real<lower = 0> sigma2;
}
transformed parameters {
  vector[C] b;
  real<lower = 0> sigma = sqrt(sigma2);
  real alpha0 = sqrt(10.0) * alpha0_raw;
  real alpha1 = sqrt(10.0) * alpha1_raw;
  b = sigma * b_raw;
}
model {
  // priors
  target += - 2 * log(1 + sigma2); // p(sigma2) = 1 / (1 + sigma2) ^ 2
  target += normal_lpdf(alpha0_raw | 0, 1);
  target += normal_lpdf(alpha1_raw | 0, 1);

  // random effects
  target += normal_lpdf(b_raw | 0, 1);

  // likelihood
  for (i in 1:N) {
    target += bernoulli_lpmf(y[i] | Phi(alpha0 + alpha1 * x[i] + b[clutch[i]]));
  }
}"

set.seed(1)
### fit models ###
stanfit_H0 <- stan(model_code = H0_code,
                   data = list(y = turtles$y, x = turtles$x, N = nrow(turtles)),
                   iter = 15500, warmup = 500, chains = 4, seed = 1)
stanfit_H1 <- stan(model_code = H1_code,
                   data = list(y = turtles$y, x = turtles$x, N = nrow(turtles),
                               C = max(turtles$clutch), clutch = turtles$clutch),
                   iter = 15500, warmup = 500, chains = 4, seed = 1)

set.seed(1)
### compute (log) marginal likelihoods ###
bridge_H0 <- bridge_sampler(stanfit_H0)
bridge_H1 <- bridge_sampler(stanfit_H1)

### compute approximate percentage errors ###
error_measures(bridge_H0)$percentage
error_measures(bridge_H1)$percentage

### summary ###
summary(bridge_H0)
summary(bridge_H1)

### compute Bayes factor ("true" value: BF01 = 1.273) ###
bf(bridge_H0, bridge_H1)

}
}
\keyword{dataset}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ier-data.R
\docType{data}
\encoding{UTF-8}
\name{ier}
\alias{ier}
\title{Standardized International Exchange Rate Changes from 1975 to 1986}
\format{
A matrix with 143 rows and 6 columns.
}
\source{
West, M., Harrison, J. (1997). \emph{Bayesian forecasting and dynamic models} (2nd ed.). Springer-Verlag, New York.

Lopes, H. F., West, M. (2004). Bayesian model assessment in factor analysis. \emph{Statistica Sinica, 14}, 41-67.
}
\usage{
ier
}
\description{
This data set contains the changes in monthly international exchange rates for pounds sterling from January 1975 to December 1986 obtained from West and Harrison (1997, pp. 612-615). Currencies tracked are US Dollar (column \code{us_dollar}), Canadian Dollar (column \code{canadian_dollar}), Japanese Yen (column \code{yen}), French Franc (column \code{franc}), Italian Lira (column \code{lira}), and the (West) German Mark (column \code{mark}). Each series has been standardized with respect to its sample mean and standard deviation.
}
\examples{

\dontrun{

################################################################################
# BAYESIAN FACTOR ANALYSIS (AS PROPOSED BY LOPES & WEST, 2004)
################################################################################

library(bridgesampling)
library(rstan)

cores <- 4
options(mc.cores = cores)

data("ier")

#-------------------------------------------------------------------------------
# plot data
#-------------------------------------------------------------------------------

currency <- colnames(ier)
label <- c("US Dollar", "Canadian Dollar", "Yen", "Franc", "Lira", "Mark")
op <- par(mfrow = c(3, 2), mar = c(6, 6, 3, 3))

for (i in seq_along(currency)) {
  plot(ier[,currency[i]], type = "l", col = "darkblue",  axes = FALSE,
       ylim = c(-4, 4), ylab = "", xlab = "", lwd = 2)
  axis(1, at = 0:12*12, labels = 1975:1987, cex.axis = 1.7)
  axis(2, at = pretty(c(-4, 4)), las = 1, cex.axis = 1.7)
  mtext("Year", 1, cex = 1.5, line = 3.2)
  mtext("Exchange Rate Changes", 2, cex = 1.4, line = 3.2)
  mtext(label[i], 3, cex = 1.6, line = .1)
}

par(op)

#-------------------------------------------------------------------------------
# stan model
#-------------------------------------------------------------------------------

model_code <-
"data {
  int<lower=1> T; // number of observations
  int<lower=1> m; // number of variables
  int<lower=1> k; // number of factors
  matrix[T,m] Y;  // data matrix
}
transformed data {
  int<lower = 1> r;
  vector[m] zeros;
  r = m * k - k * (k - 1) / 2; // number of non-zero factor loadings
  zeros = rep_vector(0.0, m);
}
parameters {
  real beta_lower[r - k];  // lower-diagonal elements of beta
  real<lower = 0> beta_diag [k]; // diagonal elements of beta
  vector<lower = 0>[m] sigma2; // residual variances
}
transformed parameters {
  matrix[m,k] beta;
  cov_matrix[m] Omega;
  // construct lower-triangular factor loadings matrix
  {
    int index_lower = 1;
    for (j in 1:k) {
      for (i in 1:m) {
        if (i == j) {
          beta[j,j] = beta_diag[j];
        } else if (i >= j) {
          beta[i,j] = beta_lower[index_lower];
          index_lower = index_lower + 1;
        } else {
          beta[i,j] = 0.0;
        }
      }
    }
  }
  Omega = beta * beta' + diag_matrix(sigma2);
}
model {
  // priors
  target += normal_lpdf(beta_diag | 0, 1) - k * normal_lccdf(0 | 0, 1);
  target += normal_lpdf(beta_lower | 0, 1);
  target += inv_gamma_lpdf(sigma2 | 2.2 / 2.0, 0.1 / 2.0);

  // likelihood
  for(t in 1:T) {
    target += multi_normal_lpdf(Y[t] | zeros, Omega);
  }
}"

# compile model
model <- stan_model(model_code = model_code)


#-------------------------------------------------------------------------------
# fit models and compute log marginal likelihoods
#-------------------------------------------------------------------------------

# function for generating starting values
init_fun <- function(nchains, k, m) {
  r <- m * k - k * (k - 1) / 2
  out <- vector("list", nchains)
  for (i in seq_len(nchains)) {
    beta_lower <- array(runif(r - k, 0.05, 1), dim = r - k)
    beta_diag <- array(runif(k, .05, 1), dim = k)
    sigma2 <- array(runif(m, .05, 1.5), dim = m)
    out[[i]] <- list(beta_lower = beta_lower,
                     beta_diag = beta_diag,
                     sigma2 = sigma2)
  }
  return(out)
}

set.seed(1)
stanfit <- bridge <- vector("list", 3)
for (k in 1:3) {
  stanfit[[k]] <- sampling(model,
                           data = list(Y = ier, T = nrow(ier),
                                       m = ncol(ier), k = k),
                           iter = 11000, warmup = 1000, chains = 4,
                           init = init_fun(nchains = 4, k = k, m = ncol(ier)),
                           cores = cores, seed = 1)
  bridge[[k]] <- bridge_sampler(stanfit[[k]], method = "warp3",
                                repetitions = 10, cores = cores)
}

# example output
summary(bridge[[2]])

#-------------------------------------------------------------------------------
# compute posterior model probabilities
#-------------------------------------------------------------------------------

pp <- post_prob(bridge[[1]], bridge[[2]], bridge[[3]],
          model_names = c("k = 1", "k = 2", "k = 3"))
pp

op <- par(mar = c(6, 6, 3, 3))
boxplot(pp, axes = FALSE,
     ylim = c(0, 1), ylab = "",
     xlab = "")
axis(1, at = 1:3, labels = colnames(pp), cex.axis = 1.7)
axis(2, cex.axis = 1.1)
mtext("Posterior Model Probability", 2, cex = 1.5, line = 3.2)
mtext("Number of Factors", 1, cex = 1.4, line = 3.2)
par(op)

}
}
\keyword{dataset}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bridge_sampler.R
\name{bridge_sampler}
\alias{bridge_sampler}
\alias{bridge_sampler.CmdStanMCMC}
\alias{bridge_sampler.stanfit}
\alias{bridge_sampler.mcmc.list}
\alias{bridge_sampler.mcmc}
\alias{bridge_sampler.matrix}
\alias{bridge_sampler.stanreg}
\alias{bridge_sampler.rjags}
\alias{bridge_sampler.runjags}
\alias{bridge_sampler.MCMC_refClass}
\title{Log Marginal Likelihood via Bridge Sampling}
\usage{
bridge_sampler(samples, ...)

\method{bridge_sampler}{CmdStanMCMC}(
  samples = NULL,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  maxiter = 1000,
  silent = FALSE,
  verbose = FALSE,
  ...
)

\method{bridge_sampler}{stanfit}(
  samples = NULL,
  stanfit_model = samples,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  maxiter = 1000,
  silent = FALSE,
  verbose = FALSE,
  ...
)

\method{bridge_sampler}{mcmc.list}(
  samples = NULL,
  log_posterior = NULL,
  ...,
  data = NULL,
  lb = NULL,
  ub = NULL,
  repetitions = 1,
  param_types = rep("real", ncol(samples[[1]])),
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  packages = NULL,
  varlist = NULL,
  envir = .GlobalEnv,
  rcppFile = NULL,
  maxiter = 1000,
  silent = FALSE,
  verbose = FALSE
)

\method{bridge_sampler}{mcmc}(
  samples = NULL,
  log_posterior = NULL,
  ...,
  data = NULL,
  lb = NULL,
  ub = NULL,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  packages = NULL,
  varlist = NULL,
  envir = .GlobalEnv,
  rcppFile = NULL,
  maxiter = 1000,
  param_types = rep("real", ncol(samples)),
  silent = FALSE,
  verbose = FALSE
)

\method{bridge_sampler}{matrix}(
  samples = NULL,
  log_posterior = NULL,
  ...,
  data = NULL,
  lb = NULL,
  ub = NULL,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  packages = NULL,
  varlist = NULL,
  envir = .GlobalEnv,
  rcppFile = NULL,
  maxiter = 1000,
  param_types = rep("real", ncol(samples)),
  silent = FALSE,
  verbose = FALSE
)

\method{bridge_sampler}{stanreg}(
  samples,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  maxiter = 1000,
  silent = FALSE,
  verbose = FALSE,
  ...
)

\method{bridge_sampler}{rjags}(
  samples = NULL,
  log_posterior = NULL,
  ...,
  data = NULL,
  lb = NULL,
  ub = NULL,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  packages = NULL,
  varlist = NULL,
  envir = .GlobalEnv,
  rcppFile = NULL,
  maxiter = 1000,
  silent = FALSE,
  verbose = FALSE
)

\method{bridge_sampler}{runjags}(
  samples = NULL,
  log_posterior = NULL,
  ...,
  data = NULL,
  lb = NULL,
  ub = NULL,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  packages = NULL,
  varlist = NULL,
  envir = .GlobalEnv,
  rcppFile = NULL,
  maxiter = 1000,
  silent = FALSE,
  verbose = FALSE
)

\method{bridge_sampler}{MCMC_refClass}(
  samples,
  repetitions = 1,
  method = "normal",
  cores = 1,
  use_neff = TRUE,
  maxiter = 1000,
  silent = FALSE,
  verbose = FALSE,
  ...
)
}
\arguments{
\item{samples}{an \code{mcmc.list} object, a fitted \code{stanfit} object, a
\code{stanreg} object, an \code{rjags} object, a \code{runjags} object, or a
\code{matrix} with posterior samples (\code{colnames} need to correspond to
parameter names in \code{lb} and \code{ub})  with posterior samples.}

\item{...}{additional arguments passed to \code{log_posterior}. Ignored for
the \code{stanfit} and \code{stanreg} methods.}

\item{repetitions}{number of repetitions.}

\item{method}{either \code{"normal"} or \code{"warp3"}.}

\item{cores}{number of cores used for evaluating \code{log_posterior}. On
unix-like systems (where \code{.Platform$OS.type == "unix"} evaluates to
\code{TRUE}; e.g., Linux and Mac OS) forking via \code{\link{mclapply}} is
used. Hence elements needed for evaluation should be in the
\code{\link{.GlobalEnv}}. For other systems (e.g., Windows)
\code{\link{makeCluster}} is used and further arguments specified below will
be used.}

\item{use_neff}{Logical. If \code{TRUE}, the effective sample size (compared
to the nominal sample size) is used in the optimal bridge function and in
the iterative scheme's uncertainty calculations (making MCSE computation
take into account autocorrelation in MCMC samples). Default is TRUE. If
FALSE, the nominal sample size  is used instead. If \code{samples} is a
\code{matrix}, it is assumed that the \code{matrix} contains the samples of
one chain in order. If \code{samples} come from more than one chain, we
recommend to use an \code{mcmc.list} object for optimal performance.}

\item{maxiter}{maximum number of iterations for the iterative updating scheme.
Default is 1,000 to avoid infinite loops.}

\item{silent}{Boolean which determines whether to print the number of
iterations of the updating scheme to the console. Default is FALSE.}

\item{verbose}{Boolean. Should internal debug information be printed to
console? Default is \code{FALSE}.}

\item{stanfit_model}{for the \code{stanfit} method, an additional object of
class \code{"stanfit"} with the same model as \code{samples}, which will be
used for evaluating the \code{log_posterior} (i.e., it does not need to
contain any samples). The default is to use \code{samples}. In case
\code{samples} was compiled in a different R session or on another computer
with a different OS or setup, the \code{samples} model usually cannot be
used for evaluation. In this case, one can compile the model on the current
computer with \code{iter = 0} and pass it here (this usually needs to be
done before \code{samples} is loaded).}

\item{log_posterior}{function or name of function that takes a parameter
vector and the \code{data} as input and returns the log of the unnormalized
posterior density (i.e., a scalar value). If the function name is passed,
the function should exist in the \code{.GlobalEnv}. For special behavior if
\code{cores > 1} see \code{Details}.}

\item{data}{data object which is used in \code{log_posterior}.}

\item{lb}{named vector with lower bounds for parameters.}

\item{ub}{named vector with upper bounds for parameters.}

\item{param_types}{character vector of length \code{ncol(samples)} with
\code{"real"}, \code{"simplex"} or \code{"circular"}. For all regular
bounded or unbounded continuous parameters, this should just be
\code{"real"}. However, if there are parameters which lie on a simplex or on
the circle, this should be noted here. Simplex parameters are parameters
which are bounded below by zero and collectively sum to one, such as weights
in a mixture model. For these, the stick-breaking transformation is
performed as described in the Stan reference manual. The circular variables
are given a numerical representation to which the normal distribution is
most likely a good fit. Only possible to use with
\code{bridge_sampler.matrix}.}

\item{packages}{character vector with names of packages needed for evaluating
\code{log_posterior} in parallel (only relevant if \code{cores > 1} and
\code{.Platform$OS.type != "unix"}).}

\item{varlist}{character vector with names of variables needed for evaluating
\code{log_posterior} (only needed if \code{cores > 1}  and
\code{.Platform$OS.type != "unix"} as these objects will be exported to the
nodes). These objects need to exist in \code{envir}.}

\item{envir}{specifies the environment for \code{varlist} (only needed if
\code{cores > 1}  and \code{.Platform$OS.type != "unix"} as these objects
will be exported to the nodes). Default is \code{\link{.GlobalEnv}}.}

\item{rcppFile}{in case \code{cores > 1} and \code{log_posterior} is an
\code{Rcpp} function, \code{rcppFile} specifies the path to the cpp file
(will be compiled on all cores).}
}
\value{
If \code{repetitions = 1}, returns a list of class \code{"bridge"}
 with components:
 \itemize{
   \item \code{logml}: estimate of the log marginal likelihood.
   \item \code{niter}: number of iterations of the iterative
         updating scheme.
   \item \code{method}: bridge sampling method that was used
         to obtain the estimate.
   \item \code{q11}: log posterior evaluations for posterior samples.
   \item \code{q12}: log proposal evaluations for posterior samples.
   \item \code{q21}: log posterior evaluations for samples from the proposal.
   \item \code{q22}: log proposal evaluations for samples from the proposal.
   \item \code{mcse_logml}: Monte Carlo standard error of \code{logml}
         on the log-scale (Micaletto & Vehtari, 2025).
 }
 If \code{repetitions > 1}, returns a list of class \code{"bridge_list"}
 with components:
 \itemize{
   \item \code{logml}: numeric vector of log marginal likelihood estimates.
   \item \code{niter}: numeric vector with the number of iterations of the
         iterative updating scheme for each repetition.
   \item \code{method}: bridge sampling method that was used to obtain
         the estimates.
   \item \code{repetitions}: number of repetitions.
   \item \code{mcse_logml}: numeric vector of Monte Carlo standard errors
         on the log-scale (Micaletto & Vehtari, 2025), one per repetition.
}
}
\description{
Computes log marginal likelihood via bridge sampling.
}
\details{
Bridge sampling is implemented as described in Meng and Wong (1996,
 see equation 4.1) using the "optimal" bridge function. When \code{method =
 "normal"}, the proposal distribution is a multivariate normal distribution
 with mean vector equal to the sample mean vector of \code{samples} and
 covariance matrix equal to the sample covariance matrix of \code{samples}.
 For a recent tutorial on bridge sampling, see Gronau et al. (in press).

 When \code{method = "warp3"}, the proposal distribution is a standard
 multivariate normal distribution and the posterior distribution is "warped"
 (Meng & Schilling, 2002) so that it has the same mean vector, covariance
 matrix, and skew as the samples. \code{method = "warp3"} takes approximately
 twice as long as \code{method = "normal"}.

 Note that for the \code{matrix} method, the lower and upper bound of a
 parameter cannot be a function of the bounds of another parameter.
 Furthermore, constraints that depend on multiple parameters of the model are
 not supported. This usually excludes, for example, parameters that
 constitute a covariance matrix or sets of parameters that need to sum to
 one.

 However, if the retransformations are part of the model itself and the
 \code{log_posterior} accepts parameters on the real line and performs the
 appropriate Jacobian adjustments, such as done for \code{stanfit} and
 \code{stanreg} objects, such constraints are obviously possible (i.e., we
 currently do not know of any parameter supported within Stan that does not
 work with the current implementation through a \code{stanfit} object).

 \subsection{Parallel Computation}{ On unix-like systems forking is used via
 \code{\link{mclapply}}. Hence elements needed for evaluation of
 \code{log_posterior} should be in the \code{\link{.GlobalEnv}}.

 On other OSes (e.g., Windows), things can get more complicated. For normal
 parallel computation, the \code{log_posterior} function can be passed as
 both function and function name. If the latter, it needs to exist in the
 environment specified in the \code{envir} argument. For parallel computation
 when using an \code{Rcpp} function, \code{log_posterior} can only be passed
 as the function name (i.e., character). This function needs to result from
 calling \code{sourceCpp} on the file specified in \code{rcppFile}.

 Due to the way \code{rstan} currently works, parallel computations with
 \code{stanfit} and \code{stanreg} objects only work with forking (i.e., NOT
 on Windows). }
}
\note{
To be able to use a \code{stanreg} object for \code{samples}, the user
 crucially needs to have specified the \code{diagnostic_file} when fitting
 the model in \pkg{rstanarm}.
}
\section{Warning}{
 Note that the results depend strongly on the parameter
 priors. Therefore, it is strongly advised to think carefully about the
 priors before calculating marginal likelihoods. For example, the prior
 choices implemented in \pkg{rstanarm} or \pkg{brms} might not be optimal
 from a testing point of view. We recommend to use priors that have been
 chosen from a testing and not a purely estimation perspective.

 Also note that for testing, the number of posterior samples usually needs to
 be substantially larger than for estimation.
}

\examples{
## ------------------------------------------------------------------------
## Example 1: Estimating the Normalizing Constant of a Two-Dimensional
##            Standard Normal Distribution
## ------------------------------------------------------------------------

library(bridgesampling)
library(mvtnorm)

samples <- rmvnorm(1e4, mean = rep(0, 2), sigma = diag(2))
colnames(samples) <- c("x1", "x2")
log_density <- function(samples.row, data) {
  -.5*t(samples.row) \%*\% samples.row
}

lb <- rep(-Inf, 2)
ub <- rep(Inf, 2)
names(lb) <- names(ub) <- colnames(samples)
bridge_result <- bridge_sampler(samples = samples, log_posterior = log_density,
                                data = NULL, lb = lb, ub = ub, silent = TRUE)

# compare to analytical value
analytical <- log(2*pi)
print(cbind(bridge_result$logml, analytical))

\dontrun{

## ------------------------------------------------------------------------
## Example 2: Hierarchical Normal Model
## ------------------------------------------------------------------------

# for a full description of the example, see
vignette("bridgesampling_example_jags")

library(R2jags)

### generate data ###

set.seed(12345)

mu <- 0
tau2 <- 0.5
sigma2 <- 1

n <- 20
theta <- rnorm(n, mu, sqrt(tau2))
y <- rnorm(n, theta, sqrt(sigma2))


### set prior parameters
alpha <- 1
beta <- 1
mu0 <- 0
tau20 <- 1

### functions to get posterior samples ###

### H0: mu = 0

getSamplesModelH0 <- function(data, niter = 52000, nburnin = 2000, nchains = 3) {

  model <- "
    model {
      for (i in 1:n) {
        theta[i] ~ dnorm(0, invTau2)
          y[i] ~ dnorm(theta[i], 1/sigma2)
      }
      invTau2 ~ dgamma(alpha, beta)
      tau2 <- 1/invTau2
    }"

  s <- jags(data, parameters.to.save = c("theta", "invTau2"),
            model.file = textConnection(model),
            n.chains = nchains, n.iter = niter,
            n.burnin = nburnin, n.thin = 1)

  return(s)

}

### H1: mu != 0

getSamplesModelH1 <- function(data, niter = 52000, nburnin = 2000,
                              nchains = 3) {

  model <- "
    model {
      for (i in 1:n) {
        theta[i] ~ dnorm(mu, invTau2)
        y[i] ~ dnorm(theta[i], 1/sigma2)
      }
      mu ~ dnorm(mu0, 1/tau20)
      invTau2 ~ dgamma(alpha, beta)
      tau2 <- 1/invTau2
    }"

  s <- jags(data, parameters.to.save = c("theta", "mu", "invTau2"),
            model.file = textConnection(model),
            n.chains = nchains, n.iter = niter,
            n.burnin = nburnin, n.thin = 1)

  return(s)

}

### get posterior samples ###

# create data lists for Jags
data_H0 <- list(y = y, n = length(y), alpha = alpha, beta = beta, sigma2 = sigma2)
data_H1 <- list(y = y, n = length(y), mu0 = mu0, tau20 = tau20, alpha = alpha,
                beta = beta, sigma2 = sigma2)

# fit models
samples_H0 <- getSamplesModelH0(data_H0)
samples_H1 <- getSamplesModelH1(data_H1)


### functions for evaluating the unnormalized posteriors on log scale ###
log_posterior_H0 <- function(samples.row, data) {

  mu <- 0
  invTau2 <- samples.row[[ "invTau2" ]]
  theta <- samples.row[ paste0("theta[", seq_along(data$y), "]") ]

  sum(dnorm(data$y, theta, data$sigma2, log = TRUE)) +
    sum(dnorm(theta, mu, 1/sqrt(invTau2), log = TRUE)) +
    dgamma(invTau2, data$alpha, data$beta, log = TRUE)

}

log_posterior_H1 <- function(samples.row, data) {

  mu <- samples.row[[ "mu" ]]
  invTau2 <- samples.row[[ "invTau2" ]]
  theta <- samples.row[ paste0("theta[", seq_along(data$y), "]") ]

  sum(dnorm(data$y, theta, data$sigma2, log = TRUE)) +
    sum(dnorm(theta, mu, 1/sqrt(invTau2), log = TRUE)) +
    dnorm(mu, data$mu0, sqrt(data$tau20), log = TRUE) +
    dgamma(invTau2, data$alpha, data$beta, log = TRUE)

}

# specify parameter bounds H0
cn <- colnames(samples_H0$BUGSoutput$sims.matrix)
cn <- cn[cn != "deviance"]
lb_H0 <- rep(-Inf, length(cn))
ub_H0 <- rep(Inf, length(cn))
names(lb_H0) <- names(ub_H0) <- cn
lb_H0[[ "invTau2" ]] <- 0

# specify parameter bounds H1
cn <- colnames(samples_H1$BUGSoutput$sims.matrix)
cn <- cn[cn != "deviance"]
lb_H1 <- rep(-Inf, length(cn))
ub_H1 <- rep(Inf, length(cn))
names(lb_H1) <- names(ub_H1) <- cn
lb_H1[[ "invTau2" ]] <- 0


# compute log marginal likelihood via bridge sampling for H0
H0.bridge <- bridge_sampler(samples = samples_H0, data = data_H0,
                            log_posterior = log_posterior_H0, lb = lb_H0,
                            ub = ub_H0, silent = TRUE)
print(H0.bridge)

# compute log marginal likelihood via bridge sampling for H1
H1.bridge <- bridge_sampler(samples = samples_H1, data = data_H1,
                            log_posterior = log_posterior_H1, lb = lb_H1,
                            ub = ub_H1, silent = TRUE)
print(H1.bridge)

# compute percentage error
print(error_measures(H0.bridge)$percentage)
print(error_measures(H1.bridge)$percentage)

# compute Bayes factor
BF01 <- bf(H0.bridge, H1.bridge)
print(BF01)

# compute posterior model probabilities (assuming equal prior model probabilities)
post1 <- post_prob(H0.bridge, H1.bridge)
print(post1)

# compute posterior model probabilities (using user-specified prior model probabilities)
post2 <- post_prob(H0.bridge, H1.bridge, prior_prob = c(.6, .4))
print(post2)

}

\dontrun{

## ------------------------------------------------------------------------
## Example 3: rstanarm
## ------------------------------------------------------------------------
library(rstanarm)

# N.B.: remember to specify the diagnostic_file

fit_1 <- stan_glm(mpg ~ wt + qsec + am, data = mtcars,
                  chains = 2, cores = 2, iter = 5000,
                  diagnostic_file = file.path(tempdir(), "df.csv"))
bridge_1 <- bridge_sampler(fit_1)
fit_2 <- update(fit_1, formula = . ~ . + cyl)
bridge_2 <- bridge_sampler(fit_2, method = "warp3")
bf(bridge_1, bridge_2)

}

}
\references{
Gronau, Q. F., Singmann, H., & Wagenmakers, E.-J. (2020). bridgesampling: An
 R Package for Estimating Normalizing Constants. \emph{Journal of Statistical
 Software, 92}. \doi{10.18637/jss.v092.i10}

 Gronau, Q. F., Sarafoglou, A., Matzke, D., Ly, A., Boehm, U.,
 Marsman, M., Leslie, D. S., Forster, J. J., Wagenmakers, E.-J., &
 Steingroever, H. (in press). A tutorial on bridge sampling. \emph{Journal of
 Mathematical Psychology}. \url{https://arxiv.org/abs/1703.05984} \cr
 \code{vignette("bridgesampling_tutorial")}

 Gronau, Q. F., Wagenmakers, E.-J., Heck, D. W., & Matzke, D. (2019). A
 Simple Method for Comparing Complex Models: Bayesian Model Comparison for
 Hierarchical Multinomial Processing Tree Models Using Warp-III Bridge
 Sampling. \emph{Psychometrika}, 84(1), 261–284.
 \doi{10.1007/s11336-018-9648-3}

 Meng, X.-L., & Wong, W. H. (1996). Simulating ratios of normalizing
 constants via a simple identity: A theoretical exploration. \emph{Statistica
 Sinica, 6}, 831-860.
 \url{https://www3.stat.sinica.edu.tw/statistica/j6n4/j6n43/j6n43.htm}

 Meng, X.-L., & Schilling, S. (2002). Warp bridge sampling. \emph{Journal of
 Computational and Graphical Statistics, 11(3)}, 552-586.
 \doi{10.1198/106186002457}

 Micaletto, G., & Vehtari, A. (2025). Monte Carlo standard errors for bridge
 sampling marginal likelihood estimation. \emph{arXiv preprint},
 arXiv:2508.14487. \url{https://arxiv.org/abs/2508.14487}

 Overstall, A. M., & Forster, J. J. (2010). Default Bayesian model
 determination methods for generalised linear mixed models.
 \emph{Computational Statistics & Data Analysis, 54}, 3269-3288.
 \doi{10.1016/j.csda.2010.03.008}
}
\seealso{
\code{\link{bf}} allows the user to calculate Bayes factors and
 \code{\link{post_prob}} allows the user to calculate posterior model
 probabilities from bridge sampling estimates. \code{\link{bridge-methods}}
 lists some additional methods that automatically invoke the
 \code{\link{error_measures}} function.
}
\author{
Quentin F. Gronau and Henrik Singmann. Parallel computing (i.e.,
 \code{cores > 1}) and the \code{stanfit} method use code from \code{rstan}
 by Jiaqing Guo, Jonah Gabry, and Ben Goodrich. Ben Goodrich added the
 \code{stanreg} method. Kees Mulder added methods for simplex and circular
 variables. Giorgio Micaletto and Aki Vehtari added the \code{CmdStanMCMC} method (for \code{cmdstanr}) and calculation of the Monte Carlo Standard Error (MCSE).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/error_measures.R
\name{error_measures}
\alias{error_measures}
\alias{error_measures.bridge}
\alias{error_measures.bridge_list}
\title{Error Measures for Estimated Marginal Likelihood}
\usage{
error_measures(bridge_object, ...)

\method{error_measures}{bridge}(bridge_object, ...)

\method{error_measures}{bridge_list}(bridge_object, na.rm = TRUE, ...)
}
\arguments{
\item{bridge_object}{an object of class \code{"bridge"} or \code{"bridge_list"} as returned from \code{\link{bridge_sampler}}.}

\item{...}{additional arguments (currently ignored).}

\item{na.rm}{a logical indicating whether missing values in logml estimates should be removed.  Ignored for the \code{bridge} method.}
}
\value{
If \code{bridge_object} is of class \code{"bridge"} and has been obtained with \code{method = "normal"} and \code{repetitions = 1}, returns a list with components:
\itemize{
 \item \code{re2}: approximate relative mean-squared error for marginal likelihood estimate.
 \item \code{cv}: approximate coefficient of variation for marginal likelihood estimate (assumes that bridge estimate is unbiased).
 \item \code{percentage}: approximate percentage error of marginal likelihood estimate.
}
If \code{bridge_object} is of class \code{"bridge_list"}, returns a list with components:
\itemize{
 \item \code{min}: minimum of the log marginal likelihood estimates.
 \item \code{max}: maximum of the log marginal likelihood estimates.
 \item \code{IQR}: interquartile range of the log marginal likelihood estimates.
}
}
\description{
Computes error measures for estimated marginal likelihood.
}
\details{
Computes error measures for marginal likelihood bridge sampling estimates. The approximate errors for a \code{bridge_object} of class \code{"bridge"} that has been obtained with \code{method = "normal"} and \code{repetitions = 1} are based on Fruehwirth-Schnatter (2004).
Not applicable in case the object of class \code{"bridge"} has been obtained with \code{method = "warp3"} and \code{repetitions = 1}.
To assess the uncertainty of the estimate in this case, it is recommended to run the \code{"warp3"} procedure multiple times.
}
\note{
For examples, see \code{\link{bridge_sampler}} and the accompanying vignettes: \cr \code{vignette("bridgesampling_example_jags")} \cr \code{vignette("bridgesampling_example_stan")}
}
\references{
Fruehwirth-Schnatter, S. (2004). Estimating marginal likelihoods for mixture and Markov switching models using bridge sampling techniques. \emph{The Econometrics Journal, 7}, 143-167. \doi{10.1111/j.1368-423X.2004.00125.x}
}
\seealso{
The \code{summary} methods for \code{bridge} and \code{bridge_list} objects automatically invoke this function, see \code{\link{bridge-methods}}.
}
\author{
Quentin F. Gronau
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bf.R
\name{bf}
\alias{bf}
\alias{bayes_factor}
\alias{bayes_factor.default}
\alias{bf.bridge}
\alias{bf.bridge_list}
\alias{bf.default}
\title{Bayes Factor(s) from Marginal Likelihoods}
\usage{
bf(x1, x2, log = FALSE, ...)

bayes_factor(x1, x2, log = FALSE, ...)

\method{bayes_factor}{default}(x1, x2, log = FALSE, ...)

\method{bf}{bridge}(x1, x2, log = FALSE, ...)

\method{bf}{bridge_list}(x1, x2, log = FALSE, ...)

\method{bf}{default}(x1, x2, log = FALSE, ...)
}
\arguments{
\item{x1}{Object of class \code{"bridge"} or \code{"bridge_list"} as returned from \code{\link{bridge_sampler}}. Additionally, the default method assumes that \code{x1} is a single numeric log marginal likelihood (e.g., from \code{\link{logml}}) and will throw an error otherwise.}

\item{x2}{Object of class \code{"bridge"} or \code{"bridge_list"} as returned from \code{\link{bridge_sampler}}. Additionally, the default method assumes that \code{x2} is a single numeric log marginal likelihood (e.g., from \code{\link{logml}}) and will throw an error otherwise.}

\item{log}{Boolean. If \code{TRUE}, the function returns the log of the Bayes factor. Default is \code{FALSE}.}

\item{...}{currently not used here, but can be used by other methods.}
}
\value{
For the default method returns a list of class \code{"bf_default"} with components:
\itemize{
 \item \code{bf}: (scalar) value of the Bayes factor in favor of the model associated with \code{x1} over the model associated with \code{x2}.
 \item \code{log}: Boolean which indicates whether \code{bf} corresponds to the log Bayes factor.
}


For the method for \code{"bridge"} objects returns a list of class \code{"bf_bridge"} with components:
\itemize{
 \item \code{bf}:  (scalar) value of the Bayes factor in favor of the model associated with \code{x1} over the model associated with \code{x2}.
 \item \code{log}: Boolean which indicates whether \code{bf} corresponds to the log Bayes factor.
}


For the method for \code{"bridge_list"} objects returns a list of class \code{"bf_bridge_list"} with components:
\itemize{
 \item \code{bf}:  a numeric vector consisting of Bayes factors where each element gives the Bayes factor for one set of logmls in favor of the model associated with \code{x1} over the model associated with \code{x2}. The length of this vector is given by the \code{"bridge_list"} element with the most \code{repetitions}. Elements with fewer repetitions will be recycled (with warning).
 \item \code{bf_median_based}: (scalar) value of the Bayes factor in favor of the model associated with \code{x1} over the model associated with \code{x2} that is based on the median values of the logml estimates.
 \item \code{log}: Boolean which indicates whether \code{bf} corresponds to the log Bayes factor.
}
}
\description{
Generic function that computes Bayes factor(s) from marginal likelihoods. \code{bayes_factor()} is simply an (S3 generic) alias for \code{bf()}.
}
\details{
Computes the Bayes factor (Kass & Raftery, 1995) in favor of the model associated with \code{x1} over the model associated with \code{x2}.
}
\note{
For examples, see \code{\link{bridge_sampler}} and the accompanying vignettes: \cr \code{vignette("bridgesampling_example_jags")} \cr \code{vignette("bridgesampling_example_stan")}
}
\references{
Kass, R. E., & Raftery, A. E. (1995). Bayes factors. \emph{Journal of the American Statistical Association, 90(430)}, 773-795. \doi{10.1080/01621459.1995.10476572}
}
\author{
Quentin F. Gronau
}
